<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for update Chronopay settings.
 *
 * @package PaymentModuleChronopay CC
 * @access  public
 * @author Girin Alexander
 */
class update_chronopay extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_chronopay()
    {
    }

    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_Chronopay_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array(
                          "MODULE_NAME"  => $SessionPost["ModuleName"]
//                         ,"MODULE_DESCR" => $SessionPost["ModuleDescr"]
                         ,"MODULE_PRODUCT_ID" => $SessionPost["ModuleProductId"]
                         ,"MODULE_MD5" => $SessionPost["ModuleMd5"]
                         //,"MODULE_MODE" => $SessionPost["ModuleMode"]
                         //,"MODULE_CART" => $SessionPost["ModuleCart"]
                         ,"MODULE_BILLING_INFO" => $SessionPost["ModuleBillingInfo"]
//                         ,"MODULE_ORDER_STATUS_ID" => $SessionPost["ModuleOrderStatusId"]
                         );
        modApiFunc("Payment_Module_Chronopay_CC", "updateSettings", $Settings);
    }

    function isValidProductId($productId)
    {
        return preg_match("/^\d{6}-\d{4}-\d{4}$/", $productId);
    }

    function isValidMd5($md5)
    {
        return preg_match("/^[0-9a-f]{32}$/i", $md5);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
            {
                $nErrors = 0;
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if(empty($SessionPost["ModuleName"]))
                {
                    $SessionPost["ViewState"]["ErrorsArray"]["ModuleName"] = new ActionMessage(array("ALERT_001_PHP"));
                }

                if(empty($SessionPost["ModuleProductId"]))
                {
                    $SessionPost["ViewState"]["ErrorsArray"]["ModuleProductId"] = new ActionMessage(array("ALERT_002_PHP"));
                }
                elseif(false == $this->isValidProductId(trim($SessionPost["ModuleProductId"])))
                {
                    $SessionPost["ViewState"]["ErrorsArray"]["ModuleProductId"] = new ActionMessage(array("ALERT_003_PHP"));
                }

/*
                if(empty($SessionPost["ModuleMd5"]))
                {
                    $SessionPost["ViewState"]["ErrorsArray"]["ModuleMd5"] = new ActionMessage(array("ALERT_004_PHP"));
                }
                elseif(false == $this->isValidMd5(trim($SessionPost["ModuleMd5"])))
                {
                    $SessionPost["ViewState"]["ErrorsArray"]["ModuleMd5"] = new ActionMessage(array("ALERT_005_PHP"));
                }
*/

                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>