<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php


/**
 *
 * @package PaymentModuleGate2shopCC
 * @author Alexander Belyakov
 */
class Payment_Module_Gate2shop_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Payment_Module_Gate2shop_CC constructor.
     */
    function Payment_Module_Gate2shop_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-gate2shop-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_MODULE_ID') .
                $info["GlobalUniquePaymentModuleID"] . "\n" .
                $this->Settings["MODULE_NAME"];
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
               array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_FALSE
                )
            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'ACCEPTED'
                )
            )
        );
        return $res;
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-gate2shop-messages", "AdminZone");

        list($usec, $sec) = explode(" ", microtime());

        return $obj->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $obj->getMessage('MODULE_PAYMENT_GATE2SHOP_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Gate2shop_CC::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-gate2shop-messages", "AdminZone");

        $tables = Payment_Module_Gate2shop_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_gate2shop_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];        #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_MERCHANT_SITE_ID", $columns['key']);
        $query->addInsertValue('s:4:"1234";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_MERCHANT_ID", $columns['key']);
        $query->addInsertValue('s:4:"1234";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_SECRET_STRING", $columns['key']);
        $query->addInsertValue('s:3:"abc";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Gate2shop_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_Gate2shop_CC                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-gate2shop-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_GATE2SHOP_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }



    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // Gate2Shop GUID
//        return "605123DF-0C16-4743-812B-DD902F5864BF";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-gate2shop-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "CheckoutPaymentModuleGate2shopCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModuleGate2shopCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleGate2shopCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_gate2shop_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_gate2shop_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }


    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_gate2shop_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_gate2shop_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_gate2shop_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_gate2shop_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

/*
    // testing
    function getPaymentMode()
    {
            return "direct";
    }

    function backgroundProcess()
    {
        $this->getConfirmationData(5);
    }
    //=========================================*/

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;
        loadCoreFile('aal.class.php');

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL("", true);

        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid()));
        $billingInfo = new ArrayAccessLayer($orderInfo);
        $billingInfo->setAccessMask ("Billing",  "attr", AAL_CUSTOM_PARAM, "value");
        $shippingInfo = new ArrayAccessLayer($orderInfo);
        $shippingInfo->setAccessMask ("Shipping",  "attr", AAL_CUSTOM_PARAM, "value");

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());

        $settings = $this->getSettings();
        $cart = $orderInfo["Products"];

        $merchant_site_id = $settings["MODULE_MERCHANT_SITE_ID"];
        $merchant_id = $settings["MODULE_MERCHANT_ID"];
        $timestamp = gmdate("Y-m-d.H:i:s");
        $numItems = count($cart);

//        $currencyId  = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currency    = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);
        $total       = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total",                 $currency_id));
        $tax         = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Tax",                   $currency_id));
        $shipping    = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalShippingAndHandlingCost",   $currency_id));
        $discount    = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "DiscountsSum",    $currency_id));
        $subtotal    = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "DiscountedSubtotal",    $currency_id));
        $numItems = count($cart);

    //=============================================================
    //=============================== checksum ====================
        $checksum_txt = $settings["MODULE_SECRET_STRING"]
            .$merchant_id
            .$currency
            .$total;

        $i=1;
        foreach ($cart as $item)
        {
            $items["item_name_$i"] = preg_replace("/[^a-zA-Z0-9]/", '', $item["name"]);
            $items["item_number_$i"] = $i;
            $items["item_quantity_$i"] = $item["qty"];
            $items["item_amount_$i"] = sprintf("%02.02f", $item["SalePrice"]);

            $checksum_txt .= $items["item_name_$i"]
                        .$items["item_amount_$i"]
                        .$items["item_quantity_$i"];

            $i++;
        }

        $checksum_txt .= $timestamp;
//        print_r($checksum_txt);
        $checksum = md5($checksum_txt);

    //==========================================================
    //====================== confirmation data =================
        $confirmationData = array
            (
                "FormAction" => "https://secure.safecharge.com/ppp/purchase.do"
                ,"FormMethod" => "POST"
                ,"DataFields" => array
                (
                    //
                    // common info
                    //
                     "version" => "3.0.0"
                    ,"merchant_site_id"  => $merchant_site_id
                    ,"merchant_id" => $merchant_id
                    ,"checksum" => $checksum
                    ,"time_stamp" => $timestamp
                    ,"currency" => $currency
                    ,"total_tax" => $tax
                    ,"shipping" => $shipping
                    ,"discount" => $discount
                    ,"total_amount" => $total
                    ,"numberofitems" => $numItems
                    ,"merchant_unique_id" => $orderId
                )
            );
        $confirmationData["DataFields"] = array_merge($confirmationData["DataFields"], $items);

        //================== logging =================

        $msg = &$application->getInstance('MessageResources',"payment-module-gate2shop-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msg->getMessage("MODULE_PAYMENT_TIMELINE_HEADER"), $confirmationData);

        //================== logging =================

        return $confirmationData;
    }

    /**
     * Processes data on updating the order status, that came from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, that came from the payment gateway.
     */
    function processData($data, $order_id /*, &$DBPaymentStatus, &$bStop, &$bPaymentFinished, &$EventType */)
    {
        global $application;
        $msg = &$application->getInstance('MessageResources',"payment-module-gate2shop-messages", "AdminZone");
        $settings = $this->getSettings();

        //
        // add incoming order message to history
        //
        $incommingHistoryMessage = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
            $msg->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_EVENT_DESCRIPTION') .
            $msg->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_MESSAGE_INCOMING') . "\n" .
            $msg->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_EXTRA') . "\n" .
            print_r($data["_GET"], true);
        modApiFunc("Checkout", "addOrderHistory", $order_id, $incommingHistoryMessage);

        //
        // check if necessary GET-parameters exist
        //
        $isGetValid = false;
        if (array_key_exists("Status", $data["_GET"]) &&
            array_key_exists("responsechecksum", $data["_GET"]))
        {
            $status = $data["_GET"]["Status"];
            $response = $data["_GET"]["responsechecksum"];

            $errCode = isset($data["_GET"]["ErrCode"]) ? $data["_GET"]["ErrCode"] : "";
            $exErrCode = isset($data["_GET"]["ExErrCode"]) ? $data["_GET"]["ExErrCode"] : "";
            $message = isset($data["_GET"]["message"]) ? $data["_GET"]["message"] : "";
            $txn = isset($data["_GET"]["TransactionID"]) ? $data["_GET"]["TransactionID"] : "";

            $response_calculated = md5($settings["MODULE_SECRET_STRING"]
                .$txn
                .$errCode
                .$exErrCode
                .$status);

            if ($response === $response_calculated)
            {
                $isGetValid = true;
            }

        }

        if ($isGetValid)
        {

            // the status update
            switch ($status)
            {
                case "APPROVED":
                    // the customer card has been approved
                    $EventType = "ConfirmationSuccess";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_MESSAGE_APPROVED'));
                    modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $txn);
                    break;

                case "DECLINED":
                    // the payment request is declined
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_MESSAGE_DECLINED'));
                    break;

                case "ERROR":
                    // payment error
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_MESSAGE_ERROR'));
                    break;

                default:
                    // payment error
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_GATE2SHOP_LOG_MESSAGE_INVALID_STATUS') . $status);
                    break;
             }
        }
        else
        {
            $EventType = "ConfirmationFailure";
            $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                $msg->getMessage("MODULE_PAYMENT_GATE2SHOP_LOG_MESSAGE_GET_ERROR"));
        }

        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Gate2shop_CC::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Gate2shop_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_gate2shop_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_gate2shop_setting_id'
               ,'key'               => $settings.'.pm_gate2shop_setting_key'
               ,'value'             => $settings.'.pm_gate2shop_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    /**
     * Credit card info. It will be used later.
     */
    var $ccInfoCardNumber;
    var $ccInfoCardExpMonth;
    var $ccInfoCardExpYear;
    var $ccInfoCardIDNumber;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>