<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package PaymentModuleHsbcxmlCC
 * @author Ravil Garafutdinov
 */
class Payment_Module_Hsbcxml_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'JNY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
                ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
            )
        );

        return $res;
    }

    /**
     * PaymentModuleHsbcxml  constructor.
     */
    function Payment_Module_Hsbcxml_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-hsbcxml-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();
    }

    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'HsbcxmlErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'HsbcxmlErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    function saveState()
    {
        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'HsbcxmlErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMessage($msg)
    {
        $this->errorMessage = $msg;
    }

    function getErrorMessage()
    {
        return $this->errorMessage;
    }

    function unsetErrorMessage()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'HsbcxmlErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'HsbcxmlErrorMessage');
        }
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-hsbcxml-messages", "AdminZone");

        list($usec, $sec) = explode(" ",microtime());

        return $obj->getMessage('MODULE_PAYMENT_HSBCXML_LOG_EVENT_TIME') . (float)($usec + $sec) . " " . $obj->getMessage('MODULE_PAYMENT_HSBCXML_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Hsbcxml_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-hsbcxml-messages", "AdminZone");

        $tables = Payment_Module_Hsbcxml_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_hsbcxml_settings';                #the name of the filled table
        $columns = $tables[$table]['columns'];      #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_USERNAME", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_PASSWORD", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_CLIENT_ID", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_GATEWAY_URL", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_DEFAULT_GATEWAY_URL')).':"'.$obj->getMessage('MODULE_DEFAULT_GATEWAY_URL').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"P";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Hsbcxml_CC',
               'OnRemovePersonInfoType');
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // Hsbcxml UID
//        return "DE3F3571-FA61-44E2-B6A7-F635D5ADBC71";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-hsbcxml-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "hsbcxml_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModuleHsbcxmlCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleHsbcxmlCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_hsbcxml_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_hsbcxml_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_hsbcxml_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_hsbcxml_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_hsbcxml_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_hsbcxml_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        return;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id)
    {
        global $application;
        $mres = &$application->getInstance('MessageResources',"payment-module-hsbcxml-messages", "AdminZone");

        //
        // The checking on the delivery to the selected place might be
        // added here
        //
        $msg = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" . $mres->getMessage('MODULE_PAYMENT_HSBCXML_LOG_EVENT_DESCRIPTION') . "\n" . $mres->getMessage('MODULE_PAYMENT_HSBCXML_LOG_POST_DATA') . " \n " . print_r($data["_POST"], true);

        if ($data["_POST"]["TransactionStatus"] == "A")
        {
	        $EventType = "ConfirmationSuccess";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);
       	}
       	else
       	{
	        $EventType = "ConfirmationFailure";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
       	}
	    return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Hsbcxml_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Hsbcxml_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /*
     * this function is needed for correct credit card info form
     * realization
     */

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        if($prerequisite_type == "creditCardInfo")
        {
            return "default";
        }
        else
        {
            return false;
        }
    }

    /**
     * parses XML tags, seeks for tags given in $fields
     *
     * @param string array $fields
     * @param string $raw
     * @return unknown
     */

    function parseXmlTags($fields, $raw, $mode = 'tag')
    {
        loadCoreFile("obj_xml.php");
        $xml = new xml_doc($raw);
        $xml->parse();

        if (!is_object($xml->document))
            return $fields;

        foreach ($fields as $tag => $val)
        {
            $xml_tag = $xml->document->findChildRecursively($tag);
            if ($xml_tag != FALSE)
            {
                if ($mode == 'tag')
                    $fields[$tag] = $xml_tag;
                else // if ($mode == 'contents')
                    $fields[$tag] = $xml_tag->contents;
            }
        }

        return $fields;
    }

    function parseResponse($raw)
    {
        if ($raw == false)
            return false;

        $fields = array(
             "CcReturnMsg" => ""
            ,"Notice" => ""
            ,"TransactionStatus" => ""
            ,"Cvv2Resp" => ""
            ,"CcErrCode" => ""
            ,"AvsDisplay" => ""
        );

        return $this->parseXmlTags($fields, $raw, 'contents');
    }

    /*
     * processing all payments
     */

    function backgroundProcess()
    {
        global $application;
        loadCoreFile('aal.class.php');

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");
        $bstate =    $billingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')) : $billingInfo->getByMask('Statetext');
        $bcountry =  $billingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')) : $billingInfo->getByMask('Country');

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");
        $sstate =    $shippingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')) : $shippingInfo->getByMask('Statetext');
        $scountry =  $shippingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')) : $shippingInfo->getByMask('Country');

        $CCInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());
        $settings = $this->getSettings();
        $refnum =  date("Y/m/d_H:i:s").'_'.intval(microtime()*1000000);

        $cardNumber = isset($CCInfo["CreditCardNumber"]["value"])
            ? $CCInfo["CreditCardNumber"]["value"] : "";
        $CVM = isset($CCInfo["CreditCardVerificationNumber"]["value"])
            ? $CCInfo["CreditCardVerificationNumber"]["value"] : "";
        $issueNumber = isset($CCInfo["CreditCardIssueNumber"]["value"])
            ? $CCInfo["CreditCardIssueNumber"]["value"] : "";

        $cardExpMonth = isset($CCInfo["ExpirationMonth"]["value"])
            ? $CCInfo["ExpirationMonth"]["value"] : "";
        $cardExpYear = isset($CCInfo["ExpirationYear"]["value"])
            ? $CCInfo["ExpirationYear"]["value"] % 100 : "";
        $cardExpYear = sprintf("%02d", $cardExpYear);

        $currencyId = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currencyCode = modApiFunc("Localization", "getCurrencyCodeById", $currencyId);
        $currencyHsbcCode = $this->getCurrencyCode($currencyCode);

        $total = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currencyId));
        $multiplicator = ($currencyCode == 'JNY') ? 1 : 100;
        $total = (number_format($total*$multiplicator, 0, '.', ''));

        $fields = array(
                     "MODULE_USERNAME"     => $settings["MODULE_USERNAME"]
                    ,"MODULE_PASSWORD"     => $settings["MODULE_PASSWORD"]
                    ,"MODULE_CLIENT_ID"    => $settings["MODULE_CLIENT_ID"]
                    ,"MODULE_MODE"         => $settings["MODULE_MODE"]
                    ,"MODULE_ORDER_NUMBER" => $refnum
                    ,"MODULE_AMOUNT"      => $total
                    ,"MODULE_CREDIT_CARD_NUMBER" => $cardNumber
                    ,"MODULE_EXP_DATE"     => $cardExpMonth.'/'.$cardExpYear
                    ,"MODULE_CREDIT_CARD_CVV2_INDICATOR" => (trim($CVM) == '') ? '0' : '1'
                    ,"MODULE_CREDIT_CARD_CVV2"  => $CVM
                    ,"MODULE_CREDIT_CARD_ISSUE_NUMBER" => $issueNumber
                    ,"MODULE_CURRENCY_CODE"     => $currencyHsbcCode
                    ,"MODULE_BILLING_FIRSTNAME" => $billingInfo->getByMask('Firstname')
                    ,"MODULE_BILLING_LASTNAME"  => $billingInfo->getByMask('Lastname')
                    ,"MODULE_BILLING_STREET1"   => $billingInfo->getByMask('Streetline1')
                    ,"MODULE_BILLING_STREET2"   => $billingInfo->getByMask('Streetline2')
                    ,"MODULE_BILLING_CITY"      => $billingInfo->getByMask('City')
                    ,"MODULE_BILLING_STATEPROV" => $bstate
                    ,"MODULE_BILLING_POSTALCODE" => $billingInfo->getByMask('Postcode')
                    ,"MODULE_BILLING_COUNTRY"   => $bcountry
                    ,"MODULE_BILLING_EMAIL"     => $billingInfo->getByMask('Email')
                    ,"MODULE_SHIPPING_FIRSTNAME" => $shippingInfo->getByMask('Firstname')
                    ,"MODULE_SHIPPING_LASTNAME" => $shippingInfo->getByMask('Lastname')
                    ,"MODULE_SHIPPING_STREET1"  => $shippingInfo->getByMask('Streetline1')
                    ,"MODULE_SHIPPING_STREET2"  => $shippingInfo->getByMask('Streetline2')
                    ,"MODULE_SHIPPING_CITY"     => $shippingInfo->getByMask('City')
                    ,"MODULE_SHIPPING_STATEPROV"  => $sstate
                    ,"MODULE_SHIPPING_POSTALCODE" => $shippingInfo->getByMask('Postcode')
                    ,"MODULE_SHIPPING_COUNTRY"    => $scountry
                    ,"MODULE_SHIPPING_EMAIL"      => $shippingInfo->getByMask('Email')
               );

        $xml_template = file_get_contents(dirname(__FILE__)."/includes/request.xml");
        $xml_content = strtr($xml_template, $fields);

        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($settings["MODULE_GATEWAY_URL"]);
        $bnc->setPOSTstring($xml_content);
        $result = $bnc->RunRequest();

    //================================ logging ===============================

        $fields["MODULE_CREDIT_CARD_NUMBER"] = preg_replace("/[0-9]/", 'x', $fields["MODULE_CREDIT_CARD_NUMBER"]);
        $fields["MODULE_EXP_DATE"] = preg_replace("/[0-9]/", 'x', $fields["MODULE_EXP_DATE"]);
        $fields["MODULE_CREDIT_CARD_CVV2"] = preg_replace("/[0-9]/", 'x', $fields["MODULE_CREDIT_CARD_CVV2"]);
        $fields["MODULE_CREDIT_CARD_ISSUE_NUMBER"] = preg_replace("/[0-9]/", 'x', $fields["MODULE_CREDIT_CARD_ISSUE_NUMBER"]);

        $xml_to_log = strtr($xml_template, $fields);
        $xml_to_log = $this->processXmlBeforeLogging($xml_to_log);

        $msg = &$application->getInstance('MessageResources',"payment-module-hsbcxml-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msg->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_REQUEST"), $xml_to_log);

    //================================ logging ===============================

        if (isset($result["body"]))
        {
            $response = $this->parseResponse($result["body"]);
        }
        else
        {
            $response["TransactionStatus"] = "R";
        }

    //================================ logging ===============================

        $response_to_log = $result;
        if (isset($result['body']))
        {
            $response_to_log = $this->processXmlBeforeLogging($result['body']);
        }
        $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", $msg->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_RESPONSE"), $response_to_log);

    //================================ logging ===============================

        if ($response["TransactionStatus"] == "A") // Successful Payment, APPROVED
        {
            //Create order
            $order_id = modApiFunc("Checkout", "createOrderInDB");
            //                .
            //
            modApiFunc("Cart", "removeAllFromCart");
            $this->processData(array("_POST" => $response, "_GET" => array()), $order_id);
            $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
        }
        else // NO RESPONSE, DECLINED or FRAUD
        {
            if ($response["TransactionStatus"] == "R")
	        {
	            // couldn't reach Hsbcxml Gateway,
	            // looks like wrong gateway settings
                $this->setErrorMessage($msg->getMessage("ERROR_NO_RESPONSE"));
	        }
            else
            {
                $txtmsg = $msg->getMessage("ERROR_SERVER_RESULT")
                    . "<br />" . "Error Code: " . $response["CcErrCode"]
                    . "<br />" . "Message: " . $response["CcReturnMsg"];
                $this->setErrorMessage($txtmsg);
            }
            $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "CHECKOUT_ERR_005", array(), $paymentModule["validatedData"]);
            $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
            modApiFunc("Checkout", "saveState");
        }
        $request = new Request();
        $request->setView  ('CheckoutView');
        $request->setAction("SetCurrStep");
        $request->setKey   ( 'step_id', $step_id_to_redirect_to);
        $application->redirect($request);
    }

    /**
     * Returns the 'direct' or 'redirect' payment method.
     *///*
    function getPaymentMode()
    {
        return "direct";
    }//*/

    /*
     * this function checks whether the SSL works on
     * this server
     */

    function checkRequirements()
    {
        $return=array();

        // check SSL
        loadCoreFile('bouncer.php');
        $bssl = new Bouncer();
        if(!$bssl->isSSLavailable())
            $return[] = "ERROR_SSL_NOT_AVAIL";

        return $return;
    }

    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_hsbcxml_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_hsbcxml_setting_id'
               ,'key'               => $settings.'.pm_hsbcxml_setting_key'
               ,'value'             => $settings.'.pm_hsbcxml_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        YourPay                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-hsbcxml-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_HSBCXML_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }

    function getCurrencyCode($threeLetterCode)
    {
        $currencies = array(
             'AUD' => 036
            ,'CAD' => 124
            ,'DKK' => 206
            ,'EUR' => 978
            ,'HKD' => 344
            ,'JNY' => 392   // 0 decimal places
            ,'NZD' => 554
            ,'NOK' => 578
            ,'SGD' => 702
            ,'SEK' => 752
            ,'CHF' => 756
            ,'GBP' => 826
            ,'USD' => 840
        );

        if (isset($currencies[$threeLetterCode]))
            return $currencies[$threeLetterCode];

        return 840;
    }

    function processXmlBeforeLogging($xml)
    {
        $ret = str_replace(' ', '&nbsp;', $xml);
        $ret = str_replace('<', '&lt;', $ret);
        $ret = str_replace('>', '&gt;', $ret);
        $ret = nl2br($ret);
//        $ret = str_replace('\n', '<br/>', $ret);
        return $ret;
    }

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>