<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php


/**
 *
 * @package PaymentModuleMoneybooewalletCC
 * @author Ravil Garafutdinov
 */
class Payment_Module_Moneybooewallet_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Payment_Module_Moneybooewallet_CC constructor.
     */
    function Payment_Module_Moneybooewallet_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-moneybooewallet-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_MODULE_ID') .
                $info["GlobalUniquePaymentModuleID"] . "\n" .
                $this->Settings["MODULE_NAME"];
    }

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'TWD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'THB'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CZK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HUF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'BGN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'PLN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'ISK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'INR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'LVL'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'KRW'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'ILS'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'ZAR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'MYR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'RON'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HRK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'TRY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'LTL'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
            )
        );
        return $res;
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-moneybooewallet-messages", "AdminZone");

        list($usec, $sec) = explode(" ", microtime());

        return $obj->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $obj->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_SECONDS');
    }

    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'MoneybooewalletErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'MoneybooewalletErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    function saveState()
    {
        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'MoneybooewalletErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMsg($msg)
    {
        $temp = $this->getErrorMsg();
        $this->errorMessage = $temp.$msg;
        modApiFunc('Session', 'set', $this->errorMessage);
    }

    function getErrorMsg()
    {
        $this->errorMessage = '';
        if(modApiFunc('Session', 'is_Set', 'MoneybooewalletErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'MoneybooewalletErrorMessage');
        }
        return $this->errorMessage;
    }

    function unsetErrorMsg()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'MoneybooewalletErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'MoneybooewalletErrorMessage');
        }
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Moneybooewallet_CC::getTables() instead of $this->getTables()
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-moneybooewallet-messages", "AdminZone");

        $tables = Payment_Module_Moneybooewallet_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_moneybooewallet_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];        #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_MERCHANT_EMAIL", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_MERCHANT_EMAIL_VALIDATED", $columns['key']);
        $query->addInsertValue('s:1:"0";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_CUSTOMER_ID", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_SECRET_STRING", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_SECRET_STRING_VALIDATED", $columns['key']);
        $query->addInsertValue('s:1:"0";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(7, $columns['id']);
        $query->addInsertValue("MODULE_MERCHANT_NAME", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(8, $columns['id']);
        $query->addInsertValue("MODULE_HIDE_LOGIN", $columns['key']);
        $query->addInsertValue('s:1:"0";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(9, $columns['id']);
        $query->addInsertValue("MODULE_LOGO_URL", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(10, $columns['id']);
        $query->addInsertValue("MODULE_LANGUAGE", $columns['key']);
        $query->addInsertValue('s:2:"EN";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(11, $columns['id']);
        $query->addInsertValue("MODULE_URL", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_URL')).':"'.$obj->getMessage('MODULE_URL').'";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Moneybooewallet_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_Moneybooewallet_CC                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-moneybooewallet-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }



    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // Moneybooewallet GUID
//        return "1DA30517-D51A-480F-98A1-C6967FC5299F";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-moneybooewallet-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "CheckoutPaymentModuleMoneybooewalletCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModuleMoneybooewalletCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleMoneybooewalletCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_moneybooewallet_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_moneybooewallet_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }


    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_moneybooewallet_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_moneybooewallet_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_moneybooewallet_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_moneybooewallet_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * Saves email_validated and customer_id
     *
     * @param int $cust_id -  Customer ID
     */
    function saveEmailAndCustomerId($email, $cust_id)
    {
        global $application;
        $settings = $this->getSettings();

        $tables = $this->getTables();
        $columns = $tables['pm_moneybooewallet_settings']['columns'];

        $query = new DB_Update('pm_moneybooewallet_settings');
        $query->addUpdateValue($columns['value'], serialize($email));
        $query->WhereValue($columns['key'], DB_EQ, 'MODULE_MERCHANT_EMAIL');
        $application->db->getDB_Result($query);

        $query = new DB_Update('pm_moneybooewallet_settings');
        $query->addUpdateValue($columns['value'], serialize('1'));
        $query->WhereValue($columns['key'], DB_EQ, 'MODULE_MERCHANT_EMAIL_VALIDATED');
        $application->db->getDB_Result($query);

        $query = new DB_Update('pm_moneybooewallet_settings');
        $query->addUpdateValue($columns['value'], serialize($cust_id));
        $query->WhereValue($columns['key'], DB_EQ, 'MODULE_CUSTOMER_ID');
        $application->db->getDB_Result($query);

        if ($email != $settings['MODULE_MERCHANT_EMAIL'])
        {
            $query = new DB_Update('pm_moneybooewallet_settings');
            $query->addUpdateValue($columns['value'], serialize('0'));
            $query->WhereValue($columns['key'], DB_EQ, 'MODULE_SECRET_STRING_VALIDATED');
            $application->db->getDB_Result($query);
        }
    }

    /**
     * Saves sw_validated
     */
    function saveValidatedSW($sw)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_moneybooewallet_settings']['columns'];

        $query = new DB_Update('pm_moneybooewallet_settings');
        $query->addUpdateValue($columns['value'], serialize('1'));
        $query->WhereValue($columns['key'], DB_EQ, 'MODULE_SECRET_STRING_VALIDATED');
        $application->db->getDB_Result($query);

        $query = new DB_Update('pm_moneybooewallet_settings');
        $query->addUpdateValue($columns['value'], serialize($sw));
        $query->WhereValue($columns['key'], DB_EQ, 'MODULE_SECRET_STRING');
        $application->db->getDB_Result($query);
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }


    /**
     * function submits order fields to the gateway
     * and gets a SID the customer to be redirected with
     *
     */
    function getPaymentSID($orderId)
    {
        global $application;
        loadCoreFile('aal.class.php');

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $status_url = $request->getURL("", true);

        $request->setKey("result", 'cancel');
        $cancel_url = $request->getURL("", true);

        $request->setKey("result", 'return');
        $return_url = $request->getURL("", true);

        $currency_id   = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());
        $currency_code = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);

        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, $currency_id);
        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");
        $bstate =    $billingInfo->getByMask('Statemenu') ? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')) : $billingInfo->getByMask('Statetext');
        $bcountry =  $billingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country'), "ISO3") : $billingInfo->getByMask('Country');

        $msgObj   = $application->getInstance("MessageResources", "payment-module-moneybooewallet-messages", "AdminZone");
        $settings = $this->getSettings();

        $total = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currency_id));
        $total = number_format($total, 2, '.', '');

        $fields = array(
                 "pay_to_email"     => $settings["MODULE_MERCHANT_EMAIL"]
                ,"recipient_description" => $settings["MODULE_MERCHANT_NAME"]
                ,"transaction_id"   => $orderId
                ,"return_url"       => $return_url
                ,"cancel_url"       => $cancel_url
                ,"status_url"       => $status_url
                ,"language"         => $settings["MODULE_LANGUAGE"]
                ,"hide_login"       => 0
                ,"logo_url"         => $settings["MODULE_LOGO_URL"]
                ,"prepare_only"     => 1
                ,"payment_methods"  => "WLT"
                ,"amount"           => $total
                ,"currency"         => $currency_code
                ,"pay_from_email"   => $billingInfo->getByMask('Email')
                ,"firstname"        => $billingInfo->getByMask('Firstname')
                ,"lastname"         => $billingInfo->getByMask('Lastname')
                ,"address"          => $billingInfo->getByMask('Streetline1')
                ,"address2"         => $billingInfo->getByMask('Streetline2')
                ,"phone_number"     => $billingInfo->getByMask('Phone')
                ,"city"             => $billingInfo->getByMask('City')
                ,"postal_code"      => $billingInfo->getByMask('Postcode')
                ,"country"          => $bcountry
                ,"state"            => $bstate
                ,"merchant_fields"  => "platform"
                ,"platform"         => "avactis"
           );

    //================================ logging ===============================

        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_LOGGING_PAYMENT_SID") . $orderId, $fields);

    //================================ logging ===============================

        $content = "";
        foreach ($fields as $key => $value) {
            $content .= $key . '=' . urlencode($value) . '&';
        }

        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($settings["MODULE_URL"]);
        $bnc->setPOSTstring($content);
        $result = $bnc->RunRequest();

    //================================ logging ===============================

        $this->addRequestLog("LOG_PM_OUTPUT", "Payment Module Logs", str_replace('{ORDER_ID}', $orderId, $msgObj->getMessage("MODULE_PAYMENT_LOGGING_PAYMENT_SID_RESULT")), $result);

    //================================ logging ===============================

        $response = false;
        $valid = false;
        if (isset($result['cookies']['valid']['SESSION_ID']))
        {
            $response = trim($result['cookies']['valid']['SESSION_ID']);
            $valid = true;

            if (strlen($response) != 32)
            {
                $this->setErrorMsg($msgObj->getMessage("ERROR_WRONG_SID"));
                $valid = false;
            }
        }
        else
        {
            $valid = false;
            $this->setErrorMsg($msgObj->getMessage("ERROR_NO_RESPONSE"));
        }

        if (!$valid)
        {
            $request = new Request();
            $request->setView(CURRENT_REQUEST_URL);
            $request->setAction("UpdatePaymentStatus");
            $request->setKey("asc_oid", $orderId);
            $request->setKey("result", 'no_sid');
            $application->processActionStarted = false;
            $application->redirect($request);
            return;
        }

        $incomingHistoryMessage = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
            $msgObj->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_EVENT_DESCRIPTION') .
            $msgObj->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_CLUSTER') . $response;
        modApiFunc("Checkout", "addOrderHistory", $orderId, $incomingHistoryMessage);

        return $response;
    }

    function backgroundProcess()
    {
        _print('wrong hole!');die;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;

    //==========================================================
    //====================== new payment cluster ===============

        $payment_sid = $this->getPaymentSID($orderId);
        $settings = $this->getSettings();

        $confirmationData = array
            (
                 "FormAction" => $settings["MODULE_URL"]
                ,"FormMethod" => "POST"
                ,"DataFields" => array
                (
                     "sid" => $payment_sid
                )
            );

    //================================ logging ===============================

        $msgObj = $application->getInstance("MessageResources", "payment-module-moneybooewallet-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_LOGGING_GET_CONFIRMATION_DATA") . $orderId, $confirmationData);

    //================================ logging ===============================

        return $confirmationData;
    }

    /**
     * Processes data on updating the order status, that came from the payment gateway.
     *
     */
    function processData($data, $order_id)
    {
        global $application;
        $msg = &$application->getInstance('MessageResources',"payment-module-moneybooewallet-messages", "AdminZone");
        $settings = $this->getSettings();

        $status = '';
        if (isset($data['_GET']['result']))
            $status = preg_replace('/[^a-z_]/', '', $data['_GET']['result']);

        $this->post = $data['_POST'];
        $trx_status     = $this->getVal('status');
        $hash           = $this->getVal('md5sig');
        $merchant_id    = $this->getVal('merchant_id');
        $merchant_email = $this->getVal('pay_to_email');
        $bank_trx_id    = $this->getVal('mb_transaction_id');
        $currency_code  = $this->getVal('currency');
        $mb_currency_code = $this->getVal('mb_currency');
        $mb_amount      = $this->getVal('mb_amount');
        $amount         = $this->getVal('amount');
        $trx_id         = $this->getVal('transaction_id');
        $cust_email     = $this->getVal('pay_from_email');

        $hash_txt = $merchant_id.$trx_id.strtoupper(md5($settings['MODULE_SECRET_STRING'])).$mb_amount.$mb_currency_code.$trx_status;
        $hash_recalc = strtoupper(md5($hash_txt));

        // hash is not empty, an IPN notification has come
        if ($hash != '')
        {
            $status = 'ipn';
        }

        $txt = '';
        $generic_error = $this->getErrorMsg();

        // add incoming order message to history
        $incomingHistoryMessage = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
            $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_EVENT_DESCRIPTION') .
            $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_MESSAGE_INCOMING');
        if ($status == 'ipn')
            $incomingHistoryMessage .= "\n" . $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_STATUS') . print_r($data, true);
        if ($generic_error != '')
            $incomingHistoryMessage .= "\n" . $generic_error;
        modApiFunc("Checkout", "addOrderHistory", $order_id, $incomingHistoryMessage);

        // the status update
        switch ($status)
        {
            case "ipn":
                // notification has come

                //================================ logging ===============================

                $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msg->getMessage("MODULE_PAYMENT_LOGGING_PROCESS_DATA") . $order_id, $data);

                //================================ logging ===============================

                if ($hash != $hash_recalc)
                {
                    $EventType = "ConfirmationFailure";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_MESSAGE_GET_ERROR') . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_MESSAGE_WRONG_HASH') . "\n" .
                        "$hash != $hash_recalc");
                }
                else
                {
                    $EventType = "ConfirmationSuccess";
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2,
                        $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                        $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_EVENT_DESCRIPTION') .
                        $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_MESSAGE_APPROVED'));
                }
                break;

            case "return":
                // the customer has returned

                $EventType = "ConfirmationSuccess";
                $result = 1;//modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3,
//                    $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
//                    $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_EVENT_DESCRIPTION') .
//                    $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_MESSAGE_DECLINED'));
                break;

            case "cancel":
            case "no_sid":
            default:
                // payment error
                $EventType = "ConfirmationFailure";

                //================================ logging ===============================

                $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msg->getMessage("MODULE_PAYMENT_LOGGING_PROCESS_DATA") . $order_id, $data);

                //================================ logging ===============================

                $txt = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
                    $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_EVENT_DESCRIPTION') .
                    $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_MESSAGE_ERROR');

                if ($status == "cancel")
                    $txt .= "\n" . $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_MESSAGE_CANCEL');
                if ($status == "no_sid")
                    $txt .= "\n" . $msg->getMessage('MODULE_PAYMENT_MONEYBOOEWALLET_LOG_MESSAGE_NO_SID');

                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $txt);
                break;
         }

        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    function getVal($label)
    {
        if (isset($this->post[$label]))
            return $this->post[$label];
        return '';
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Moneybooewallet_CC::getTables() instead of $this->getTables()
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Moneybooewallet_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_moneybooewallet_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_moneybooewallet_setting_id'
               ,'key'               => $settings.'.pm_moneybooewallet_setting_key'
               ,'value'             => $settings.'.pm_moneybooewallet_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    /**
     * Credit card info. It will be used later.
     */
    var $post;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>