<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php


/**
 * This Hook is activated by action checkout 'SetCurrentStep'.
 *
 * @package PaymentModulePaypalProCC
 * @author Alexander Girin
 */
class PayPalProHook
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * NewOrder constructor.
     */
    function PayPalProHook()
    {
    }

    /**
     *
     */
    function onHook()
    {
        global $application;
        $request = &$application->getInstance("Request");

        #                          ,                                                     PayPalPro
        if ($paymentModule = $request->getValueByKey("paymentModule"))
        {
            if ($paymentModule["method_code"] != modApiFunc("Payment_Module_PaypalPro_CC", "getUid"))
            {
                $billingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo");
                if ($billingInfo["variant_tag"] == "PaypalProExpressCheckout")
                {
                    modApiFunc("Checkout", "changeCurrentPersonInfoVariant", "billingInfo" , "default");
                }
                if (modApiFunc("Payment_Module_PaypalPro_CC", "getPaymentMethod") == "ExpressCheckout")
                {
                    modApiFunc("Payment_Module_PaypalPro_CC", "setPaymentMethod", "");
                    modApiFunc("Payment_Module_PaypalPro_CC", "SaveState");
                }
            }
        }

        #this condition works, when a customer presses the Express Checkout button,
        #i.e. it sends a request to the PayPal server and redirects the customer to the PayPal site on success
        $paymentModule = $request->getValueByKey("PayPalProExpressCheckout");
        if (!$paymentModule)
        {
            $paymentModule = $request->getValueByKey("PayPalProExpressCheckout_x");
            if (!$paymentModule)
            {
                $paymentModule = $request->getValueByKey("PayPalProExpressCheckout_y");
                if ($paymentModule)
                {
                    $paymentModule = "doPayPalProExpressCheckout";
                }
            }
            else
            {
                $paymentModule = "doPayPalProExpressCheckout";
            }
        }
        if ($paymentModule == "doPayPalProExpressCheckout")
        {
            #: define the step, where the button Express Checkout was pressed and specify that step- Checkout CurrentStepID
            $Settings = modApiFunc("Payment_Module_PaypalPro_CC", "getSettings");
            $billingInfo = modApiFunc("Checkout", "getValidatedDataStructure", "billingInfo", $Settings["MODULE_BILLING_PERSON_INFO_VARIANT"]["tag"]);
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "billingInfo", $Settings["MODULE_BILLING_PERSON_INFO_VARIANT"]["tag"], false, "", array(), $billingInfo);
            modApiFunc("Checkout", "ProcessNewStepID", 1);

            if (modApiFunc("Payment_Module_PaypalPro_CC", "backgroundProcess", "setExpressCheckout"))
            {
                $response = modApiFunc("Payment_Module_PaypalPro_CC", "getResponse");
                if (isset($response['Ack']) && $response['Ack'] == 'Success' && isset($response['Token']) && $response['Token'] != '')
                {
                    modApiFunc("Payment_Module_PaypalPro_CC", "setExpessCheckoutData", "token", $response['Token']);
                    modApiFunc("Payment_Module_PaypalPro_CC", "SaveState");
                    $request = new Request(modApiFunc("Payment_Module_PaypalPro_CC", "getPayPalURL")."?cmd=_express-checkout&token=".$response['Token']);
                    $application->redirect($request);
                }
                else
                {
                    $request = new Request();
                    $request->setView('CheckoutView');
                    $request->setAction("SetCurrStep");
                    $request->setKey   ( 'step_id', (modApiFunc("Checkout", "getCurrentStepID")));
                    $application->redirect($request);
                }
            }
            else
            {
                $request = new Request();
                $request->setView('CheckoutView');
                $request->setAction("SetCurrStep");
                $request->setKey   ( 'step_id', modApiFunc("Checkout", "getCurrentStepID"));
                $application->redirect($request);
            }
        }

        #this condition works, when a customer is back from the PayPalPro Express Checkout site
        if ($token = $request->getValueByKey("token") && $PayerID = $request->getValueByKey("PayerID"))
        {
            if ($token == modApiFunc("Payment_Module_PaypalPro_CC", "getExpessCheckoutData", "token") && $PayerID != "")
            {
                modApiFunc("Payment_Module_PaypalPro_CC", "setExpessCheckoutData", "PayerID", $PayerID);
                modApiFunc("Payment_Module_PaypalPro_CC", "setPaymentMethod", "ExpressCheckout");
                modApiFunc("Payment_Module_PaypalPro_CC", "SaveState");

                if (modApiFunc("Payment_Module_PaypalPro_CC", "backgroundProcess", "getExpressCheckoutDetails"))
                {
                    $response = modApiFunc("Payment_Module_PaypalPro_CC", "getResponse");
                    if (isset($response['Ack']) && $response['Ack'] == 'Success')
                    {
                        #Override Custom Info with data received from Express Checkout.
/*                        $customerInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "customerInfo");
                        if (isset($customerInfo["validatedData"]["Firstname"]["value"]) && !$customerInfo["validatedData"]["Firstname"]["value"])
                        {
                            $customerInfo["validatedData"]["Firstname"]["value"] = $response["BillingFirstname"];
                        }
                        if (isset($customerInfo["validatedData"]["Lastname"]["value"]) && !$customerInfo["validatedData"]["Lastname"]["value"])
                        {
                            $customerInfo["validatedData"]["Lastname"]["value"] = $response["BillingLastname"];
                        }
                        if (isset($customerInfo["validatedData"]["Email"]["value"]) && !$customerInfo["validatedData"]["Email"]["value"])
                        {
                            $customerInfo["validatedData"]["Email"]["value"] = $response["BillingEmail"];
                        }
                        if (isset($customerInfo["validatedData"]["Country"]["value"]) && !$customerInfo["validatedData"]["Country"]["value"])
                        {
                            $customerInfo["validatedData"]["Country"]["value"] = modApiFunc("Location", "getCountryIdByCountryCode", $response["BillingCountry"]);
                        }
                        modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "customerInfo", "default", false, "", array(), $customerInfo["validatedData"]);
*/
                        #Override Billing Info with data received from Express Checkout.
                        $Settings = modApiFunc("Payment_Module_PaypalPro_CC", "getSettings");
                        $billingInfo = modApiFunc("Checkout", "getValidatedDataStructure", "billingInfo", $Settings["MODULE_BILLING_PERSON_INFO_VARIANT"]["tag"]);
                        foreach ($billingInfo as $rerequisiteItemKey => $rerequisiteItemData)
                        {
                            switch ($rerequisiteItemKey)
                            {
                                case "Firstname":
                                    $billingInfo["Firstname"]["value"] = $response["BillingFirstname"];
                                    break;
                                case "Lastname":
                                    $billingInfo["Lastname"]["value"] = $response["BillingLastname"];
                                    break;
                                case "Email":
                                    $billingInfo["Email"]["value"] = $response["BillingEmail"];
                                    break;
//                                case "Country":
//                                    $billingInfo["validatedData"]["Country"]["value"] = modApiFunc("Location", "getCountryIdByCountryCode", $response["BillingCountry"]);
//                                    break;
                                default:
                                    break;
                            }
                        }
                        modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "billingInfo", $Settings["MODULE_BILLING_PERSON_INFO_VARIANT"]["tag"], false, "", array(), $billingInfo);

                        #Override Shipping Info with data received from Express Checkout.
                        $shippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
                        if (isset($shippingInfo["validatedData"]["Firstname"]["value"]))
                        {
                            $shippingInfo["validatedData"]["Firstname"]["value"] = $response["ShippingFirstname"];
                        }
                        if (isset($shippingInfo["validatedData"]["Lastname"]["value"]))
                        {
                            $shippingInfo["validatedData"]["Lastname"]["value"] = $response["ShippingLastname"];
                        }
                        if (isset($shippingInfo["validatedData"]["Email"]["value"]))
                        {
                            $shippingInfo["validatedData"]["Email"]["value"] = $response["BillingEmail"];
                        }
                        if (isset($shippingInfo["validatedData"]["Country"]["value"]))
                        {
                            $shippingInfo["validatedData"]["Country"]["value"] = modApiFunc("Location", "getCountryIdByCountryCode", $response["ShippingCountryCode"]);
                        }
                        if (isset($shippingInfo["validatedData"]["Postcode"]["value"]))
                        {
                            $shippingInfo["validatedData"]["Postcode"]["value"] = $response["ShippingPostcode"];
                        }
                        if (isset($shippingInfo["validatedData"]["Statemenu"]) && isset($shippingInfo["validatedData"]["Statemenu"]["value"]))
                        {
                            $shippingInfo["validatedData"]["Statemenu"]["value"] = modApiFunc("Location", "getStateIdByStateCode", $response["ShippingStateCode"]);
                            if (!$shippingInfo["validatedData"]["Statemenu"]["value"] && isset($shippingInfo["validatedData"]["Statetext"]["value"]))
                            {
                                $shippingInfo["validatedData"]["Statetext"]["value"] = $response["ShippingStateCode"];
                            }
                        }
                        if (isset($shippingInfo["validatedData"]["City"]["value"]))
                        {
                            $shippingInfo["validatedData"]["City"]["value"] = $response["ShippingCity"];
                        }
                        if (isset($shippingInfo["validatedData"]["Streetline1"]["value"]))
                        {
                            $shippingInfo["validatedData"]["Streetline1"]["value"] = $response["ShippingStreetline1"];
                        }
                        if (isset($shippingInfo["validatedData"]["Streetline2"]["value"]))
                        {
                            $shippingInfo["validatedData"]["Streetline2"]["value"] = $response["ShippingStreetline2"];
                        }
                        modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "shippingInfo", "default", false, "", array(), $shippingInfo["validatedData"]);

                        $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
                        $paymentModule["validatedData"]["method_code"]["value"] = modApiFunc("Payment_Module_PaypalPro_CC", "getUid");
                        modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", true, "", array(), $paymentModule["validatedData"]);
                    }
                    else
                    {
                        $billingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo");
                        modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "billingInfo", "default", false, "", array(), $billingInfo["validatedData"]);
                        $shippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
                        modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "shippingInfo", "default", false, "", array(), $shippingInfo["validatedData"]);
                    }
                    modApiFunc("Checkout", "saveState");
                    #redirect to current Checkout step
                    $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID");
                    $request = new Request();
                    $request->setView('CheckoutView');
                    $request->setAction("SetCurrStep");
                    $request->setKey   ('step_id', $step_id_to_redirect_to);
                    $application->redirect($request);
                }
            }
            else
            {
                #: it is unknown, if such condition is possible and what to do in it
            }
        }
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */


    /**#@-*/

}
?>