<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

//: move "defines" to member variables
define("PAYPALPRO_URL_TEST", "https://www.sandbox.paypal.com/cgi-bin/webscr");
//define("PAYPAL_NOTIFY_URL_TEST", "https://www.sandbox.paypal.com");
define("PAYPALPRO_SOCKET_TEST", "www.sandbox.paypal.com");
define("PAYPALPRO_API_URL_TEST", "api.sandbox.paypal.com/2.0/");

define("PAYPALPRO_URL", "https://www.paypal.com/cgi-bin/webscr");
//define("PAYPAL_NOTIFY_URL", "https://www.paypal.com");
define("PAYPALPRO_SOCKET", "www.paypal.com");
define("PAYPALPRO_API_URL", "api.paypal.com/2.0/");
define("PAYPALPRO_SIG_API_URL", "api-3t.paypal.com/2.0/");

/**
 *
 * @package PaymentModulePaypalProCC
 * @author Alexander Girin
 */
class Payment_Module_PaypalPro_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CZK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HUF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'PLN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
            )
        );
        return $res;
    }

    /**
     * PaymentModulePaypalPro constructor.
     */
    function Payment_Module_PaypalPro_CC()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-paypalpro-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->paymentMethod = "";

        $this->ExpessCheckoutData = array();

        $this->CCInfo = array();

        $this->response = array();

        $this->OrderHistoryMessageTag = $this->MessageResources->getMessage('MODULE_PAYMENT_PAYPALPRO_IPN_LOG_MODULE_ID') . $info["GlobalUniquePaymentModuleID"] . "\n" . $this->Settings["MODULE_NAME"];
    }

    /**
     * Restores the module state from the session.
     */
    function loadState()
    {
        global $zone;
        if ($zone == "CustomerZone")
        {
            if(modApiFunc('Session', 'is_Set', 'PayPalPro_response'))
            {
                $this->response = modApiFunc('Session', 'get', 'PayPalPro_response');
            }
            if(modApiFunc('Session', 'is_Set', 'PayPalPro_paymentMethod'))
            {
                $this->paymentMethod = modApiFunc('Session', 'get', 'PayPalPro_paymentMethod');
            }
            if(modApiFunc('Session', 'is_Set', 'PayPalPro_ExpessCheckoutData'))
            {
                $this->ExpessCheckoutData = modApiFunc('Session', 'get', 'PayPalPro_ExpessCheckoutData');
            }
        }
    }

    /**
     * Saves the module state.
     */
    function saveState()
    {
        global $zone;
        if ($zone == "CustomerZone")
        {
            if (sizeof($this->response))
            {
                modApiFunc('Session', 'set', 'PayPalPro_response', $this->response);
            }
            elseif (modApiFunc('Session', 'is_Set', 'PayPalPro_response'))
            {
                modApiFunc('Session', 'un_Set', 'PayPalPro_response');
            }
            if ($this->paymentMethod)
            {
                modApiFunc('Session', 'set', 'PayPalPro_paymentMethod', $this->paymentMethod);
            }
            elseif (modApiFunc('Session', 'is_Set', 'PayPalPro_paymentMethod'))
            {
                modApiFunc('Session', 'un_Set', 'PayPalPro_paymentMethod');
            }
            if (sizeof($this->ExpessCheckoutData))
            {
                modApiFunc('Session', 'set', 'PayPalPro_ExpessCheckoutData', $this->ExpessCheckoutData);
            }
            elseif (modApiFunc('Session', 'is_Set', 'PayPalPro_ExpessCheckoutData'))
            {
                modApiFunc('Session', 'un_Set', 'PayPalPro_ExpessCheckoutData');
            }
        }
    }


    function gettime()
    {
        return $this->MessageResources->getMessage('MODULE_PAYMENT_PAYPALPRO_IPN_LOG_EVENT_TIME') . modApiFunc("Localization", "timestamp_date_format", time())." ". modApiFunc("Localization", "timestamp_time_format", time());
    }

    function setPaymentMethod($method)
    {
        $this->paymentMethod = $method;
    }

    function getPaymentMethod()
    {
        return $this->paymentMethod;
    }

    function setExpessCheckoutData($field, $value)
    {
        $this->ExpessCheckoutData[$field] = $value;
    }

    function getExpessCheckoutData($field = "")
    {
        if ($field && isset($this->ExpessCheckoutData[$field]))
        {
            return $this->ExpessCheckoutData[$field];
        }
        else
        {
            return $this->ExpessCheckoutData;
        }
    }

    function clearPayPalProSession()
    {
        $this->paymentMethod = "";
        $this->ExpessCheckoutData = array();
        $this->response = array();
        $this->SaveState();
    }

    function clearResponseErrors()
    {
        if (isset($this->response["Errors"]["ErrorCode"]))
        {
            $this->response["Errors"]["ErrorCode"] = "";
        }
        if (isset($this->response["Errors"]["ShortMessage"]))
        {
            $this->response["Errors"]["ShortMessage"] = "";
        }
        if (isset($this->response["Errors"]["LongMessage"]))
        {
            $this->response["Errors"]["LongMessage"] = "";
        }
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-paypalpro-messages", "AdminZone");

        $tables = Payment_Module_PaypalPro_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_paypalpro_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];  #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("EXPRESS_CHECKOUT_METHOD_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('EXPRESS_CHECKOUT_METHOD_NAME')).':"'.$obj->getMessage('EXPRESS_CHECKOUT_METHOD_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("DIRECT_PAYMENT_METHOD_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('DIRECT_PAYMENT_METHOD_NAME')).':"'.$obj->getMessage('DIRECT_PAYMENT_METHOD_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);
/*
        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_DESCR", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_DESCR')).':"'.$obj->getMessage('MODULE_DESCR').'";', $columns['value']);
        $application->db->getDB_Result($query);
*/
        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_API_CERTIFICATE", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_API_USERNAME", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(7, $columns['id']);
        $query->addInsertValue("MODULE_API_PASSWORD", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(8, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(9, $columns['id']);
        $query->addInsertValue("MODULE_CART", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(10, $columns['id']);
        $query->addInsertValue("MODULE_BILLING_PERSON_INFO_VARIANT", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(11, $columns['id']);
        $query->addInsertValue("MODULE_LOGO", $columns['key']);


        $s = "https://www.paypal.com/en_US/i/btn/btn_xpressCheckout.gif";
        $query->addInsertValue('s:'._ml_strlen($s).':"'.$s.'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(0, $columns['id']);
        $query->addInsertValue("MODULE_API_SIGNATURE", $columns['key']);
        $query->addInsertValue('s:1:"0";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_PaypalPro_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        PayPalPro                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-paypalpro-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_PAYPALPRO_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//        return "AC593800-68BA-A4D3-6A14-49BA5022FED7";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-paypalpro-messages", "AdminZone");

        $this->getSettings();

        global $zone;
        if ($zone == 'CustomerZone')
        {
            if ($this->paymentMethod == "ExpressCheckout")
            {
                $name = $this->Settings["EXPRESS_CHECKOUT_METHOD_NAME"];
            }
            else
            {
                $name = $this->Settings["DIRECT_PAYMENT_METHOD_NAME"];
            }
        }
        else
        {
            $name = $this->Settings["MODULE_NAME"];
        }

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $name,
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "paypalpro_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModulePaypalProCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModulePaypalProCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_paypalpro_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settins array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_paypalpro_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_paypalpro_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_paypalpro_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_paypalpro_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_paypalpro_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    function usesSignature()
    {
        $settings = $this->getSettings();
        return $settings["MODULE_API_SIGNATURE"] != "";
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.00 : number_format($price, 2, '.', '');
    }

    /**
     * Returns the 'derect' or 'redirect' payment method.
     */
    function getPaymentMode()
    {
        return "direct";
    }

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        //           -                     PersonInfo Variant'    -         /        ...
        if($prerequisite_type == "creditCardInfo")
        {
            //                   'PayPalPro_paymentMethod' = "ExpressCheckout"                           Checkout,
            //  . .                                  (step_id = 2)
            if(modApiFunc('Session', 'is_Set', 'PayPalPro_paymentMethod') && modApiFunc('Session', 'get', 'PayPalPro_paymentMethod') == "ExpressCheckout")
            {
                return false;
            }
            return "default";
        }
        else
        {
            return false;
        }
    }

    function backgroundProcess($type="doDirectPayment", $transactionData = null)
    {
        global $application;
        loadCoreFile('aal.class.php');

        if ($type == "doDirectPayment" && $this->paymentMethod == "ExpressCheckout")
        {
            $type = "doExpressCheckout";
        }

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currency = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);

        $_billingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo");
        $billingInfo = new ArrayAccessLayer($_billingInfo);
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $_shippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
        $shippingInfo = new ArrayAccessLayer($_shippingInfo);
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");
//        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId);

        $CCInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());
        //:                 $CCInfo             false.                                          .

        $Products = modApiFunc("Cart", "getCartContent", $currency_id);

        $tempOrderId = $this->getTempOrderId();

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("PayPalProUpdatePaymentStatus");
        $request->setKey("paypalpro_temp_oid", $tempOrderId);
        $Notify_URL = str_replace('&', '&amp;', $request->getURL("", true));


        $current_checkout_step = modApiFunc("Checkout", "getCurrentStepID");
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("SetCurrStep");
//        ?asc_action=SetCurrStep&step_id=2&previous_step_id=1&token=ldf;h;h
//                                            ?asc_action=SetCurrStep%7F=2%7F &amp;  s_step_id=1&token=ldf;h;h
//        $request->setKey('step_id', ($current_checkout_step+1));
//        $request->setKey('previous_step_id', $current_checkout_step);
        $Return_URL = str_replace('&', '&amp;', $request->getURL("", true));

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $Cancel_URL = str_replace('&', '&amp;', $request->getURL("", true));

        $this->getSettings();

        $gc = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalPrepaidByGC", $currency_id));
        $discount = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "DiscountsSum", $currency_id));
        $item_total = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Subtotal", $currency_id)) - $discount - $gc;
        if($item_total < 0) $item_total = 0;

        $DataFields = array
            (
                "PAYPAL_USERNAME"           => $this->Settings["MODULE_API_USERNAME"]
               ,"PAYPAL_PASSWORD"           => $this->Settings["MODULE_API_PASSWORD"]
               ,"PAYPAL_VERSION"            => '2.0'
               ,"PAYPAL_PAYMENT_ACTION"     => 'Sale'
               ,"PAYPAL_CURRENCY"           => $currency
               //,"PAYPAL_ORDER_TOTAL"        => number_format($this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currency_id)), 2, '.', ',')
               ,"PAYPAL_ORDER_TOTAL"        => number_format($this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalToPay", $currency_id)), 2, '.', ',')
               ,"PAYPAL_MAX_AMOUNT"         => number_format(10000, 2, '.', ',')
               ,"PAYPAL_ORDER_DESCRIPTION"  => modApiFunc("Configuration", "getValue", SYSCONFIG_STORE_OWNER_NAME)
               ,"PAYPAL_ITEM_TOTAL"         => number_format($item_total, 2, '.', ',')
               ,"PAYPAL_SHIPPING_TOTAL"     => number_format($this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "TotalShippingAndHandlingCost", $currency_id)), 2, '.', ',')
               ,"PAYPAL_HANDLING_TOTAL"     => ""
               ,"PAYPAL_TAX_TOTAL"          => number_format($this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "NotIncludedTax", $currency_id)), 2, '.', ',')
               ,"PAYPAL_CUSTOM"             => $billingInfo->getByMask('Firstname')." ".
                                               $billingInfo->getByMask('Lastname') ." ".
                                               ($billingInfo->getByMask('Email')? "&lt;".$billingInfo->getByMask('Email')."&gt;":"")." ".
                                               ($billingInfo->getByMask('Phone')? $_billingInfo["validatedData"]["Phone"]["view_tag"].": ".$billingInfo->getByMask('Phone'):"")
               ,"PAYPAL_INVOICE_ID"         => ""
               ,"PAYPAL_NOTIFY_URL"         => $Notify_URL
               # The next variables are for Express Checkout
               # Express Checkout Block Begin
               ,"PAYPAL_RETURN_URL"         => $Return_URL #Return URL for Express Checkout
               ,"PAYPAL_CANCEL_URL"         => $Cancel_URL #Cancel URL for Express Checkout
               ,"PAYPAL_REQUIRE_CONFIRM_SHIPPING" => '1' #:           settings
               ,"PAYPAL_NO_SHIPPING"        => '0'  #:           settings
               ,"PAYPAL_ADDRESS_OVERRIDE"   => $_shippingInfo['isMet']? '1':'0'  #:           settings,                  PAYPAL_NO_SHIPPING.      0,    1,      1,    0
               ,"PAYPAL_LOCALE_CODE"        => 'US' #:                              -
               ,"PAYPAL_PAGE_STYLE"         => ''   #:           settings
               ,"PAYPAL_CPP_HEADER_IMAGE"   => ''   #:           settings
               ,"PAYPAL_CPP_HEADER_BORDER_COLOR" => '' #:           settings
               ,"PAYPAL_CPP_HEADER_BACK_COLOR"   => '' #:           settings
               ,"PAYPAL_CPP_PAYFLOW_COLOR"       => '' #:           settings
//               ,"PAYPAL_NAME"                    => (isset($shippingInfo["validatedData"]["Firstname"]["value"])? $shippingInfo["validatedData"]["Firstname"]["value"]:"")
//                                               ." ".(isset($shippingInfo["validatedData"]["Lastname"]["value"])? $shippingInfo["validatedData"]["Lastname"]["value"]:"")
               ,"PAYPAL_TOKEN"              => isset($this->ExpessCheckoutData["token"])? $this->ExpessCheckoutData["token"]:""
               ,"PAYPAL_PAYER_ID"           => isset($this->ExpessCheckoutData["PayerID"])? $this->ExpessCheckoutData["PayerID"]:""
               # Express Checkout Block End
               ,"PAYPAL_BUTTON_SOURCE"      => ""
               ,"PAYPAL_SHIPPING_NAME"      => $shippingInfo->getByMask('Firstname')." ".$shippingInfo->getByMask('Lastname')
                                               #:                  PAYPAL_ADDRESS_OVERRIDE,      1,
               #:                                      Express Checkout,      PAYPAL_ADDRESS_OVERRIDE = 0
               #Begin
               ,"PAYPAL_SHIPPING_ADDRESS1"  => $shippingInfo->getByMask('Streetline1')
               ,"PAYPAL_SHIPPING_ADDRESS2"  => $shippingInfo->getByMask('Streetline2')
               ,"PAYPAL_SHIPPING_CITY"      => $shippingInfo->getByMask('City')
               ,"PAYPAL_SHIPPING_STATE"     => $shippingInfo->getByMask('Statemenu')? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')): $shippingInfo->getByMask('Statetext')
               ,"PAYPAL_SHIPPING_ZIP"       => $shippingInfo->getByMask('Postcode')
               ,"PAYPAL_SHIPPING_COUNTRY"   => $shippingInfo->getByMask('Country')? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')):""
               #End
               ,"PAYMENT_DETAILS_ITEM"      => ""
               ,"PAYPAL_BUYER_EMAIL"        => $billingInfo->getByMask('Email')
               ,"PAYPAL_FIRST_NAME"         => $billingInfo->getByMask('Firstname')
               ,"PAYPAL_LAST_NAME"          => $billingInfo->getByMask('Lastname')
               ,"PAYPAL_ADDRESS1"           => $billingInfo->getByMask('Streetline1')
               ,"PAYPAL_ADDRESS2"           => $billingInfo->getByMask('Streetline2')
               ,"PAYPAL_CITY"               => $billingInfo->getByMask('City')
               ,"PAYPAL_STATE"              => $billingInfo->getByMask('Statemenu')? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')): $billingInfo->getByMask('Statetext')
               ,"PAYPAL_ZIP"                => $billingInfo->getByMask('Postcode')
               ,"PAYPAL_COUNTRY"            => $billingInfo->getByMask('Country')? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')):""
               ,"PAYPAL_CC_TYPE"            => ($type=="doDirectPayment")? $CCInfo["CreditCardType"]["value"]:""
               ,"PAYPAL_CC_NUMBER"          => ($type=="doDirectPayment")? $CCInfo["CreditCardNumber"]["value"]:""
               ,"PAYPAL_CC_EXP_MONTH"       => ($type=="doDirectPayment")? $CCInfo["ExpirationMonth"]["value"]:""
               ,"PAYPAL_CC_EXP_YEAR"        => ($type=="doDirectPayment")? $CCInfo["ExpirationYear"]["value"]:""
               ,"PAYPAL_CC_CVV2"            => ($type=="doDirectPayment")? ($CCInfo["CreditCardVerificationNumber"]["value"]? $CCInfo["CreditCardVerificationNumber"]["value"]:""):""
               ,"PAYPAL_IP_ADDRESS"         => $_SERVER['REMOTE_ADDR']
               ,"PAYPAL_MERCHANT_SESSION_ID"=> session_id()

               ,"PAYPAL_SIGNATURE" => ""
            );

        if (false && $this->Settings['MODULE_CART'] == 1 && $discount == 0)
        {
            $output = '';
            foreach ($Products as $productInfo) {
                $output .= '<PaymentDetailsItem>';
                $output .= '<Name>' . prepareHTMLDisplay($productInfo["Name"]) . '</Name>';
                $output .= '<Amount currencyID="' . $currency . '">' . $productInfo["CartItemSalePrice"] . '</Amount>';
                $output .= '<Number>' . $productInfo['ID'] . '</Number>';
                $output .= '<Quantity>' . $productInfo["Quantity_In_Cart"] . '</Quantity>';
                /*                 -
                foreach ($productInfo["Options"] as $option_id => $option_val)
                {
                    $option_data = modApiFunc("Product_Options", "prepareDataForPlaceOrder", $option_id, $option_val);
                    $output .= '<Options>';
                    $output .= '<name>'.$option_data[0].'</name>';
                    $output .= '<value>'.$option_data[1].'</value>';
                    $output .= '</Options>';
                }
                */
                $output .= '</PaymentDetailsItem>';
            }
            $DataFields['PAYMENT_DETAILS_ITEM'] = $output;
        }

        if ($transactionData)
        {
            $DataFields = array_merge($DataFields, $transactionData);
        }

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/".$type.".xml");

    //===================================== logging start ========================================

        $xml_log_content = $xml_content;
        $log_data_fields = $DataFields;

        $log_data_fields['PAYPAL_CC_NUMBER'] = preg_replace("/[0-9]/", 'x', $log_data_fields['PAYPAL_CC_NUMBER']);
        $log_data_fields['PAYPAL_CC_EXP_MONTH'] = preg_replace("/[0-9]/", 'x', $log_data_fields['PAYPAL_CC_EXP_MONTH']);
        $log_data_fields['PAYPAL_CC_EXP_YEAR'] = preg_replace("/[0-9]/", 'x', $log_data_fields['PAYPAL_CC_EXP_YEAR']);
        $log_data_fields['PAYPAL_CC_CVV2'] = preg_replace("/[0-9]/", 'x', $log_data_fields['PAYPAL_CC_CVV2']);

        $xml_to_log = strtr($xml_log_content, $log_data_fields);

        $msgObj = $application->getInstance("MessageResources", "payment-module-paypalpro-messages", "AdminZone");
        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_"._ml_strtoupper($type)."_REQUEST"), prepareArrayDisplay($xml_to_log));

    //===================================== logging stop ========================================

        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $usesSignature = $this->usesSignature();
        $bnc->setURL('https://'.$this->getPayPalURL("API", $usesSignature));

        if ($usesSignature)
        {
            $DataFields["PAYPAL_SIGNATURE"] = "<Signature>".$this->Settings["MODULE_API_SIGNATURE"]."</Signature>";

        }
        else
        {
           $bnc->setSSLcert($this->Settings['MODULE_API_CERTIFICATE']);
        }

        $bnc->setPOSTstring(strtr($xml_content, $DataFields));
        $result = $bnc->RunRequest();

    //===================================== logging start ========================================

        $this->addRequestLog("LOG_PM_INPUT", "Payment Module Logs", $msgObj->getMessage("MODULE_PAYMENT_TIMELINE_HEADER_"._ml_strtoupper($type)."_RESPONSE"), prepareArrayDisplay($result));

    //===================================== logging stop ========================================

        $retval = true;
        if (isset($result['body']))
        {
            loadCoreFile('obj_xml.php');
            $xml = new xml_doc($result['body']);
            $xml->parse();

            //       XML         ,
            $response = array(
                              'Timestamp' => ''
                             ,'Ack' => ''
                             ,'Status' => ''
                             ,'CorrelationID' => ''
                             ,'Version' => ''
                             ,'Build' => ''
                             ,'Errors' => array('ShortMessage' => '', 'LongMessage' => '', 'ErrorCode' => '')
                             ,'Faultcode' => ''
                             ,'Faultstring' => ''
                             ,'Detail' => ''
                             ,'TransactionID' => ''
                             ,'Amount' => ''
                             ,'AVSCode' => array('AVSCode' => '', 'AVSMsg' => '')
                             ,'CVV2Code' => array('CVV2Code' => '', 'CVV2Msg' => '')
                             ,'Token' => ''
                             ,'TransactionID' => ''
                             ,'ParentTransactionID' => ''
                             ,'ReceiptID' => ''
                             ,'TransactionType' => ''
                             ,'PaymentType' => ''
                             ,'PaymentDate' => ''
                             ,'TaxAmount' => ''
                             ,'ExchangeRate' => ''
                             ,'PaymentStatus' => ''
                             ,'PendingReason' => ''
                             ,'ReasonCode' => ''
                             );
            if (is_object($xml->document))
            {
                foreach ($response as $tag => $val)
                {
                    if ($tag == 'Errors')
                    {
                        foreach ($response['Errors'] as $_tag => $_val)
                        {
                            $xml_tag = $xml->document->findChildRecursively($_tag);
                            if ($xml_tag != FALSE)
                            {
                                $response['Errors'][$_tag] = $xml_tag->contents;
                            }
                        }
                    }
                    elseif ($tag == 'AVSCode')
                    {
                        foreach ($response['AVSCode'] as $_tag => $_val)
                        {
                            $xml_tag = $xml->document->findChildRecursively($_tag);
                            if ($xml_tag != FALSE)
                            {
                                $response['AVSCode'][$_tag] = $xml_tag->contents;
                            }
                        }
                    }
                    elseif ($tag == 'CVV2Code')
                    {
                        foreach ($response['CVV2Code'] as $_tag => $_val)
                        {
                            $xml_tag = $xml->document->findChildRecursively($_tag);
                            if ($xml_tag != FALSE)
                            {
                                $response['CVV2Code'][$_tag] = $xml_tag->contents;
                            }
                        }
                    }
                    else
                    {
                        $xml_tag = $xml->document->findChildRecursively($tag);
                        if ($xml_tag != FALSE)
                        {
                            $response[$tag] = $xml_tag->contents;
                        }
                    }
                }

                if ($type == "getExpressCheckoutDetails")
                {
                    $xml_tag = $xml->document->findChildRecursively('Payer');
                    if ($xml_tag != FALSE)
                    {
                        $response['BillingEmail'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('PayerID');
                    if ($xml_tag != FALSE)
                    {
                        $response['PayerID'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('PayerStatus');
                    if ($xml_tag != FALSE)
                    {
                        $response['PayerStatus'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('Salutation');
                    if ($xml_tag != FALSE)
                    {
                        $response['Salutation'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('Firstname');
                    if ($xml_tag != FALSE)
                    {
                        $response['BillingFirstname'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('Middlename');
                    if ($xml_tag != FALSE)
                    {
                        $response['BillingMiddlename'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('Lastname');
                    if ($xml_tag != FALSE)
                    {
                        $response['BillingLastname'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('Suffix');
                    if ($xml_tag != FALSE)
                    {
                        $response['Suffix'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('PayerCountry');
                    if ($xml_tag != FALSE)
                    {
                        $response['BillingCountry'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('PayerBusiness');
                    if ($xml_tag != FALSE)
                    {
                        $response['PayerBusiness'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('Name');
                    if ($xml_tag != FALSE)
                    {
                        $name = $xml_tag->contents;
                        if (!(_ml_strpos($name, " ") === false))
                        {
                            $firstname = _ml_substr($name, 0, _ml_strrpos($name, " "));
                            $lastname = _ml_substr($name, (_ml_strrpos($name, " ")+1));
                        }
                        else
                        {
                            $firstname = "";
                            $lastname = $name;
                        }
                        $response['ShippingFirstname'] = $firstname;
                        $response['ShippingLastname'] = $lastname;
                    }
                    $xml_tag = $xml->document->findChildRecursively('Street1');
                    if ($xml_tag != FALSE)
                    {
                        $response['ShippingStreetline1'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('Street2');
                    if ($xml_tag != FALSE)
                    {
                        $response['ShippingStreetline2'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('CityName');
                    if ($xml_tag != FALSE)
                    {
                        $response['ShippingCity'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('StateOrProvince');
                    if ($xml_tag != FALSE)
                    {
                        $response['ShippingStateCode'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('Country');
                    if ($xml_tag != FALSE)
                    {
                        $response['ShippingCountryCode'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('CountryName');
                    if ($xml_tag != FALSE)
                    {
                        $response['ShippingCountry'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('PostalCode');
                    if ($xml_tag != FALSE)
                    {
                        $response['ShippingPostcode'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('CountryName');
                    if ($xml_tag != FALSE)
                    {
                        $response['ShippingCountry'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('AddressOwner');
                    if ($xml_tag != FALSE)
                    {
                        $response['AddressOwner'] = $xml_tag->contents;
                    }
                    $xml_tag = $xml->document->findChildRecursively('AddressStatus');
                    if ($xml_tag != FALSE)
                    {
                        $response['AddressStatus'] = $xml_tag->contents;
                    }
                }
            }
            else
            {
                $response['Errors'] = array('ShortMessage' => '', 'LongMessage' => '', 'ErrorCode' => '');
                $response['Errors']['LongMessage'] = $this->MessageResources->getMessage("UNKNOWN_ERROR");
            }
        }
        else
        {
            $response['Errors'] = array('ShortMessage' => '', 'LongMessage' => '', 'ErrorCode' => '');
            $response['Errors']['LongMessage'] = $bnc->getLastErrorMessage();
        }

        $this->setResponse($response);
        $this->SaveState();

        switch ($type)
        {
            case "doExpressCheckout":
            case "doDirectPayment":

                $DataFields = array
                    (
                        "Status"                => isset($response["Ack"])? $response["Ack"]:"CustomCode"
                       ,"Timestamp"             => isset($response['Timestamp'])? $response['Timestamp']:time()
                       ,"CorrelationID"         => isset($response['CorrelationID'])? $response['CorrelationID']:""
                       ,"ErrorCode"             => isset($response['Errors'])? $response['Errors']['ErrorCode']:""
                       ,"ErrorShortMessage"     => isset($response['Errors'])? $response['Errors']['ShortMessage']:""
                       ,"ErrorLongMessage"      => isset($response['Errors'])? $response['Errors']['LongMessage']:""
                       ,"Version"               => isset($response['Version'])? $response['Version']:""
                       ,"Build"                 => isset($response['Build'])? $response['Build']:""
                       ,"TransactionID"         => isset($response['TransactionID'])? $response['TransactionID']:""
                       ,"ParentTransactionID"   => isset($response['ParentTransactionID'])? $response['ParentTransactionID']:""
                       ,"Amount"                => isset($response['Amount'])? $response['Amount']:""
                       ,"AVSCode"               => isset($response['AVSCode'])? $response['AVSCode']['AVSCode']:""
                       ,"CVV2Code"              => isset($response['CVV2Code'])? $response['CVV2Code']['CVV2Code']:""
                       ,"Faultcode"             => isset($response['Faultcode'])? $response['Faultcode']:""
                       ,"Faultstring"           => isset($response['Faultstring'])? $response['Faultstring']:""
                       ,"Detail"                => isset($response['Detail'])? $response['Detail']:""
                       ,"Token"                 => isset($response['Token'])? $response['Token']:""
                       ,"ReceiptID"             => isset($response['ReceiptID'])? $response['ReceiptID']:""
                       ,"TransactionType"       => isset($response['TransactionType'])? $response['TransactionType']:""
                       ,"PaymentType"           => isset($response['PaymentType'])? $response['PaymentType']:""
                       ,"PaymentDate"           => isset($response['PaymentDate'])? $response['PaymentDate']:""
                       ,"TaxAmount"             => isset($response['TaxAmount'])? $response['TaxAmount']:""
                       ,"ExchangeRate"          => isset($response['ExchangeRate'])? $response['ExchangeRate']:""
                       ,"PaymentStatus"         => isset($response['PaymentStatus'])? $response['PaymentStatus']:""
                       ,"PendingReason"         => isset($response['PendingReason'])? $response['PendingReason']:""
                       ,"ReasonCode"            => isset($response['ReasonCode'])? $response['ReasonCode']:""
                    );

                if (!$DataFields["ErrorCode"] && !$DataFields["ErrorShortMessage"] && !$DataFields["ErrorLongMessage"])
                {
                    //Create order
                    $order_id = modApiFunc("Checkout", "createOrderInDB");
                    //Session update.
                    //Remove all product info.
                    modApiFunc("Cart", "removeAllFromCart");
                    $this->processData(array("_POST" => $DataFields, "_GET" => array()), $order_id);
                    $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
                }
                else
                {
                    $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
                    modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "CHECKOUT_ERR_005", array(), $paymentModule["validatedData"]);
                    $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
                    modApiFunc("Checkout", "saveState");
                }

                $request = new Request();
                $request->setView('CheckoutView');
                $request->setAction("SetCurrStep");
                $request->setKey   ( 'step_id', $step_id_to_redirect_to);
                $application->redirect($request);
                break;
        }

        return true;
    }

    function getPayPalURL($type="", $usesSignature=false)
    {
        if ($type == "API")
        {
            return $this->Settings['MODULE_MODE'] == 1 ? PAYPALPRO_API_URL_TEST : ($usesSignature ? PAYPALPRO_SIG_API_URL : PAYPALPRO_API_URL);
        }
        else
        {
            return $this->Settings['MODULE_MODE'] == 1 ? PAYPALPRO_URL_TEST : PAYPALPRO_URL;
        }
    }

    function setResponse($response)
    {
        $this->response = $response;
    }

    function getResponse()
    {
        return $this->response;
    }

    function un_setResponse()
    {
        $this->response = array();
        if (modApiFunc('Session', 'is_Set', 'PayPalPro_response'))
        {
            modApiFunc('Session', 'un_Set', 'PayPalPro_response');
        }
    }

    function getTempOrderId()
    {
        if (modApiFunc('Session', 'is_Set', 'PayPalPro_tempOrderId'))
        {
            return modApiFunc('Session', 'get', 'PayPalPro_tempOrderId');
        }
        else
        {
            global $application;
            $tables =  $this->getTables();

            $table = 'pm_paypalpro_temp_orders';
            $columns = $tables[$table]['columns'];

            $query = new DB_Insert($table);
            $query->addInsertValue("", $columns['o_id']);
            $application->db->getDB_Result($query);

            $tempOrderId = $application->db->DB_Insert_Id();
            modApiFunc('Session', 'set', 'PayPalPro_tempOrderId', $tempOrderId);
            return $tempOrderId;
        }
    }

    function unSetTempOrderId()
    {
        if (modApiFunc('Session', 'is_Set', 'PayPalPro_tempOrderId'))
        {
            modApiFunc('Session', 'un_Set', 'PayPalPro_tempOrderId');
        }
    }

    function processIPNnotify($data=null, $order_id=null)
    {
        global $application;
        $tables =  $this->getTables();

        if ($data)
        {
            $tempOrderId = $data['_GET']['paypalpro_temp_oid'];

            $table = 'pm_paypalpro_temp_order_data';
            $columns = $tables[$table]['columns'];

            $query = new DB_Insert($table);
            $query->addInsertValue($tempOrderId, $columns['to_id']);
            $query->addInsertValue(serialize($data), $columns['data']);
            $application->db->getDB_Result($query);
        }
        elseif ($order_id)
        {
            $tempOrderId = $this->getTempOrderId();
            $this->unSetTempOrderId();

            $table = 'pm_paypalpro_temp_orders';
            $columns = $tables[$table]['columns'];

            $query = new DB_Update($table);
            $query->addUpdateValue($columns['o_id'], $order_id);
            $query->WhereValue($columns["id"], DB_EQ, $tempOrderId);
            $application->db->getDB_Result($query);
        }
    }


    /**
     * Processes data on updating the order status come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process come from the payment gateway.
     */
    function processData($data, $order_id)
    {

        $DBPaymentStatus = array();
        $result = array();

        $msg = $this->OrderHistoryMessageTag . "\n" . $this->gettime() . "\n" . $this->MessageResources->getMessage('MODULE_PAYMENT_PAYPALPRO_IPN_LOG_EVENT_DESCRIPTION') ."\n";

        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $order_id, modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $order_id, $this->getUid()));

        $transactionData = array(
                                 "PAYPAL_START_DATE" => date('Y-m-d', mktime(0, 0, 0, date("m"), date("d")-1,  date("Y"))) . 'T00:00:00-0700'
                                ,"PAYPAL_PAYER"      => $orderInfo["Billing"]["attr"]["Email"]["value"]
                                //,"PAYPAL_AMOUNT"     => number_format($orderInfo["Total"], 2 , '.', ',')
                                ,"PAYPAL_AMOUNT"     => number_format($orderInfo["TotalToPay"], 2 , '.', ',')
                                );

//        $EventType = "ConfirmationSuccess";
        if ($this->backgroundProcess("transactionSearch", $transactionData))
        {
            $response = modApiFunc("Payment_Module_PaypalPro_CC", "getResponse");
            if (isset($response["TransactionID"]))
            {
                modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $response["TransactionID"]);
            }
            if (isset($response["Status"]) || isset($response["Ack"]))
            {
                if (isset($data["_POST"]["PaymentStatus"]) && $data["_POST"]["PaymentStatus"] == "Pending")
                {
                    $response["Status"] = $data["_POST"]["PaymentStatus"];
                }
                if (isset($response["Status"]))
                {
                    if ($response["Status"] == "Uncleared")
                    {
                        $response["Status"] = "Pending";
                    }
                }
                elseif (isset($response["Ack"]) && $response["Ack"] == "Success")
                {
                    $response["Status"] = "Completed";
                }
                $msg.= $this->MessageResources->getMessage('MODULE_PAYMENT_PAYPALPRO_LOG_PAYMENT_STATUS')." <b>".$response["Status"]."</b> - ".
                       $this->MessageResources->getMessage('PAYMENT_STATUS_'._ml_strtoupper($response["Status"]));

                if (isset($data["_POST"]["PendingReason"]) && $data["_POST"]["PendingReason"])
                {
                    $msg.= "\n".$this->MessageResources->getMessage('MODULE_PAYMENT_PAYPALPRO_LOG_PENDING_REASON')." <b>".$data["_POST"]["PendingReason"]."</b> - ".
                           $this->MessageResources->getMessage('PAYMENT_STATUS_PENDING_REASON_'._ml_strtoupper($data["_POST"]["PendingReason"]));
                }

                switch ($response["Status"])
                {
                    case "In-Progress":
                    case "Partially-Refunded":
                    case "Pending":
                    case "Reversed":
                    case "Uncleared":
                    case "Refunded":
                        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 1, $msg);
                        $EventType = "ConfirmationSuccess";
                        break;
                    case "Processed":
                    case "Completed":
                        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);
                        $EventType = "ConfirmationSuccess";
                        break;
                    case "None":
                    case "Canceled-Reversal":
                    case "Denied":
                    case "Expired":
                    case "Failed":
                    case "Voided":
                    case "CustomCode":
                        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
                        $EventType = "ConfirmationFailure";
                        break;
                    default:
                        $result = array("payment_status" => array());
                        $EventType = "ConfirmationFailure";
                        break;
                }
            }
            else
            {
                $msg.= $this->MessageResources->getMessage('MODULE_PAYMENT_PAYPALPRO_LOG_POST_DATA') . " \n " . print_r($data["_POST"], true);
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
                $EventType = "ConfirmationFailure";
            }
        }

        $this->processIPNnotify(null, $order_id);
        $this->clearPayPalProSession();
        return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_PaypalPro_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Returns the data array, used for creating a new Person Info variant in the database.
     * in the database.
     *
     * @param string $infoType  - person info type, e.g. 'billinginfo'
     * @param string $forMethod  - for each method, e.g. for 'ExpressCheckout'
     * @return
     */
    function setPersonInfoVariant($infoType, $forMethod)
    {
        switch ($infoType)
        {
            case "billingInfo":
                  $infoTypeId = 2;
                  $variant_to_attributes = array("Firstname" => 1, "Lastname" => 2, "Email" => 3);//, "Country" => 9);
                  foreach ($variant_to_attributes as $view_tag => $id)
                  {
                      $variant_to_attributes[$view_tag] = array("person_attribute_id" => $id
                                                               ,"person_attribute_visible_name" => $this->MessageResources->getMessage(_ml_strtoupper($forMethod).'_'.
                                                                                                                                       _ml_strtoupper($infoType).'_'.
                                                                                                                                       _ml_strtoupper($view_tag).'_NAME')
                                                               ,"person_attribute_description"  => $this->MessageResources->getMessage(_ml_strtoupper($forMethod).'_'.
                                                                                                                                       _ml_strtoupper($infoType).'_'.
                                                                                                                                       _ml_strtoupper($view_tag).'_DESCR')
                                                               ,"person_attribute_unremovable"  => 1
                                                               ,"person_attribute_visible"      => 1
                                                               ,"person_attribute_required"     => 1
                                                               ,"person_attribute_sort_order"   => $id
                                                               );
                  }
                  break;
            default:
                  $infoTypeId = 1;
                  $variant_to_attributes = array();
                  break;
        }
        $variantId = modApiFunc("Checkout", "insertPersonInfoVariant",
                                            $infoTypeId,
                                            "PayPalPro".$forMethod,
                                            $this->MessageResources->getMessage(_ml_strtoupper($forMethod).'_'._ml_strtoupper($infoType).'_NAME'),
                                            $this->MessageResources->getMessage(_ml_strtoupper($forMethod).'_'._ml_strtoupper($infoType).'_DESCR'),
                                            $this->MessageResources->getMessage(_ml_strtoupper($forMethod).'_'._ml_strtoupper($infoType).'_VISIBLE_NAME'),
                                            $variant_to_attributes);
        return array("id" => $variantId, "tag" => "PayPalPro".$forMethod);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_paypalpro_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_paypal_setting_id'
               ,'key'               => $settings.'.pm_paypal_setting_key'
               ,'value'             => $settings.'.pm_paypal_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        $temp_orders = 'pm_paypalpro_temp_orders';
        $tables[$temp_orders] = array();
        $tables[$temp_orders]['columns'] = array
            (
                'id'                => $temp_orders.'.pm_paypal_temp_order_id'
               ,'o_id'              => $temp_orders.'.order_id'
            );
        $tables[$temp_orders]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'o_id'              => DBQUERY_FIELD_TYPE_INT
            );
        $tables[$temp_orders]['primary'] = array
            (
                'id'
            );
        $tables[$temp_orders]['indexes'] = array
            (
                'IDX_oi' => 'o_id'
            );

        $temp_order_data = 'pm_paypalpro_temp_order_data';
        $tables[$temp_order_data] = array();
        $tables[$temp_order_data]['columns'] = array
            (
                'to_id'             => $temp_order_data.'.pm_paypal_temp_order_id'
               ,'data'              => $temp_order_data.'.pm_paypal_temp_order_data'
            );
        $tables[$temp_order_data]['types'] = array
            (
                'to_id'             => DBQUERY_FIELD_TYPE_INT
               ,'data'              => DBQUERY_FIELD_TYPE_TEXT
            );
        $tables[$temp_order_data]['indexes'] = array
            (
                'IDX_toi' => 'to_id'
            );

/*
        $keys = 'pm_paypalpro_keys';
        $tables[$keys] = array();
        $tables[$keys]['columns'] = array
            (
                's_id'             => $keys.'.pm_paypal_session_id'
               ,'key'              => $keys.'.pm_paypal_key'
            );
        $tables[$temp_order_data]['types'] = array
            (
                's_id'              => DBQUERY_FIELD_TYPE_CHAR50
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
            );
*/
        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;

    var $CCInfo;

    var $paymentMethod;
    /**#@-*/

}
?>