<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php


/**
 * This Hook is activated by action checkout 'SetCurrentStep'.
 *
 * PayPal Pro Express Checkout                        :
 * 1. SetExpressCheckout
 * 2. GetExpressCheckoutDetails
 * 3. DoExpressCheckoutPayment
 *
 *                                      hook,                  backgroundProcess().
 *
 * @package PaymentModulePaypalPro_UKCC
 * @author Ravil Garafutdinov
 */
class PaypalPro_UKHook
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * NewOrder constructor.
     */
    function PaypalPro_UKHook()
    {
    }

    /**
     *
     */
    function onHook()
    {
        global $application;
        $current_request = &$application->getInstance("Request");

        /**
         *                            ,                                                     PaypalPro_UK
         *
         *                              ,       PersonInfo Variant      ;
         *      PaypalPro_UKExpressCheckout,                     default
         *
         */
        $paymentModule = $current_request->getValueByKey("paymentModule");
        if ($paymentModule)
        {
            if ($paymentModule["method_code"] != modApiFunc("Payment_Module_PaypalPro_UK_CC", "getUid"))
            {
                $billingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo");
                if ($billingInfo["variant_tag"] == "PaypalPro_UKExpressCheckout")
                {
                    modApiFunc("Checkout", "changeCurrentPersonInfoVariant", "billingInfo" , "default");
                }
                if (modApiFunc("Payment_Module_PaypalPro_UK_CC", "getPaymentMethod") == "ExpressCheckout")
                {
                    modApiFunc("Payment_Module_PaypalPro_UK_CC", "setPaymentMethod", "DirectPayment");
                    modApiFunc("Payment_Module_PaypalPro_UK_CC", "SaveState");
                }
            }
            else // check if we need to do 3D-Secure for Maestro cards
            {
                $step_id = $current_request->getValueByKey('step_id');
                $prev_step_id = $current_request->getValueByKey('previous_step_id');
                if ($step_id == 3 && $prev_step_id == 2)
                {
                    $decision = 'goto_ups_standard';
                    $settings = modApiFunc("Payment_Module_PaypalPro_UK_CC", "getSettings");
                    $cardInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", modApiFunc("Payment_Module_PaypalPro_UK_CC", "getUid"));

                    $rlt_eciflag = false;
                    $rlt_url = false;
                    $rlt_payload = false;
                    $rlt_err = false;
                    $rlt_errdesc = false;

                    $cardType = $cardInfo['CreditCardType']['value'];

                    $ccInfoPost = $current_request->getValueByKey("creditCardInfoC92C5FAF_D946_453A_A72C_FEEEE54F417D");

                    if (isset($ccInfoPost['CreditCardType']))
                    {
                        $cardType = $ccInfoPost['CreditCardType'];
                    }


                    // check if the 3D-Secure check is enabled and if the card is of the proper type
                    if ($settings['MODULE_3DS_ENABLE'] == '1'       // used Visa for testing purposes, Maestro for live
                        && ($cardType == 'Maestro'))
                    {
                        // do cmpi_lookup
                //        modApiFunc("Payment_Module_PaypalPro_UK_CC", "unset3dsValues");
                        $dsRlt = modApiFunc("Payment_Module_PaypalPro_UK_CC", "do3DSCmpiLookup", $ccInfoPost);



                        if ($dsRlt !== false) // if the result is live
                        {
                            $rlt_err = $dsRlt['ErrorNo'];
                            $rlt_errdesc = $dsRlt['ErrorDesc'];
                            $rlt_url = $dsRlt['ACSUrl'];
                            $rlt_payload = $dsRlt['Payload'];
                            $rlt_eciflag = $dsRlt['EciFlag'];

                            if (isset($dsRlt['TransactionId']))
                            {
                                modApiFunc("Payment_Module_PaypalPro_UK_CC", "set3dsValues", 'trx_id', $dsRlt['TransactionId']);
                            }
                            if (isset($dsRlt['Enrolled']))
                            {
                                modApiFunc("Payment_Module_PaypalPro_UK_CC", "set3dsValues", 'Enrolled', $dsRlt['Enrolled']);
                            }
                            if ($rlt_eciflag)
                            {
                                modApiFunc("Payment_Module_PaypalPro_UK_CC", "set3dsValues", 'EciFlag', $rlt_eciflag);
                            }

                            if ($rlt_err !== '0' || $rlt_url === false)
                            {
                                $decision = 'goto_ups_failure';
                            }
                            else if ($dsRlt['Enrolled'] !== 'Y') // Y: Enrolled, N: Not enrolled, U: Cardholder authentication unavailable.
                            {
							    $decision = 'goto_ups_standard';
                            }
                            else
                            {
							    $decision = 'goto_url';
                            }
                        }
                        else // say we do not need any checks
                        {

                            $decision = 'goto_ups_standard';
                        }
                    }
					else
					{
					}

                    switch ($decision)
                    {
                        case 'goto_url': // perform a 3D-Secure check

                            $request = new Request();
                            $request->setView(CURRENT_REQUEST_URL);
                            $request->setAction("SetCurrStep");
                            $request->setKey('CHECKOUT_CZ_BLOWFISH_KEY', $current_request->getValueByKey("CHECKOUT_CZ_BLOWFISH_KEY"));
                            $request->setKey('step_id', 3);

//                            $returnUrl = str_replace('&', '&amp;', $request->getURL());
                            $returnUrl = $request->getURL();

                        //================================ logging ===============================

                            $msg_to_log = array(
                                     "Bank URL" => $rlt_url
                                    ,"PaReq"    => $rlt_payload
                                    ,"TermUrl"  => $returnUrl
                                    ,"MD"       => ''
                                );

                            modApiFunc('Payment_Module_PaypalPro_UK_CC', 'addRequestLog', "LOG_PM_OUTPUT", "Payment Module Logs", getxmsg('PM_PPP_UK_CC', "MODULE_PAYMENT_TIMELINE_HEADER_CMPI_REDIRECT_REQUEST"), prepareArrayDisplay($msg_to_log));

                        //================================ logging ===============================

                            echo '<html><head><title>Redirect for Maestro 3D-Secure check</title></head><body onLoad="document.getElementById(\'form_id\').submit();">';
                            echo "<form id='form_id' method='POST' action='$rlt_url'>";
                            echo "<input type='hidden' name='PaReq' value='$rlt_payload'>";
                            echo "<input type='hidden' name='TermUrl' value='$returnUrl'>";
                            echo "<input type='hidden' name='MD' value=''>";
                            echo '</body></html>';

                            die;

                        case 'goto_ups_standard': // do nothing, just proceed as usual

                        //================================ logging ===============================

                            modApiFunc('Payment_Module_PaypalPro_UK_CC', 'addRequestLog', "LOG_PM_OUTPUT", "Payment Module Logs", getxmsg('PM_PPP_UK_CC', "MODULE_PAYMENT_TIMELINE_HEADER_CARD_NOT_ENROLLED"), prepareArrayDisplay($_SESSION));

                        //================================ logging ===============================

                            break;

                        case 'goto_ups_failure': // failure, return to the 2nd step
                        default:

                            $msg = getxmsg('PM_PPP_UK_CC', 'MODULE_ERROR_3D_SECURE_GENERAL_ERROR');
                            if ($rlt_errdesc)
                            {
                                $msg .= "<br />" . $rlt_errdesc;
                            }
                            modApiFunc('Session', 'set', 'PaypalProUKErrorMessage', $msg);

                            $request = new Request();
                            $request->setView('CheckoutView');
                            $request->setAction("SetCurrStep");
                            $request->setKey   ('step_id', 2);
                            $request->setKey   ('CHECKOUT_CZ_BLOWFISH_KEY', $current_request->getValueByKey("CHECKOUT_CZ_BLOWFISH_KEY"));
                            $application->redirect($request);

                            break;
                    }
                }
            }
        }

    //                                  ,
    //                            PaRes, step_id == 3
    // check for 3D-Secure customer who's coming back after authorization
        $pares = $current_request->getValueByKey("PaRes");
        $step_id = $current_request->getValueByKey('step_id');
        if ($pares && $step_id == 3)
        {
        //================================ logging ===============================

            modApiFunc('Payment_Module_PaypalPro_UK_CC', 'addRequestLog', "LOG_PM_OUTPUT", "Payment Module Logs", getxmsg('PM_PPP_UK_CC', "MODULE_PAYMENT_TIMELINE_HEADER_CMPI_REDIRECT_RESPONSE"), prepareArrayDisplay($_POST));

        //================================ logging ===============================

            modApiFunc("Payment_Module_PaypalPro_UK_CC", "set3dsValues", 'PaRes', $pares);
        }

    // this condition works, when a customer presses the Express Checkout button,
    // i.e. it sends a request to the PayPal server and redirects the customer to the PayPal site on success
    //
    //     Microsoft Internet Explorer
        $paymentModule = $current_request->getValueByKey("PaypalProUKExpressCheckout");
        if (!$paymentModule)
        {
            $paymentModule = $current_request->getValueByKey("PaypalProUKExpressCheckout_x");
            if (!$paymentModule)
            {
                $paymentModule = $current_request->getValueByKey("PaypalProUKExpressCheckout_y");
                if ($paymentModule)
                {
                    $paymentModule = "doPaypalProUKExpressCheckout";
                }
            }
            else
            {
                $paymentModule = "doPaypalProUKExpressCheckout";
            }
        }

        /**
         *        Express Checkout -                          ,
         *                       PayPal           .
         *                                 -
         *                                    PayPal.
         *                                  -              1.
         */
        if ($paymentModule == "doPaypalProUKExpressCheckout")
        {
            // define the step, where the button Express Checkout was pressed and specify that step- Checkout CurrentStepID
            $settings = modApiFunc("Payment_Module_PaypalPro_UK_CC", "getSettings");
            $billingInfo = modApiFunc("Checkout", "getValidatedDataStructure", "billingInfo", $settings["MODULE_BILLING_PERSON_INFO_VARIANT"]["tag"]);
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "billingInfo", $settings["MODULE_BILLING_PERSON_INFO_VARIANT"]["tag"], false, "", array(), $billingInfo);
            modApiFunc("Checkout", "ProcessNewStepID", 1);

            $response = modApiFunc("Payment_Module_PaypalPro_UK_CC", "setExpressCheckoutRequest");

            if ($response != false)
            {
                if (isset($response["Result"]) && $response["Result"] == 0 && isset($response["Token"]) && $response["Token"] != '')
                {
                    modApiFunc("Payment_Module_PaypalPro_UK_CC", "setExpessCheckoutData", "token", $response["Token"]);
                    modApiFunc("Payment_Module_PaypalPro_UK_CC", "SaveState");
                    $url = ($settings["MODULE_MODE"] == 1) ? $settings["ECHECKOUT_URL_TEST"] : $settings["ECHECKOUT_URL_LIVE"];
                    $request = new Request($url.$response['Token']);
                    $application->redirect($request);
                }
                else
                {
                    $request = new Request();
                    $request->setView('CheckoutView');
                    $request->setAction("SetCurrStep");
                    $request->setKey   ('step_id', 1);//(modApiFunc("Checkout", "getCurrentStepID")));
                    $application->redirect($request);
                }
            }
            else
            {
                $request = new Request();
                $request->setView('CheckoutView');
                $request->setAction("SetCurrStep");
                $request->setKey   ('step_id', 1);//modApiFunc("Checkout", "getCurrentStepID"));
                $application->redirect($request);
            }
        }

        // this condition works, when a customer is back from the Paypal site
        /**
         *                      PayPal,         $_GET               payer_ID.
         *                         (                                      ),
         *                                     getExpressCheckoutDetails.
         *         -               ,                 billingInfo   shippingInfo.
         */
        if (($token = $current_request->getValueByKey("token")) && ($PayerID = $current_request->getValueByKey("PayerID")))
        {
            if ($token == modApiFunc("Payment_Module_PaypalPro_UK_CC", "getExpessCheckoutData", "token")
                && $PayerID != "")
            {
                modApiFunc("Payment_Module_PaypalPro_UK_CC", "setExpessCheckoutData", "PayerID", $PayerID);
                modApiFunc("Payment_Module_PaypalPro_UK_CC", "setPaymentMethod", "ExpressCheckout");
                modApiFunc("Payment_Module_PaypalPro_UK_CC", "SaveState");

                $response = modApiFunc("Payment_Module_PaypalPro_UK_CC", "getExpressCheckoutDetailsRequest", $token);
                if ($response != false)
                {
                    if (isset($response["Result"]) && $response["Result"] == 0)
                    {
                        // Override Billing Info with data received from Express Checkout.
                        $Settings = modApiFunc("Payment_Module_PaypalPro_UK_CC", "getSettings");
                        $billingInfo = modApiFunc("Checkout", "getValidatedDataStructure", "billingInfo", $Settings["MODULE_BILLING_PERSON_INFO_VARIANT"]["tag"]);
                        foreach ($billingInfo as $rerequisiteItemKey => $rerequisiteItemData)
                        {
                            switch ($rerequisiteItemKey)
                            {
                                case "Firstname":
                                    $billingInfo["Firstname"]["value"] = $response["Name"];
                                    break;

                                case "Lastname":
                                    $billingInfo["Lastname"]["value"] = $response["ExtData"]["VALUE"];
                                    break;

                                case "Email":
                                    $billingInfo["Email"]["value"] = $response["EMail"];
                                    break;

                                default:
                                    break;
                            }
                        }
                        modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "billingInfo", $Settings["MODULE_BILLING_PERSON_INFO_VARIANT"]["tag"], false, "", array(), $billingInfo);

                        #Override Shipping Info with data received from Express Checkout.
                        $shippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
                        if (isset($shippingInfo["validatedData"]["Firstname"]["value"]) && isset($response["Name"]))
                        {
                            $shippingInfo["validatedData"]["Firstname"]["value"] = $response["Name"];
                        }
                        if (isset($shippingInfo["validatedData"]["Lastname"]["value"]) && isset($response["ExtData"]["VALUE"]))
                        {
                            $shippingInfo["validatedData"]["Lastname"]["value"] = $response["ExtData"]["VALUE"];
                        }
                        if (isset($shippingInfo["validatedData"]["Email"]["value"]) && isset($response["EMail"]))
                        {
                            $shippingInfo["validatedData"]["Email"]["value"] = $response["EMail"];
                        }
                        if (isset($shippingInfo["validatedData"]["Country"]["value"]) && isset($response["Country"]))
                        {
                            $shippingInfo["validatedData"]["Country"]["value"] = modApiFunc("Location", "getCountryIdByCountryCode", $response["Country"]);
                        }
                        if (isset($shippingInfo["validatedData"]["Postcode"]["value"]) && isset($response["Zip"]))
                        {
                            $shippingInfo["validatedData"]["Postcode"]["value"] = $response["Zip"];
                        }
                        if (isset($shippingInfo["validatedData"]["City"]["value"]) && isset($response["City"]))
                        {
                            $shippingInfo["validatedData"]["City"]["value"] = $response["City"];
                        }
                        if (isset($shippingInfo["validatedData"]["Streetline1"]["value"]) && isset($response["Street"]))
                        {
                            $shippingInfo["validatedData"]["Streetline1"]["value"] = $response["Street"];
                        }
                        if (isset($shippingInfo["validatedData"]["Streetline2"]["value"]) && isset($response["ShippingStreetline2"]))
                        {
                            $shippingInfo["validatedData"]["Streetline2"]["value"] = $response["ShippingStreetline2"];
                        }
                        modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "shippingInfo", "default", false, "", array(), $shippingInfo["validatedData"]);

                        $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
                        $paymentModule["validatedData"]["method_code"]["value"] = modApiFunc("Payment_Module_PaypalPro_UK_CC", "getUid");
                        modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", true, "", array(), $paymentModule["validatedData"]);
                    }
                    else
                    {
                        $billingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo");
                        modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "billingInfo", "default", false, "", array(), $billingInfo["validatedData"]);
                        $shippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
                        modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "shippingInfo", "default", false, "", array(), $shippingInfo["validatedData"]);
                    }
                    modApiFunc("Checkout", "saveState");

                // redirect to current Checkout step
                    $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID");
                    $request = new Request();
                    $request->setView('CheckoutView');
                    $request->setAction("SetCurrStep");
                    $request->setKey   ('step_id', $step_id_to_redirect_to);
                    $application->redirect($request);
                }
            }
            else
            {
                #: it is unknown, if such condition is possible and what to do in it
            }
        }
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */


    /**#@-*/

}
?>