<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

define("PROTX_DIRECT_TRANSACTION_REGISTRATION_URL_VSP_SIMULATOR", "https://test.sagepay.com/VSPSimulator/VSPDirectGateway.asp");
define("PROTX_DIRECT_TRANSACTION_REGISTRATION_URL_TEST_SYSTEM", "https://test.sagepay.com/gateway/service/vspdirect-register.vsp");
define("PROTX_DIRECT_TRANSACTION_REGISTRATION_URL_LIVE_SYSTEM", "https://live.sagepay.com/gateway/service/vspdirect-register.vsp");

define("PROTX_DIRECT_3D_SECURE_CALLBACK_URL_VSP_SIMULATOR", "https://test.sagepay.com/VSPSimulator/VSPDirectCallback.asp");
define("PROTX_DIRECT_3D_SECURE_CALLBACK_URL_TEST_SYSTEM", "https://test.sagepay.com/gateway/service/direct3dcallback.vsp");
define("PROTX_DIRECT_3D_SECURE_CALLBACK_URL_LIVE_SYSTEM", "https://live.sagepay.com/gateway/service/direct3dcallback.vsp");



// A const with a protocol version should be "2.22" now.
define("PROTX_DIRECT_PROTOCOL_VER", "2.22");

/**
 * API is the Protx Direct payment module class.
 *
 * @package PaymentModuleProtxDirectCC
 * @author Egor Makarov
 */
class Payment_Module_Protx_Direct_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CZK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HUF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'PLN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }

    /**
     * Payment_Module_Protx_Direct_CC  constructor.
     */
    function Payment_Module_Protx_Direct_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources', modApiFunc("Modules_Manager","getResFileByShortName", 'PM_PXD'), 'AdminZone');
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->response = array();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_MODULE_ID') .
                $info["GlobalUniquePaymentModuleID"] . "\n" .
                $this->Settings["MODULE_NAME"];
    }


    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources', modApiFunc("Modules_Manager","getResFileByShortName", 'PM_PXD'), 'AdminZone');

        list($usec, $sec) = explode(" ", microtime());

        return $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $obj->getMessage('MODULE_PAYMENT_PROTX_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources', modApiFunc("Modules_Manager","getResFileByShortName", 'PM_PXD'), 'AdminZone');

        $tables = Payment_Module_Protx_Direct_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_protx_direct_settings';            #the name of the filled table
        $columns = $tables[$table]['columns'];        #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);
/*
        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_DESCR", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_DESCR')).':"'.$obj->getMessage('MODULE_DESCR').'";', $columns['value']);
        $application->db->getDB_Result($query);
*/
        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_VENDOR", $columns['key']);
        $query->addInsertValue('s:7:"Your ID";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(7, $columns['id']);
        $query->addInsertValue("MODULE_ALLOW_GIFT_AID", $columns['key']);
        $query->addInsertValue('s:1:"0";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(8, $columns['id']);
        $query->addInsertValue("MODULE_APPLY_AVSCV2", $columns['key']);
        $query->addInsertValue('s:1:"0";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(9, $columns['id']);
        $query->addInsertValue("MODULE_APPLY_3D_SECURE", $columns['key']);
        $query->addInsertValue('s:1:"0";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(10, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Protx_Direct_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_Protx_Direct_CC                    2 PersonInfoType' :
     * billingInfo
     * shippingInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = $obj = &$application->getInstance('MessageResources', modApiFunc("Modules_Manager","getResFileByShortName", 'PM_PXD'), 'AdminZone');
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_PROTX_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }

    /**
     * It is called by the Checkout module to know which CCInfo variant to
     * output to the CZ. If the function is not defined, then the additional
     * prerequisite CCInfo for the payment module won't be created while
     * cz checkout.
     *
     * If the payment gateway needs a specific CreditCardInfo variant, it can
     * create it itself, add it to the database, as PaypalPro does it and
     * return a tag matching this new variant within this function.
     */
    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        //If necessary, do actions with PersonInfo Variants - add/change...
        if($prerequisite_type == "creditCardInfo")
        {
            return "default";
        }
        else
        {
            return false;
        }
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//        return "6A0EF99B-D9B9-4DEE-951A-8656A58CB9BA";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources', modApiFunc("Modules_Manager","getResFileByShortName", 'PM_PXD'), 'AdminZone');

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "CheckoutPaymentModuleProtxDirectCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModuleProtxDirectCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleProtxDirectCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_protx_direct_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_protx_direct_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_protx_direct_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_protx_direct_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_protx_direct_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_protx_direct_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * Returns the 'derect' or 'redirect' payment method.
     */
    function getPaymentMode()
    {
        return "direct";
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }


    function convertCCTypeToProtx($asc_cc_type)
    {
// VISA ,  MC ,  DELTA ,  SOLO ,  MAESTRO ,  UKE ,  AMEX ,  DC  or  JCB
//"SWITCH" => "MAESTRO"
        switch($asc_cc_type)
        {
            case "Visa":
            {
                $value = "VISA";
                break;
            }
            case "MasterCard":
            {
                $value = "MC";
                break;
            }
            case "Discover":
            {
                $value = "";
                break;
            }
            case "Amex":
            {
                $value = "AMEX";
                break;
            }
            case "Maestro":
            {
                $value = "MAESTRO";
                break;
            }
            case "Solo":
            {
                $value = "SOLO";
                break;
            }
            default:
            {
                $value = "";
                break;
            }
        }
        return $value;
    }

    /**
     * Saves the module state.
     */
    function saveState()
    {
        global $zone;
        if ($zone == "CustomerZone")
        {
            if (sizeof($this->response))
            {
                modApiFunc('Session', 'set', 'ProtxDirect_response', $this->response);
            }
            elseif (modApiFunc('Session', 'is_Set', 'ProtxDirect_response'))
            {
                modApiFunc('Session', 'un_Set', 'ProtxDirect_response');
            }
        }
    }

    /**
     * Restores the module state from the session.
     */
    function loadState()
    {
        global $zone;
        if ($zone == "CustomerZone")
        {
            if(modApiFunc('Session', 'is_Set', 'ProtxDirect_response'))
            {
                $this->response = modApiFunc('Session', 'get', 'ProtxDirect_response');
            }
        }
    }

    function clearResponseErrors()
    {
        if (isset($this->response["Errors"]["ErrorCode"]))
        {
            $this->response["Errors"]["ErrorCode"] = "";
        }
        if (isset($this->response["Errors"]["ShortMessage"]))
        {
            $this->response["Errors"]["ShortMessage"] = "";
        }
        if (isset($this->response["Errors"]["LongMessage"]))
        {
            $this->response["Errors"]["LongMessage"] = "";
        }
    }

    function setResponse($response)
    {
        $this->response = $response;
    }

    function getResponse()
    {
        return $this->response;
    }

    function un_setResponse()
    {
        $this->response = array();
        if (modApiFunc('Session', 'is_Set', 'ProtxDirect_response'))
        {
            modApiFunc('Session', 'un_Set', 'ProtxDirect_response');
        }
    }

    /**
     *                       3D-Secure         .                  ,
     *        (                         )           3D-Secure.                   -
     *         Protx.
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;
        loadCoreFile('aal.class.php');

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL();

        $cache = CCacheFactory::getCache('temporary', __CLASS__);
        $values = $cache->read("Payment_Module_Protx_Direct_CC::protx_direct_register_transaction_response");

        $this->getSettings();
        $confirmationData = array
            (
                //"FormAction" => PAYPAL_URL
                "FormMethod" => "POST"
               ,"DataFields" => array
                    (
                        "PaReq"         => $values['PAReq']
                       ,"TermUrl"       => $self_link
                       ,"MD"            => $values['MD']
                    )
            );

        $confirmationData['FormAction'] = $values['ACSURL'];
        return $confirmationData;
    }
    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function backgroundProcess(/*$type="doDirectPayment", $transactionData = null*/)
    {
        global $application;
        $obj = &$application->getInstance('MessageResources', modApiFunc("Modules_Manager","getResFileByShortName", 'PM_PXD'), 'AdminZone');
        $MessageResourcesCZ = &$application->getInstance('MessageResources',"messages");

        loadCoreFile('aal.class.php');

        $currency_id = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currency = modApiFunc("Localization", "getCurrencyCodeById", $currency_id);

        $_billingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo");
        $billingInfo = new ArrayAccessLayer($_billingInfo);
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $_shippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
        $shippingInfo = new ArrayAccessLayer($_shippingInfo);
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $CCInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());
        //:                 $CCInfo             false.                                          .

        $Products = modApiFunc("Cart", "getCartContent", $currency_id);

        $current_checkout_step = modApiFunc("Checkout", "getCurrentStepID");
        $this->getSettings();
        $settings = $this->getSettings();
        $vendorId = $settings["MODULE_VENDOR"];

        srand();
        $strVendorTxCode =
            $vendorId .
            "-" .
            date("y") .
            date("m") .
            date("d") .
            date("H") .
            date("i") .
            date("s") .
            "-" .
            (string)(round(rand(0, 100000)));
        $strVendorTxCode = trim(preg_replace("/[^A-Za-z0-9\-\_\.]/i","",$strVendorTxCode));

        switch ($settings["MODULE_MODE"])
        {
            case "1" :
            //: remove
/*                // Test(Dummy)
                $vendorId = PROTX_TEST_VENDOR;
                $vendorPassword = PROTX_TEST_PASSWORD;
                $protxURL = PROTX_TEST_URL;
                $request->setKey("testmode", "yes");
                // HACK. Is used, for the server not to return constantly an
                // error "ununique transaction id". Perhaps md5 should be transferred
                // from a large random number.
                $vendorTxCode = md5($orderId);*/
                break;
            case "2" :
                // Test(VSP Simulator)
                $protxURL = PROTX_DIRECT_TRANSACTION_REGISTRATION_URL_VSP_SIMULATOR;
                break;
            case "3" :
                // Test (Test Server)
                $protxURL = PROTX_DIRECT_TRANSACTION_REGISTRATION_URL_TEST_SYSTEM;
                break;
            case "4" :
                // Production
                $protxURL = PROTX_DIRECT_TRANSACTION_REGISTRATION_URL_LIVE_SYSTEM;
                break;
        }

        $amount = number_format($this->export_PRICE_N_A(
            modApiFunc("Checkout", "getOrderPrice", "Total", $currency_id)), 2, '.', '');

        $card_holder = $billingInfo->getByMask('Firstname') . " " . $billingInfo->getByMask('Lastname');
        if(
           isset($CCInfo["ValidFromMonth"]) && !empty($CCInfo["ValidFromMonth"]["value"]) &&
           isset($CCInfo["ValidFromYear"]) && !empty($CCInfo["ValidFromYear"]["value"])
          )
        {
            $month = _ml_substr("00" . $CCInfo["ValidFromMonth"]["value"], -2, 2);
            $year = _ml_substr("00" . $CCInfo["ValidFromYear"]["value"], -2, 2);

            $strStartDate = $month . $year;
        }
        else
        {
            $strStartDate = NULL;
        }

        //:               getByMask
        $month = _ml_substr("00" . $CCInfo["ExpirationMonth"]["value"], -2, 2);
        $year = _ml_substr("00" . $CCInfo["ExpirationYear"]["value"], -2, 2);
        $strExpiryDate = $month . $year;

        if(isset($CCInfo["CreditCardIssueNumber"]) && !empty($CCInfo["CreditCardIssueNumber"]["value"]))
        {
            $strIssueNumber = $CCInfo["CreditCardIssueNumber"]["value"];
        }
        else
        {
            $strIssueNumber = NULL;
        }

        if(isset($CCInfo["CreditCardVerificationNumber"]) && !empty($CCInfo["CreditCardVerificationNumber"]["value"]))
        {
            $strCV2 = $CCInfo["CreditCardVerificationNumber"]["value"];
        }
        else
        {
            $strCV2 = NULL;
        }
        //:           AMEX
        $strCardType = $this->convertCCTypeToProtx($CCInfo["CreditCardType"]["value"]);

        //:          ,                             -           /
        $billing_address_list = array(  $billingInfo->getByMask('Country')? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')):"",
                                        $billingInfo->getByMask('Statemenu')? modApiFunc("Location", "getStateCode", $billingInfo->getByMask('Statemenu')): $billingInfo->getByMask('Statetext'),
                                        $billingInfo->getByMask('City'),
                                        $billingInfo->getByMask('Streetline1'),
                                        $billingInfo->getByMask('Streetline2')
                                      );
        // concatenate a string, delete backup commas
        // and commas from both sides of the string.
        $strBillingAddress = trim(preg_replace('/(, )+/', ', ', implode(', ', $billing_address_list)), ", ");
        //:                             Protx *DIRECT*?
        if (_ml_strlen($strBillingAddress) > 200)
        {
            $strBillingAddress = _ml_substr($strBillingAddress, 0, 200);
        }

        $strBillingPostCode = $billingInfo->getByMask('Postcode');

        //:          ,                             -           /
        $shipping_address_list = array(  $shippingInfo->getByMask('Country')? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')):"",
                                        $shippingInfo->getByMask('Statemenu')? modApiFunc("Location", "getStateCode", $shippingInfo->getByMask('Statemenu')): $shippingInfo->getByMask('Statetext'),
                                        $shippingInfo->getByMask('City'),
                                        $shippingInfo->getByMask('Streetline1'),
                                        $shippingInfo->getByMask('Streetline2')
                                      );
        // concatenate a string, delete backup commas
        // and commas from both sides of the string.
        $strDeliveryAddress = trim(preg_replace('/(, )+/', ', ', implode(', ', $shipping_address_list)), ", ");
        //:                             Protx *DIRECT*?
        if (_ml_strlen($strDeliveryAddress) > 200)
        {
            $strDeliveryAddress = _ml_substr($strDeliveryAddress, 0, 200);
        }

        $strDeliveryPostCode = $shippingInfo->getByMask('Postcode');
        $strCustomerName = $billingInfo->getByMask('Firstname') . " " . $billingInfo->getByMask('Lastname');

        $prod_num = sizeof($Products);
        $basket_data = "{$prod_num}:";
        foreach ($Products as $productInfo)
        {
            $basket_data .= prepareHTMLDisplay($productInfo["Name"]) . ":" .
                $productInfo["Quantity_In_Cart"] . ":---:---:---:---:";
        }
        $len = _ml_strlen($basket_data);
        $basket_data = _ml_substr($basket_data, 0, $len - 1); //                             .


        $strPost  = "";
        $strPost .= $this->makeParamEntry("VPSProtocol", PROTX_DIRECT_PROTOCOL_VER);
        $strPost .= $this->makeParamEntry("TxType", "PAYMENT");
        $strPost .= $this->makeParamEntry("Vendor", $vendorId);
        $strPost .= $this->makeParamEntry("VendorTxCode", $strVendorTxCode);
        $strPost .= $this->makeParamEntry("Amount", $amount);
        $strPost .= $this->makeParamEntry("Currency", $currency);
        $strPost .= $this->makeParamEntry("Description", "Goods"); //  :
        $strPost .= $this->makeParamEntry("CardHolder", $card_holder);
        $strPost .= $this->makeParamEntry("CardNumber", $CCInfo["CreditCardNumber"]["value"]);
        if(!empty($strStartDate))
        {
            $strPost .= $this->makeParamEntry("StartDate", $strStartDate);
        }
        $strPost .= $this->makeParamEntry("ExpiryDate", $strExpiryDate);
        if(!empty($strIssueNumber))
        {
            $strPost .= $this->makeParamEntry("IssueNumber", $strIssueNumber);
        }
        if(!empty($strCV2))
        {
            $strPost .= $this->makeParamEntry("CV2", $strCV2);
        }
        $strPost .= $this->makeParamEntry("CardType", $strCardType);
        $strPost .= $this->makeParamEntry("BillingAddress", $strBillingAddress);
        $strPost .= $this->makeParamEntry("BillingPostCode", $strBillingPostCode);
        $strPost .= $this->makeParamEntry("DeliveryAddress", $strDeliveryAddress);
        $strPost .= $this->makeParamEntry("DeliveryPostCode", $strDeliveryPostCode);
        $strPost .= $this->makeParamEntry("CustomerName", $strCustomerName);

        //'** Optionally add the contact numbers, if they are present **
        //if len(strContactNumber)>0 then strPost=strPost & "&ContactNumber=" & strContactNumber
        $strContactNumber = $billingInfo->getByMask("Phone");
        if(!empty($strContactNumber))
        {
            $strPost .= $this->makeParamEntry("ContactNumber", $strContactNumber);
        }

        //:              ,                     person attribute - fax.
        //if len(strContactFax)>0 then strPost=strPost & "&ContactFax=" & strContactFax

        $strCustomerEmail = $billingInfo->getByMask("Email");
        if(!empty($strCustomerEmail))
        {
            $strPost .= $this->makeParamEntry("CustomerEMail", $strCustomerEmail);
        }
        $strPost .= $this->makeParamEntry("Basket", $basket_data);
        // Account parameters
        //:   -          "0"     ""?
        //       AVACTIS "Use default" -> 9.         .           Protx Form.                    .
        //             Protx         "Default" -> 0
        $strPost .= $this->makeParamEntry("GiftAidPayment", $settings["MODULE_ALLOW_GIFT_AID"]);
        //'** Allow fine control over AVS/CV2 checks and rules by changing this value. 0 is Default **
        //'** It can be changed dynamically, per transaction, if you wish.  See the VSP Direct Protocol document **
        //if strTransactionType<>"AUTHENTICATE" then strPost=strPost & "&ApplyAVSCV2=0"
        $strPost .= $this->makeParamEntry("ApplyAVSCV2", $settings["MODULE_APPLY_AVSCV2"]);
        $strPost .= $this->makeParamEntry("ClientIPAddress", $_SERVER['REMOTE_ADDR']);
        $strPost .= $this->makeParamEntry("Apply3DSecure", $settings["MODULE_APPLY_3D_SECURE"]);

        $strPost .= $this->makeParamEntry("AccountType", "E");

        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($protxURL);
        $bnc->setPOSTstring($strPost);

        if ($application->getAppIni('PROTX_DIRECT_DEFAULT_TIMEOUT') == null)
            $val = 10;
        else
            $val = $application->getAppIni('PROTX_DIRECT_DEFAULT_TIMEOUT');

        $bnc->setSocketReadTimeout($val);
        $result = $bnc->RunRequest();


        $retval = true;
        if (isset($result['body']))
        {
            //                                -                                   payment       .
            //
            //    3D-Secure     ,      3D-Secure                                              ,
            //                                                 Protx                                       .

            //     -         .                     "Status=INVALID",       ,           "StatusDetail="
            //                                                                                    .
            $body = $result['body'];
            $rows = preg_split("/\n/", $body);
            $values = array();
            foreach($rows as $row)
            {
                $pattern = "/^([A-Za-z0-9]+)=(.*)\r$/";
                $matches = array();
                if(preg_match($pattern, $row, $matches) == 1)
                {
                    $values[$matches[1]] = $matches[2];
                }
                else
                {
                    //                  -
                    $pattern = "/^([A-Za-z0-9]+)=(.*)$/";
                    $matches = array();
                    if(preg_match($pattern, $row, $matches) == 1)
                    {
                        $values[$matches[1]] = $matches[2];
                    }
                    else
                    {
                        //: log error?
                        //                                 .                 BODY                =
                    }
                }
            }

            if(!isset($values['Status']) ||
                     ($values['Status'] != PROTX_DIRECT_STATUS_OK &&
                      $values['Status'] != PROTX_DIRECT_STATUS_3DAUTH)
              )
            {
                //                                             Status:
                switch($values['Status'])
                {
                    case PROTX_DIRECT_STATUS_OK:
                    {
                        $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_OK';
                        break;
                    }
                    case PROTX_DIRECT_STATUS_MALFORMED:
                    {
                        $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_MALFORMED';
                        break;
                    }
                    case PROTX_DIRECT_STATUS_INVALID:
                    {
                        $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_INVALID';
                        break;
                    }
                    case PROTX_DIRECT_STATUS_NOTAUTHED:
                    {
                        $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_NOTAUTHED';
                        break;
                    }
                    case PROTX_DIRECT_STATUS_REJECTED:
                    {
                        $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_REJECTED';
                        break;
                    }
                    case PROTX_DIRECT_STATUS_AUTHENTICATED:
                    {
                        $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_AUTHENTICATED';
                        break;
                    }
                    case PROTX_DIRECT_STATUS_REGISTERED:
                    {
                        $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_REGISTERED';
                        break;
                    }
                    case PROTX_DIRECT_STATUS_ERROR:
                    {
                        $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_ERROR';
                        break;
                    }
                    default:
                    {
                        $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_UNKNOWN';
                        break;
                    }
                }
                $short_msg = $obj->getMessage($short_msg_code);
                $msg  = $short_msg;
                $msg .= isset($values["StatusDetail"]) ? $values["StatusDetail"] : $MessageResourcesCZ->getMessage('CHECKOUT_ERR_005');
                $response = array();
                $response['Errors'] = array();
                $response['Errors']['ErrorCode'] = "";
                $response['Errors']['ShortMessage'] = "";
                $response['Errors']['LongMessage'] = $msg;
                $this->setResponse($response);
                $this->SaveState();

                $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
                modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "CHECKOUT_ERR_005", array(), $paymentModule["validatedData"]);
                $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
                modApiFunc("Checkout", "saveState");

                $request = new Request();
                $request->setView('CheckoutView');
                $request->setAction("SetCurrStep");
                $request->setKey   ( 'step_id', $step_id_to_redirect_to);
                $application->redirect($request);
            }
            else
            {
                //                      .
                $order_id = modApiFunc("Checkout", "createOrderInDBAndUpdateEnvironment");
                //
                modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $strVendorTxCode);

                //               ,              Protx.
                $msg = $this->OrderHistoryMessageTag .
                       "\n" .
                       $this->getmicrotime() .
                       "\n" .
                       $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                       $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_RESPONSE_OK_3D') .
                       "\n" .
                       "<pre>" . "\n" . $body . "\n". "</pre>";
                modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);

                if($values['Status'] == PROTX_DIRECT_STATUS_OK)
                {
                    //                   3D-Secure              .
                    //                             .
                    //              Checkout Success.
                    $msg = $this->OrderHistoryMessageTag .
                           "\n" .
                           $this->getmicrotime() .
                           "\n" .
                           $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                           $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_RESPONSE_OK');
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);

                    $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
                    $request = new Request();
                    $request->setView('CheckoutView');
                    $request->setAction("SetCurrStep");
                    $request->setKey   ( 'step_id', $step_id_to_redirect_to);
                    $application->redirect($request);
                }
                else if($values['Status'] == PROTX_DIRECT_STATUS_3DAUTH)
                {
                   //Protx        ,                                   3D-Secure.
                   $cache = CCacheFactory::getCache('temporary', __CLASS__);
                   $cache->write("Payment_Module_Protx_Direct_CC::protx_direct_register_transaction_response", $values);

                   //Display the page, which redirects to
                   // the payment gateway site(if JavaScript is on).
                   $application->prepareStorefrontBlockTag("CheckoutView");
                   echo modApiFunc("CheckoutView", "outputRedirectPage");
                   $application->_exit();
                }
            }
        }
        else
        {
            //   -         :                                    .           socket read timeout.
            // 1.                                   Waiting.
            // 2.                                         .
            // 3.                                                  .
            // 4.                     "Checkout Success"
            $order_id = modApiFunc("Checkout", "createOrderInDBAndUpdateEnvironment");
            //
            modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID", $order_id, $strVendorTxCode);

            $msg = $this->OrderHistoryMessageTag .
                   "\n" .
                   $this->getmicrotime() .
                   "\n" .
                   $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                   $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_EMPTY_RESPONSE') .
                   "\n" .
                   "<pre>" . "\n" . print_r($bnc, true) . "\n". "</pre>";
            modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);

            $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
            $request = new Request();
            $request->setView('CheckoutView');
            $request->setAction("SetCurrStep");
            $request->setKey   ( 'step_id', $step_id_to_redirect_to);
            $application->redirect($request);
        }
    }

    function backgroundProcess_ProtxDirectStep7($order_id, $strMD, $strPaRes)
    {
        global $application;
        $obj = &$application->getInstance('MessageResources', modApiFunc("Modules_Manager","getResFileByShortName", 'PM_PXD'), 'AdminZone');

        $this->getSettings();
        $settings = $this->getSettings();
        switch ($settings["MODULE_MODE"])
        {
            case "1" :
            //: remove
/*                // Test(Dummy)
                $vendorId = PROTX_TEST_VENDOR;
                $vendorPassword = PROTX_TEST_PASSWORD;
                $protxURL = PROTX_TEST_URL;
                $request->setKey("testmode", "yes");
                // HACK. Is used, for the server not to return constantly an
                // error "ununique transaction id". Perhaps md5 should be transferred
                // from a large random number.
                $vendorTxCode = md5($orderId);*/
                break;
            case "2" :
                // Test(VSP Simulator)
                $protxURL = PROTX_DIRECT_3D_SECURE_CALLBACK_URL_VSP_SIMULATOR;
                break;
            case "3" :
                // Test (Test Server)
                $protxURL = PROTX_DIRECT_3D_SECURE_CALLBACK_URL_TEST_SYSTEM;
                break;
            case "4" :
                // Production
                $protxURL = PROTX_DIRECT_3D_SECURE_CALLBACK_URL_LIVE_SYSTEM;
                break;
        }

        $strPost  = "";
        $strPost .= $this->makeParamEntry("MD", $strMD);
        $strPost .= $this->makeParamEntry("PARes", urlencode($strPaRes));

        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL($protxURL);
        $bnc->setPOSTstring($strPost);

        if ($application->getAppIni('PROTX_DIRECT_DEFAULT_TIMEOUT') == null)
            $val = 10;
        else
            $val = $application->getAppIni('PROTX_DIRECT_DEFAULT_TIMEOUT');

        $bnc->setSocketReadTimeout($val);
        $result = $bnc->RunRequest();


        $retval = true;
        if (isset($result['body']))
        {
            //                                -                                   payment       .
            //
            //    3D-Secure     ,      3D-Secure                                              ,
            //                                                 Protx                                       .

            //     -         .                     "Status=INVALID",       ,           "StatusDetail="
            //                                                                                    .
            $body = $result['body'];
            $rows = preg_split("/\n/", $body);
            $values = array();
            foreach($rows as $row)
            {
                $pattern = "/^([A-Za-z0-9]+)=(.*)\r$/";
                $matches = array();
                if(preg_match($pattern, $row, $matches) == 1)
                {
                    $values[$matches[1]] = $matches[2];
                }
                else
                {
                    //                  -
                    $pattern = "/^([A-Za-z0-9]+)=(.*)$/";
                    $matches = array();
                    if(preg_match($pattern, $row, $matches) == 1)
                    {
                        $values[$matches[1]] = $matches[2];
                    }
                    else
                    {
                        //: log error?
                        //                                 .                 BODY                =
                    }
                }
            }

            //                                             Status:
            switch($values['Status'])
            {
                case PROTX_DIRECT_STATUS_OK:
                {
                    $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_OK';
                    break;
                }
                case PROTX_DIRECT_STATUS_MALFORMED:
                {
                    $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_MALFORMED';
                    break;
                }
                case PROTX_DIRECT_STATUS_INVALID:
                {
                    $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_INVALID';
                    break;
                }
                case PROTX_DIRECT_STATUS_NOTAUTHED:
                {
                    $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_NOTAUTHED';
                    break;
                }
                case PROTX_DIRECT_STATUS_REJECTED:
                {
                    $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_REJECTED';
                    break;
                }
                case PROTX_DIRECT_STATUS_AUTHENTICATED:
                {
                    $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_AUTHENTICATED';
                    break;
                }
                case PROTX_DIRECT_STATUS_REGISTERED:
                {
                    $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_REGISTERED';
                    break;
                }
                case PROTX_DIRECT_STATUS_ERROR:
                {
                    $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_ERROR';
                    break;
                }
                default:
                {
                    $short_msg_code = 'MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_MSG_UNKNOWN';
                    break;
                }
            }
            $short_msg = $obj->getMessage($short_msg_code);

            //               ,              Protx.
            $msg = $this->OrderHistoryMessageTag .
                   "\n" .
                   $short_msg .
                   "\n" .
                   $this->getmicrotime() .
                   "\n" .
                   $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                   $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_3D_CALLBACK_RESPONSE') .
                   "\n" .
                   "<pre>" . "\n" . $body . "\n". "</pre>";
            modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);

            if(!isset($values['Status']) ||
                     ($values['Status'] != PROTX_DIRECT_STATUS_OK &&
                      $values['Status'] != PROTX_DIRECT_STATUS_AUTHENTICATED &&
                      $values['Status'] != PROTX_DIRECT_STATUS_REGISTERED)
              )
            {
                // :                                           ,            3D-Secure
                //          .                       Checkout Success,      Checkout Failure.
            }
            else
            {
                $msg = $this->OrderHistoryMessageTag .
                       "\n" .
                       $this->getmicrotime() .
                       "\n" .
                       $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                       $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_3D_CALLBACK_RESPONSE_OK');
                $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 2, $msg);
            }
        }
        else
        {
            //   -         :                                    .           socket read timeout.
            // 1.                                   Waiting.
            // 2.                                         .
            // 3.                                                  .
            // 4.                     "Checkout Success"
            $msg = $this->OrderHistoryMessageTag .
                   "\n" .
                   $this->getmicrotime() .
                   "\n" .
                   $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
                   $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_3D_CALLBACK_EMTPY_RESPONSE') .
                   "\n" .
                   "<pre>" . "\n" . print_r($bnc, true) . "\n". "</pre>";
            modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);
        }
        $EventType = "ConfirmationSuccess";
        return array("EventType" => $EventType, "statusChanged" => "");
    }

    /**
     * Converts the pair "NAME-VALUE" to a string of the type "NAME=VALUE&" ,
     * if VALUE is not an empty string, returns an empty string otherwise.
     *
     * @param string $paramName
     * @param string $paramValue
     * @return string
     */
    function makeParamEntry($paramName, $paramValue)
    {
        $result = "";
        if ($paramValue)
        {
        	$result = $paramName . "=" . $paramValue . "&";
        }
        return $result;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     *
     *                  3D-Secure.                   Protx' ,
     *                                        .
     */
    function processData($data, $order_id /*, &$DBPaymentStatus, &$bStop, &$bPaymentFinished, &$EventType */)
    {
        global $application;
        $obj = &$application->getInstance('MessageResources', modApiFunc("Modules_Manager","getResFileByShortName", 'PM_PXD'), 'AdminZone');
        //            ,                  3D-Secure.
        //                          .
        //                          Protx.
        //        3D-Secure     -             -                   ,
        //      Protx                         .
        $request = $application->getInstance('Request');
        $strMD = $request->getValueByKey('MD');
        $strPaRes = $request->getValueByKey('PaRes');

        $msg = $this->OrderHistoryMessageTag .
               "\n" .
               $this->getmicrotime() .
               "\n" .
               $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_EVENT_DESCRIPTION') .
               $obj->getMessage('MODULE_PAYMENT_PROTX_LOG_MESSAGE_TRANSACTION_REGISTRATION_3D_SECURE_RESPONSE') .
               "\n" .
               "<pre>" . "\n" . "_POST=\n" . print_r($_POST, true) . "\n". "</pre>";
        modApiFunc("Checkout", "addOrderHistory", $order_id, $msg);

        return $this->backgroundProcess_ProtxDirectStep7($order_id, $strMD, $strPaRes);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Paypal_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Protx_Direct_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_protx_direct_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_protx_direct_setting_id'
               ,'key'               => $settings.'.pm_protx_direct_setting_key'
               ,'value'             => $settings.'.pm_protx_direct_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>