<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Payment Module.
 * This action is responsible for updating protx settings.
 *
 * @package PaymentModuleProtxFormCC
 * @access  public
 * @author Egor Makarov
 */
class update_protx_form extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_protx_form()
    {
    }


    function isValidEmail($email)
    {
        return preg_match("/^[_a-z0-9-]+(\.[_a-z0-9-]+)*@[a-z0-9-]+(\.[a-z0-9-]+)*(\.[a-z]{2,6})$/i", $email);
    }

    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Payment_Module_Protx_Form_CC", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array
            (
                "MODULE_NAME"  => $SessionPost["ModuleName"]
//              ,"MODULE_DESCR" => $SessionPost["ModuleDescr"]
                ,"MODULE_VENDOR" => $SessionPost["ModuleVendor"]
                ,"MODULE_PASSWORD" => $SessionPost["ModulePassword"]
                ,"MODULE_ALLOW_GIFT_AID" => $SessionPost["ModuleAllowGiftAid"]
                ,"MODULE_APPLY_AVSCV2" => $SessionPost["ModuleApplyAVSCV2"]
                ,"MODULE_APPLY_3D_SECURE" => $SessionPost["ModuleApply3DSecure"]
                ,"MODULE_MODE" => $SessionPost["ModuleMode"]
//              ,"MODULE_ORDER_STATUS_ID" => $SessionPost["ModuleOrderStatusId"]
            );

        if (array_key_exists("ModuleUseVendorEmail", $SessionPost))
        {
            $Settings["MODULE_USE_VENDOR_EMAIL"] = "1";
            $Settings["MODULE_VENDOR_EMAIL"] = $SessionPost["ModuleVendorEmail"];
        }
        else
        {
            $Settings["MODULE_USE_VENDOR_EMAIL"] = "0";
        }
        modApiFunc("Payment_Module_Protx_Form_CC", "updateSettings", $Settings);
    }

    /**
     *
     */
    function onAction()
    {
        global $application;
        parent::onAction();
        $request = $application->getInstance('Request');

        $SessionPost = array();
        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        switch($SessionPost["ViewState"]["FormSubmitValue"])
        {
            case "save" :
            {
                //$nErrors = 0;
                $SessionPost["ViewState"]["ErrorsArray"] = array();

                if($SessionPost["status"] == "active")
                {
                    //         ,       CheckoutFormEditor'
                    //         PersonInfo     : BillingInfo, ShippingInfo.
                    if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("billingInfo", "shippingInfo")) === true)
                    {
                    }
                    else
                    {
                        $SessionPost["status"]= "inactive";
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
                    }
                }

                if (empty($SessionPost["ModuleName"]) == true || trim($SessionPost["ModuleName"]) == '')
                {
                    $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_NAME";
                }

                if ($SessionPost["status"] == "active" && $SessionPost["ModuleMode"] != "1")
                {
                    // testing mode parameters are in the initial mode, so
					// to fill out all the fields during module activation is
					// not necessary.
                    if (empty($SessionPost["ModuleVendor"]) == true || trim($SessionPost["ModuleVendor"]) == '')
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_VENDOR";
                    }
                    if (empty($SessionPost["ModulePassword"]) == true || trim($SessionPost["ModulePassword"]) == '')
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PASSWORD";
                    }
                    if (array_key_exists("ModuleUseVendorEmail", $SessionPost) == true &&
                        $this->isValidEmail(trim($SessionPost["ModuleVendorEmail"])) == false)
                    {
                        $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_INVALID_EMAIL";
                    }
                }

                $nErrors = sizeof($SessionPost["ViewState"]["ErrorsArray"]);

                if($nErrors == 0)
                {
                    unset($SessionPost["ViewState"]["ErrorsArray"]);
                    $this->saveDataToDB($SessionPost);
                    $SessionPost["ViewState"]["hasCloseScript"] = "true";
                }
                break;
            }
            default :
                _fatal(array( "CODE" => "CORE_051"), __CLASS__, __FUNCTION__, $request->getValueByKey('FormSubmitValue'));
                break;
        }

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>