<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 *
 * @package PaymentModuleRealexCC
 * @author Ravil Garafutdinov
 */
class Payment_Module_Realex_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CZK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HUF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'PLN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }

    /**
     * PaymentModuleRealex  constructor.
     */
    function Payment_Module_Realex_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-realex-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();
    }

    function loadState()
    {
        if(modApiFunc('Session', 'is_Set', 'RealexErrorMessage'))
        {
            $this->errorMessage = modApiFunc('Session', 'get', 'RealexErrorMessage');
        }
        else
        {
            $this->errorMessage = null;
        }
    }

    function saveState()
    {
        if ($this->errorMessage)
        {
            modApiFunc('Session', 'set', 'RealexErrorMessage', $this->errorMessage);
        }
    }

    function setErrorMessage($msg)
    {
        $this->errorMessage = $msg;
    }

    function getErrorMessage()
    {
        return $this->errorMessage;
    }

    function unsetErrorMessage()
    {
        $this->errorMessage = null;
        if(modApiFunc('Session', 'is_Set', 'RealexErrorMessage'))
        {
            modApiFunc('Session', 'un_Set', 'RealexErrorMessage');
        }
    }

    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-realex-messages", "AdminZone");

        list($usec, $sec) = explode(" ",microtime());

        return $obj->getMessage('MODULE_PAYMENT_REALEX_LOG_EVENT_TIME') . (float)($usec + $sec) . " " . $obj->getMessage('MODULE_PAYMENT_REALEX_SECONDS');
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Realex_CC::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-realex-messages", "AdminZone");

        $tables = Payment_Module_Realex_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_realex_settings';                #the name of the filled table
        $columns = $tables[$table]['columns'];      #the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_MERCHANT_ID", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_ACCOUNT", $columns['key']);
        $query->addInsertValue('s:8:"internet";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_SECRET", $columns['key']);
        $query->addInsertValue('s:0:"";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_PAYMENT_METHOD", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Realex_CC',
               'OnRemovePersonInfoType');
    }

    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
        // Realex UID
//        return "9EC6B43E-5453-4BA4-BC88-C20BE1DB2EBA";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-realex-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     "PreferencesAZViewClassName" => "realex_cc_input_az",
                     "CZInputViewClassName" => "CheckoutPaymentModuleRealexCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleRealexCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }
    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_realex_settings');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_realex_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settings array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_realex_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_realex_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_realex_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_realex_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * It is called from Checkout. It returns the cost of selected delivery
     * method. The cost should be 0 for the majority of payment methods.
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     * Converts the value of the monetary sum to be used _out_ ASC.
     * If the price equals PRICE_N_A, then it is changed to 0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     * Prepares and returns necessary data, passed to the payment gateway.
     *
     * @ not all data is defined
     */
    function getConfirmationData($orderId)
    {
        global $application;
        loadCoreFile("aal.class.php");

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL("", true);

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $timestamp = gmdate("YmdHis");
        $settings = $this->getSettings();

        $comment1 = $billingInfo->getByMask("CommentLine")." ".$billingInfo->getByMask("CommentArea");
        $comment2 = $shippingInfo->getByMask("CommentLine")." ".$shippingInfo->getByMask("CommentArea");

        $currencyId = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid());
        $currencyCode = modApiFunc("Localization", "getCurrencyCodeById", $currencyId);
        $total = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currencyId)) * 100;

        $md5hash = $timestamp.'.'
            .$settings["MODULE_MERCHANT_ID"].'.'
            .$orderId.'.'
            .$total.'.'
            .$currencyCode;
        $md5hash = md5(md5($md5hash) . '.' . $settings["MODULE_SECRET"]);

        $confirmationData = array
            (
                 "FormAction" => "https://epage.payandshop.com/epage.cgi"
                ,"FormMethod" => "POST"
                ,"DataFields" => array(
                     "MERCHANT_ID" => $settings["MODULE_MERCHANT_ID"]
                    ,"ACCOUNT" => $settings["MODULE_ACCOUNT"]
                    ,"ORDER_ID" => $orderId
                    ,"AMOUNT" => $total
                    ,"CURRENCY" => $currencyCode
                    ,"TIMESTAMP" => $timestamp
                    ,"MD5HASH" => $md5hash
                    ,"AUTO_SETTLE_FLAG" => 1
                    ,"COMMENT1" => $comment1
                    ,"COMMENT2" => $comment2
                    ,"RETURN_TSS" => 1
                    ,"SHIPPING_CODE" => $shippingInfo->getByMask('Postcode')
                    ,"SHIPPING_CO" => $shippingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')) : $shippingInfo->getByMask('Country')
                    ,"BILLING_CODE" => $billingInfo->getByMask('Postcode')
                    ,"BILLING_CO" => $billingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')) : $billingInfo->getByMask('Country')
                    ,"CUST_NUM" => $billingInfo->getByMask('Email')
                    ,"VAR_REF" => $billingInfo->getByMask('Email')
                    ,"PROD_ID" => 0
                    ,"asc_action" => "UpdatePaymentStatus"
                    ,"asc_oid" => $orderId
                    ,"CZSESSID" => session_id()
                )
            );

        return $confirmationData;
    }

    /**
     * Processes data on updating the order status, come from the payment gateway.
     * The flag &$bStop is set by the payment module. If it is true on return,
     * then Checkout module stops the data process, come from the payment gateway.
     */
    function processData($data, $order_id)
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-realex-messages", "AdminZone");

        $settings = $this->getSettings();
        if ($settings["MODULE_PAYMENT_METHOD"] == 1)
        {
            $raw = htmlspecialchars(print_r($data["_POST"]["raw"], true));
            $resultCode = isset($data["_POST"]["rlt"]["result"]) ? $data["_POST"]["rlt"]["result"] : false;
            $timestamp = $data["_POST"]["rlt"]["timestamp"];
            $responseHash = $data["_POST"]["rlt"]["md5hash"];

            $md5hash = $timestamp.'.'
                    .$data["_POST"]["rlt"]["merchantid"].'.'
                    .$data["_POST"]["rlt"]["orderid"].'.'
                    .$data["_POST"]["rlt"]["result"].'.'
                    .$data["_POST"]["rlt"]["message"].'.'
                    .$data["_POST"]["rlt"]["pasref"].'.'
                    .$data["_POST"]["rlt"]["authcode"];
             $md5hash = md5(md5($md5hash).'.'.$settings["MODULE_SECRET"]);
        }
        else // - if ($settings["MODULE_PAYMENT_METHOD"] == 2)
        {
            $raw = htmlspecialchars(print_r($data["_POST"], true));
            $resultCode = isset($data["_POST"]["RESULT"]) ? $data["_POST"]["RESULT"] : false;
            $responseHash = $data["_POST"]["MD5HASH"];

            $md5hash = $data["_POST"]["TIMESTAMP"].'.'
                    .$data["_POST"]["MERCHANT_ID"].'.'
                    .$data["_POST"]["ORDER_ID"].'.'
                    .$data["_POST"]["RESULT"].'.'
                    .$data["_POST"]["MESSAGE"].'.'
                    .$data["_POST"]["PASREF"].'.'
                    .$data["_POST"]["AUTHCODE"];
             $md5hash = md5(md5($md5hash).'.'.$settings["MODULE_SECRET"]);
        }

        $msg = $this->OrderHistoryMessageTag . "\n"
            . $this->getmicrotime() . "\n"
            . $this->MessageResources->getMessage('MODULE_PAYMENT_REALEX_LOG_EVENT_DESCRIPTION') . "\n"
            . $this->MessageResources->getMessage('MODULE_PAYMENT_REALEX_LOG_POST_DATA') . "\n-----------\n"
            . $raw . "\n-----------\n"
            . $this->MessageResources->getMessage("MODULE_PAYMENT_REALEX_RESPONSE_MD5HASH") . $responseHash . "\n"
            . $this->MessageResources->getMessage("MODULE_PAYMENT_REALEX_CALCULATED_MD5HASH") . $md5hash . "\n";

        if ($md5hash != $responseHash)
        {
            $orderStatus = 1;
            $msg .= $this->MessageResources->getMessage("MODULE_PAYMENT_REALEX_MD5HASH_DIFFERS") . "\n";
        }
        else
        {
            $orderStatus = 2;
            $msg .= $this->MessageResources->getMessage("MODULE_PAYMENT_REALEX_MD5HASH_COINCIDES") . "\n";
        }

        if ($resultCode == '00')
       	{
           $EventType = "ConfirmationSuccess";
           $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, $orderStatus, $msg);
       	}
       	else
       	{
	        $EventType = "ConfirmationFailure";
	        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, 3, $msg);
       	}
	    return array("EventType" => $EventType, "statusChanged" => $result);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Realex_CC::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Realex_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /*
     * this function is needed for correct credit card info form
     * realization
     */

    function getAdditionalPersonInfoVariantTag($prerequisite_type)
    {
        if($prerequisite_type == "creditCardInfo")
        {
            $settings = modApiFunc(__CLASS__, "getSettings");
            if ($settings["MODULE_PAYMENT_METHOD"] != 1) // 1 - remote, 2 - redirect
            {
                return false;
            }
            return "default";
        }
        else
        {
            return false;
        }
    }

    /**
     * parses XML tags, seeks for tags given in $fields
     *
     * @param string array $fields
     * @param string $raw
     * @return unknown
     */

    function parseXmlTags($fields, $raw)
    {
        loadCoreFile("obj_xml.php");
        $xml = new xml_doc($raw);
        $xml->parse();

        if (!is_object($xml->document))
            return $fields;

        foreach ($fields as $tag => $val)
        {
            $xml_tag = $xml->document->findChildRecursively($tag);
            if (is_array($val))
            {
                $fields[$tag] = $xml_tag->attributes;
            }
            else //if ($xml_tag != FALSE && $xml_tag != '' && $xml_tag != NULL)
            {
                $fields[$tag] = $xml_tag->contents;
            }
        }

        $fields["document"] = $xml->document->attributes;
        $fields["timestamp"] = $fields["document"]["TIMESTAMP"];

        return $fields;
    }

    function parseResponse($raw)
    {
        if ($raw == false)
            return false;

        $fields = array(
             "document" => ""
            ,"timestamp" => ""
            ,"merchantid" => ""
            ,"account" => ""
            ,"orderid" => ""
            ,"authcode" => ""
            ,"result" => ""
            ,"message" => ""
            ,"pasref" => ""
            ,"cvnresult" => ""
            ,"batchid" => ""
            ,"bank" => ""
            ,"country" => ""
            ,"countrycode" => ""
            ,"region" => ""
            ,"sha1hash" => ""
            ,"md5hash" => ""
        );

        $result = $this->parseXmlTags($fields, $raw);

        return $result;
    }

    /*
     * processing all payments
     */

    function backgroundProcess()
    {
        global $application;
        loadCoreFile('aal.class.php');

        $billingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "billingInfo"));
        $billingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $shippingInfo = new ArrayAccessLayer(modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo"));
        $shippingInfo->setAccessMask("validatedData", AAL_CUSTOM_PARAM, "value");

        $CCInfo = modApiFunc("Checkout", "getDecryptedCreditCardInfoPrerequisiteData", $this->getUid());
        $settings = $this->getSettings();

        $cardExpMonth = isset($CCInfo["ExpirationMonth"]["value"])
            ? $CCInfo["ExpirationMonth"]["value"] : "";
        // notice: a two-digit year
        $cardExpYear = isset($CCInfo["ExpirationYear"]["value"])
            ? sprintf("%02d", $CCInfo["ExpirationYear"]["value"] % 100) : "";

        $timestamp = date("YmdHis");
        $orderId = $timestamp.intval(microtime()*1000000);

        $currencyId = modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", ORDER_NOT_CREATED_YET, $this->getUid());
        $currencyCode = modApiFunc("Localization", "getCurrencyCodeById", $currencyId);
        $total = $this->export_PRICE_N_A(modApiFunc("Checkout", "getOrderPrice", "Total", $currencyId)) * 100;

        $comment1 = $billingInfo->getByMask("CommentLine")." ".$billingInfo->getByMask("CommentArea");
        $comment2 = $shippingInfo->getByMask("CommentLine")." ".$shippingInfo->getByMask("CommentArea");

        $md5hash = "$timestamp."
            .$settings["MODULE_MERCHANT_ID"]."."
            .$orderId."."
            .$total."."
            .$currencyCode."."
            .$CCInfo["CreditCardNumber"]["value"];
        $md5hash = md5(md5($md5hash).".".$settings["MODULE_SECRET"]);

        $fields = array(
                     "TIMESTAMP"        => $timestamp
                    ,"MERCHANT_ID"      => $settings["MODULE_MERCHANT_ID"]
                    ,"ACCOUNT"          => $settings["MODULE_ACCOUNT"]
                    ,"ORDER_ID"         => $orderId
                    ,"CURRENCY_ID"      => $currencyCode
                    ,"TOTAL_AMT"        => $total
                    ,"CARD_NUMBER"      => $CCInfo["CreditCardNumber"]["value"]
                    ,"CARD_TYPE"        => $CCInfo["CreditCardType"]["value"]
                    ,"EXP_DATE"         => $cardExpMonth.$cardExpYear
                    ,"CARD_NAME"        => $billingInfo->getByMask('Firstname')." ".$billingInfo->getByMask('Lastname')
                    ,"CVN"              => $CCInfo["CreditCardVerificationNumber"]["value"]
                    ,"COMMENT_1"        => $comment1
                    ,"COMMENT_2"        => $comment2
                    ,"CUSTOMER_ID"      => $billingInfo->getByMask('Email')
                    ,"PRODUCT_ID"       => 0
                    ,"VAR_REF"          => $billingInfo->getByMask('Email')
                    ,"CUSTOMER_IP"      => $_SERVER["REMOTE_ADDR"]
                    ,"BZIP"             => $billingInfo->getByMask('Postcode')
                    ,"BCOUNTRY"         => $billingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $billingInfo->getByMask('Country')) : $billingInfo->getByMask('Country')
                    ,"SZIP"             => $shippingInfo->getByMask('Postcode')
                    ,"SCOUNTRY"         => $shippingInfo->getByMask('Country') ? modApiFunc("Location", "getCountryCode", $shippingInfo->getByMask('Country')) : $shippingInfo->getByMask('Country')
                    ,"MD5_HASH"         => $md5hash
            );

        $xml_content = file_get_contents(dirname(__FILE__)."/includes/templateRequest.xml");
        $xml_content = strtr($xml_content, $fields);

        loadCoreFile('bouncer.php');
        $bnc = new Bouncer();
        $bnc->setMethod('POST');
        $bnc->setURL("https://epage.payandshop.com/epage-remote.cgi");
        $bnc->setPOSTstring($xml_content);
        $result = $bnc->RunRequest();

        $raw = $result["body"];
        $arrRlt = $this->parseResponse($result["body"]);

        $msgObj = $application->getInstance("MessageResources", "payment-module-realex-messages", "AdminZone");
        if (intval($arrRlt["result"]) == 0) // APPROVED
        {
            //Create order
            $order_id = modApiFunc("Checkout", "createOrderInDB");
            //                .
            //
            modApiFunc("Cart", "removeAllFromCart");
            $this->processData(array("_POST" => array("raw" => $raw, "rlt" => $arrRlt), "_GET" => array()), $order_id);
            $step_id_to_redirect_to = modApiFunc("Checkout", "getCurrentStepID") + 1;
        }
        else // DECLINED or FRAUD
        {
            if ($arrRlt === false)
	        {
	            // couldn't reach YourPay Gateway,
	            // looks like wrong gateway settings
	            $msg = $msgObj->getMessage("ERROR_NO_RESPONCE");
                $this->setErrorMessage($msg);
	        }
            else
            {
                $msg = $msgObj->getMessage("ERROR_SERVER_RESULT");
                if ($arrRlt["result"] != '') $msg .= $arrRlt["result"];
                if ($arrRlt["message"] != '') $msg .= "<br />".$arrRlt["message"];
                $this->setErrorMessage($msg);
            }
            $paymentModule = modApiFunc("Checkout", "getPrerequisiteValidationResults", "paymentModule");
            modApiFunc("Checkout", "setPrerequisitesValidationResultsItem", "paymentModule", "", false, "CHECKOUT_ERR_005", array(), $paymentModule["validatedData"]);
            $step_id_to_redirect_to = modApiFunc('Checkout', 'getStepIDtoRedirectToAfterPrerequisitesValidationErrors', modApiFunc("Checkout", "getCurrentStepID"));
            modApiFunc("Checkout", "saveState");
        }
        $request = new Request();
        $request->setView  ('CheckoutView');
        $request->setAction("SetCurrStep");
        $request->setKey   ( 'step_id', $step_id_to_redirect_to);
        $application->redirect($request);
    }

    /**
     * Returns the 'direct' or 'redirect' payment method.
     *///*
    function getPaymentMode()
    {
        $settings = $this->getSettings();
        if (!isset($settings["MODULE_PAYMENT_METHOD"])
            || $settings["MODULE_PAYMENT_METHOD"] != 2)
        {
            return "direct";
        }
        else
        {
            return "redirect";
        }
    }//*/

    /*
     * this function checks whether the SSL works on
     * this server
     */

    function checkRequirements()
    {
        $return=array();

        // check SSL
        loadCoreFile('bouncer.php');
        $bssl = new Bouncer();
        if(!$bssl->isSSLavailable())
            $return[] = "ERROR_SSL_NOT_AVAIL";

        return $return;
    }

    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_realex_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_realex_setting_id'
               ,'key'               => $settings.'.pm_realex_setting_key'
               ,'value'             => $settings.'.pm_realex_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        YourPay                        PersonInfoType' :
     * billingInfo
     * shippingInfo
     * creditCardInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-realex-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_REALEX_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "creditCardInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>