<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

define("VERISIGN_AUS_URL", "https://payments.verisign.com.au/payflowlink");

/**
 *
 * @package PaymentModuleVerisignAusCC
 * @author Egor Makarov
 */
class Payment_Module_Verisign_Aus_CC extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /* static */ function getInitialCurrencySettings()
    {
        $res = array
        (
            'currency_acceptance_rules' => array
            (
                array
                (
                    'rule_name'     =>  ACTIVE_AND_ACCEPTED_BY_PM_SM_AND_SELECTED_BY_CUSTOMER
                   ,'rule_selected' =>  DB_FALSE
                )
               ,array
                (
                    'rule_name'     =>  THE_ONLY_ACCEPTED
                   ,'rule_selected' =>  DB_TRUE
                )
               ,array
                (
                    'rule_name'     =>  MAIN_STORE_CURRENCY
                   ,'rule_selected' =>  DB_FALSE
                )
            )

            /**
             * Website Payments Standard Integration Guide, Last updated: March 2008.
             * TABLE 2.6 Currencies Allowed for Transactions and Balances, Currency ISO-4217 Code
             */
           ,'accepted_currencies' => array
            (
                array
                (
                    'currency_code'   => 'AUD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CAD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CHF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'CZK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'DKK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'EUR'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'GBP'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HKD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'HUF'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'JPY'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NOK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'NZD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'PLN'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SEK'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'SGD'
                   ,'currency_status' => 'NOT_ACCEPTED'
                )
               ,array
                (
                    'currency_code'   => 'USD'
                   ,'currency_status' => 'THE_ONE_ONLY_ACCEPTED'
                )
            )
        );
        return $res;
    }

    /**
     *  Payment_Module_Verisign_Aus_CC constructor
     */
    function Payment_Module_Verisign_Aus_CC()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-verisign-aus-messages", "AdminZone");
        //: gen real UID
        $info = $this->getInfo();

        $this->getSettings();

        $this->OrderHistoryMessageTag = $obj->getMessage('MODULE_PAYMENT_VERISIGN_AUS_LOG_MODULE_ID') .
                $info["GlobalUniquePaymentModuleID"] . "\n" .
                $this->Settings["MODULE_NAME"];
    }


    function getmicrotime()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-verisign-aus-messages", "AdminZone");

        list($usec, $sec) = explode(" ", microtime());

        return $obj->getMessage('MODULE_PAYMENT_VERISIGN_AUS_LOG_EVENT_TIME') .
                (float)($usec + $sec) . " " .
                $obj->getMessage('MODULE_PAYMENT_VERISIGN_AUS_SECONDS');
    }

    /**
     *                                     .
     *
     *       install()                      .
     *
     *                                          ,         ,
     * Payment_Module_Paypal_CC::getTables()        $this->getTables()
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-verisign-aus-messages", "AdminZone");

        $tables = Payment_Module_Verisign_Aus_CC::getTables();
        $query = new DB_Table_Create($tables);

        $table = 'pm_verisign_aus_settings';            //
        $columns = $tables[$table]['columns'];        //

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);
/*
        $query = new DB_Insert($table);
        $query->addInsertValue(2, $columns['id']);
        $query->addInsertValue("MODULE_DESCR", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_DESCR')).':"'.$obj->getMessage('MODULE_DESCR').'";', $columns['value']);
        $application->db->getDB_Result($query);
*/
        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_MODE", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(4, $columns['id']);
        $query->addInsertValue("MODULE_LOGIN", $columns['key']);
        $query->addInsertValue('s:10:"Your login";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(5, $columns['id']);
        $query->addInsertValue("MODULE_PARTNER", $columns['key']);
        $query->addInsertValue('s:13:"Reseller Name";', $columns['value']);
        $application->db->getDB_Result($query);

        $query = new DB_Insert($table);
        $query->addInsertValue(6, $columns['id']);
        $query->addInsertValue("MODULE_TYPE", $columns['key']);
        $query->addInsertValue('s:1:"A";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       PaymentModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Payment_Module_Verisign_Aus_CC',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      PaymentModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Payment_Module_Verisign_Aus_CC                    2 PersonInfoType' :
     * billingInfo
     * shippingInfo
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"payment-module-verisign-aus-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_PAYMENT_VERISIGN_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "billingInfo":
                {
                    $value = $msg;
                    break;
                }
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }



    /**
     *                      Checkout   CZ.           AZ.
     *   .                            -
     *                   Checkout   CZ.
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules","payment");
        return array_key_exists($this->getUid(), $active_modules);
    }

    function getUid()
    {
//        return "72D1A9DB-9BA0-3856-F7FE-DFE0DCCB96E9";
        include(dirname(__FILE__)."/includes/uid.php");
        return $uid;
    }

    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"payment-module-verisign-aus-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniquePaymentModuleID" => $this->getUid(),
                     "Name"        => $this->Settings["MODULE_NAME"],
//                     "Description" => $this->Settings["MODULE_DESCR"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>",
                     //"Undefined", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "CheckoutPaymentModuleVerisignAusCCInputAZ",
                     "CZInputViewClassName" => "CheckoutPaymentModuleVerisignAusCCInput",
                     "CZOutputViewClassName" => "CheckoutPaymentModuleVerisignAusCCOutput",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     *                 Settings
     */
    function clearSettingsInDB()
    {
        global $application;
        $query = new DB_Delete('pm_verisign_aus_settings');
        $application->db->getDB_Result($query);
    }

    /**
     *                                               Settings
     *
     * @return array -
     */
    function getSettings()
    {
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => 'pm_verisign_aus_settings'));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     *                          -
     *
     * @param array $Settings -                        .
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables['pm_verisign_aus_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert('pm_verisign_aus_settings');
            $query->addInsertValue($key, $columns['key']);
            $query->addInsertValue(serialize($value), $columns['value']);
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     *                          -
     *
     * @param array $Settings -                        .                    ,                   ,
     *                       .
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables['pm_verisign_aus_settings']['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update('pm_verisign_aus_settings');
            $query->addUpdateValue($columns['value'], serialize($value));
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     *                      Checkout.
     *                .             0                 payment        .
     */
    function getPaymentCost($method_id)
    {
        return 0;
    }

    /**
     *                                                       _   _ ASC.
     *                 PRICE_N_A,                      0.0.
     */
    function export_PRICE_N_A($price)
    {
        return ($price == PRICE_N_A) ? 0.0 : $price;
    }

    /**
     *                                                    ,
     * @
     */
    function getConfirmationData($orderId)
    {
        global $application;
        loadCoreFile('aal.class.php');
        $Settings = $this->getSettings();

        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $request->setAction("UpdatePaymentStatus");
        $request->setKey("asc_oid", $orderId);
        $self_link = $request->getURL("", true);

        $orderInfo = modApiFunc("Checkout", "getOrderInfo", $orderId, modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid()));
        $shippingInfo = new ArrayAccessLayer($orderInfo["Shipping"]["attr"]);
        $billingInfo = new ArrayAccessLayer($orderInfo["Billing"]["attr"]);
        $shippingInfo->setAccessMask(AAL_CUSTOM_PARAM,'value');
        $billingInfo->setAccessMask (AAL_CUSTOM_PARAM,'value');

		$demoMode = ($Settings["MODULE_MODE"] == "1");

		$orderTotal = modApiFunc("Checkout", "getOrderPrice", "Total", modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $orderId, $this->getUid()));
		$exportedTotal = $this->export_PRICE_N_A($orderTotal);
        $amount = number_format($exportedTotal, 2, '.', '');

		$confirmationData = array
            (
                "FormAction" => VERISIGN_AUS_URL
                ,"FormMethod" => "POST"
                ,"DataFields" => array
                (
                    //
                    // Common info
                    //
                    "LOGIN"        => $Settings["MODULE_LOGIN"]
                    ,"PARTNER"     => $Settings["MODULE_PARTNER"]
                    ,"AMOUNT"      => $amount
                    ,"TYPE"        => $Settings["MODULE_TYPE"]
                    ,"METHOD"      => "CC"
                    ,"DESCRIPTION" => "Transaction description." // :
                    ,"USER1"       => $orderId
                    ,"COMMENT1"    => "Oder ID : " . $orderId // Use these parameters to pass information that appears in the PayPal Manager Custom Report.
                    //
                    // Billing info
                    //
                    ,"COUNTRY" => modApiFunc("Location", "getCountryCode", $billingInfo->get("Country","id"))
                    ,"STATE"   => modApiFunc("Location", "getStateCode",   $billingInfo->get("State","id"))
                    ,"CITY"    => $billingInfo->getByMask("City")
                    ,"ADDRESS" => $billingInfo->getByMask("Streetline1")." ".$billingInfo->getByMask("Streetline2")
                    ,"ZIP"     => $billingInfo->getByMask("Postcode")
                    ,"EMAIL"   => $billingInfo->getByMask("Email")
                    //
                    // Shipping info
                    //
                    ,"COUNTRYCODE"   => modApiFunc("Location", "getCountryCode", $shippingInfo->get("Country","id"))
                    ,"STATETOSHIP"   => modApiFunc("Location", "getStateCode",   $shippingInfo->get("State","id"))
                    ,"CITYTOSHIP"    => $shippingInfo->getByMask("City")
                    ,"ADDRESSTOSHIP" => $shippingInfo->getByMask("Streetline1")." ".$shippingInfo->getByMask("Streetline2")
                    ,"ZIPTOSHIP"     => $shippingInfo->getByMask("Postcode")
                    ,"EMAILTOSHIP"   => $shippingInfo->getByMask("Email")
                )
            );

        return $confirmationData;
    }

    /**
     *                          post-                 Payflow.
     *
     * @param array $postData        post-          ,                    .
     * @param string $order_id id                 .
     * @return array
     */
    function processSilentPost($postData, $order_id)
    {
        global $application;
        $msg = &$application->getInstance('MessageResources',"payment-module-verisign-aus-messages", "AdminZone");
        //
        //            history
        //
        $incommingHistoryMessage = $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
            $msg->getMessage('MODULE_PAYMENT_VERISIGN_AUS_LOG_EVENT_DESCRIPTION') .
            $msg->getMessage('MODULE_PAYMENT_VERISIGN_AUS_LOG_MESSAGE_INCOMMING') . "\n" .
            $msg->getMessage('MODULE_PAYMENT_VERISIGN_AUS_LOG_EXTRA') . "\n" .
            print_r($postData, true);
        modApiFunc("Checkout", "addOrderHistory", $order_id, $incommingHistoryMessage);

        //
        //
        //
        $parametersPresent = array_key_exists("RESULT", $postData) &&
            array_key_exists("RESPMSG", $postData) &&
            array_key_exists("PNREF", $postData) &&
            preg_match('/(^-?[1-9]{1}[0-9]{0,3}$)|(^0$)/', $postData["RESULT"]) === 1;

        $includeRespmsg = false;

        if ($parametersPresent)
        {
            modApiFunc("Checkout", "updateOrderPaymentProcessorOrderID",
               $order_id, $postData["PNREF"]);
            if ($postData["RESULT"] == 0)
            {
                //
                //     result==0                          ,  . .
                //                            AVS/CSC                     .
                //
                switch ($postData["RESPMSG"])
                {
                	case "Approved":
                	    $paymentStatus = 2;
                	    $msgId = 'MODULE_PAYMENT_VERISIGN_AUS_LOG_MESSAGE_APPROVED';
                		break;

                	case "AVSDECLINED":
                	    $paymentStatus = 3;
                	    $includeRespmsg = true;
                	    $codeDescr = 'VERISIGN_AUS_COMM_ERR_0';
                	    $msgId = 'MODULE_PAYMENT_VERISIGN_AUS_LOG_MESSAGE_AVSDECLINED';
                	    break;

                	case "CSCDECLINED":
                        $paymentStatus = 3;
                        $includeRespmsg = true;
                	    $codeDescr = 'VERISIGN_AUS_COMM_ERR_0';
                        $msgId = 'MODULE_PAYMENT_VERISIGN_AUS_LOG_MESSAGE_CSCDECLINED';
                	    break;

                	default:
                	    $paymentStatus = 3;
                	    $msgId = 'MODULE_PAYMENT_VERISIGN_AUS_LOG_MESSAGE_INVALID_STATUS';
                		break;
                }
            }
            else if ($postData["RESULT"] < 0)
            {
                // A communication error occurred. No transaction is attempted.
                $paymentStatus = 3;
                $includeRespmsg = true;
                $codeDescr = 'VERISIGN_AUS_COMM_ERR_' . _ml_substr($postData["RESULT"], 1);
                $msgId = 'MODULE_PAYMENT_VERISIGN_AUS_LOG_MESSAGE_COMM_ERROR';
                break;
            }
            else
            {
                // decline or error
                $paymentStatus = 3;
                $includeRespmsg = true;
                $codeDescr = 'VERISIGN_AUS_ERR_' . $postData["RESULT"];
                $msgId = 'MODULE_PAYMENT_VERISIGN_AUS_LOG_MESSAGE_DECLINE_OR_ERROR';
                break;
            }
        }
        else
        {
            //                                .
            $paymentStatus = 3;
            $msgId = 'MODULE_PAYMENT_VERISIGN_AUS_LOG_MESSAGE_NO_PARAMS';
            break;
        }

        $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id, $paymentStatus,
            $this->OrderHistoryMessageTag . "\n" . $this->getmicrotime() . "\n" .
            $msg->getMessage('MODULE_PAYMENT_VERISIGN_AUS_LOG_EVENT_DESCRIPTION') .
            $msg->getMessage($msgId) . "\n" .
            $includeRespmsg ? ($postData["RESPMSG"] . "\n" . $msg->getMessage($codeDescr)) : "");

        return array("EventType" => "BackgroundEvent", "statusChanged" => $result);
    }

    /**
     *                                               ,                              .
     *      &$bStop                                  .         true                         ,
     *           Checkout                                  [                   ].
     */
    function processData($data, $order_id /*, &$DBPaymentStatus, &$bStop, &$bPaymentFinished, &$EventType */)
    {
        global $application;
        $msg = &$application->getInstance('MessageResources',"payment-module-verisign-aus-messages", "AdminZone");
        $postData = $data["_POST"];

        if (array_key_exists("status", $data["_GET"]))
        {
            switch ($data["_GET"]["status"])
            {
                case "return":
                    $orderInfo = modApiFunc("Checkout", "getOrderInfo", $order_id, modApiFunc("Localization", "whichCurrencySendOrderToPaymentShippingGatewayIn", $order_id, $this->getUid()));
                    $currentPaymentStatus = $orderInfo["PaymentStatusId"];
                    $result = modApiFunc("Checkout", "UpdatePaymentStatusInDB", $order_id,
                        $currentPaymentStatus);
                    //$EventType = $currentPaymentStatus == 2 ? "ConfirmationSuccess" : "ConfirmationFailure";
                    switch ($currentPaymentStatus)
                    {
                        case 2:
                            $EventType = "ConfirmationSuccess";
                            break;
                        case 3:
                            $EventType = "ConfirmationFailure";
                            break;
                        default:
                            //
                            // :                     EventType="ConfiramtionFailure".
                            //               silent post                      waiting.
                            //
                            break;
                    }
                    return array("EventType" => $EventType, "statusChanged" => $result);
                    break;

                case "notify":
                    return $this->processSilentPost($postData, $order_id);
                    break;

                default:
                    //
                    // :                -             status.
                    //
                    break;
            }
        }
        else
        {
            //
            // :                      (    status).
            //
        }
    }

    /**
     * Uninstall the module.
     *                           .
     *
     *       uninstall()                      .
     *
     *                                          ,         ,
     * Payment_Module_Paypal_CC::getTables()        $this->getTables()
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Payment_Module_Verisign_Aus_CC::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     *
     *
     *                                        :
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       #                                            ,          - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      #                                                   ,          - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $settings = 'pm_verisign_aus_settings';
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.pm_verisign_aus_setting_id'
               ,'key'               => $settings.'.pm_verisign_aus_setting_key'
               ,'value'             => $settings.'.pm_verisign_aus_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     *     .              .                ,
     * CZ Checkout.
     */
    var $bActive;

    var $OrderHistoryMessageTag;
    /**#@-*/

}
?>