<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

class SELECT_SM_FEDEX_METHODS_BY_METHOD_ID extends DB_Select
{
    function initQuery($params)
    {
        $tables = modApiStaticFunc($params['ApiClassName'], "getTables");
        $methods_table = $tables['sm_fedex_methods']['columns'];

        $this->addSelectTable('sm_fedex_methods');
        $this->addSelectField($methods_table['id'],'id');
        $this->Where($methods_table['id'], DB_EQ, intval($params['method_id']));
    }
}

class SELECT_SM_FEDEX_METHODS_BY_METHOD_ID_EXT extends DB_Select
{
    function initQuery($params)
    {
        $tables = modApiStaticFunc($params['ApiClassName'], "getTables");
        $methods_table = $tables['sm_fedex_methods']['columns'];

        $this->addSelectTable('sm_fedex_methods');
        $this->addSelectField($methods_table['id'],'id');
        $this->addSelectField($methods_table['method_name'],'method_name');
        $this->addSelectField($methods_table['method_code'],'method_code');
        $this->addSelectField($methods_table['destination'],'destination');
        $this->addSelectField($methods_table['available'],'available');
        $this->Where($methods_table['id'], DB_EQ, intval($params['method_id']));
    }
}

class SELECT_SM_FEDEX_METHODS_BY_AVAILABILITY extends DB_Select
{
    function initQuery($params)
    {
        $tables = modApiStaticFunc($params['ApiClassName'], "getTables");
        $methods_table = $tables['sm_fedex_methods']['columns'];

        $this->addSelectTable('sm_fedex_methods');
        $this->addSelectField($methods_table['id'],'id');
        $this->addSelectField($methods_table['method_name'],'method_name');
        $this->addSelectField($methods_table['method_code'],'method_code');
        $this->addSelectField($methods_table['destination'],'destination');
        $this->addSelectField($methods_table['available'],'available');
        if($params['available_condition'] !="")
            $this->Where($methods_table['available'], DB_EQ, $params['available_condition']);
    }
}

class SELECT_SM_FEDEX_CACHED_RATES extends DB_Select
{
    function initQuery($params)
    {
        $tables = modApiStaticFunc($params['ApiClassName'], "getTables");
        $rc_table = $tables['sm_fedex_rates_cache']['columns'];

        $this->addSelectTable('sm_fedex_rates_cache');
        $this->addSelectField($rc_table['rate'],'rate');
        $this->Where($rc_table['hash'], DB_EQ, "'". $params['hash'] ."'");
        $this->WhereAND();
        $this->Where($rc_table['method_id'], DB_EQ, $params['method_id']);
        $this->WhereAND();
        $this->Where($rc_table['expire'], DB_GT, time());
    }
}

class SELECT_SM_FEDEX_METHODS_BY_CODE extends DB_Select
{
    function initQuery($params)
    {
        $tables = modApiStaticFunc($params['ApiClassName'], "getTables");
        $methods_table = $tables['sm_fedex_methods']['columns'];

        $this->addSelectTable('sm_fedex_methods');
        $this->addSelectField($methods_table['id'],'id');
        $this->Where($methods_table['method_code'], DB_EQ, $params['method_code']);
    }
}


?>