<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * Shipping Module "Flat Shipping Rates".
 *
 * @package ShippingModuleFlatShippingRates
 * @author Girin Alexander
 */
class Shipping_Module_Flat_Shipping_Rates extends pm_sm_api
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * ShippingModuleFlatShippingRates  constructor.
     */
    function Shipping_Module_Flat_Shipping_Rates()
    {
        $this->selectedCountries = array();
        $this->selectedStates = array();
        $this->selectedStatesAllOther = array();
    }

    function getUID()
    {
        return "8C262EF4-5E9B-DE1D-94CB-30EEC93F002E";
    }

    /**
     *
     */
    /**
     * Returns module info.
     */
    function getInfo()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"shipping-module-flat-shipping-rates-messages", "AdminZone");

        $this->getSettings();

        return array("GlobalUniqueShippingModuleID" => $this->getUID(),
                     "Name"        => $this->Settings["MODULE_NAME"],
                     "StatusMessage" => ($this->IsActive())? "<span class=\"status_online\">".$obj->getMessage('MODULE_STATUS_ACTIVE')."</span>":$obj->getMessage('MODULE_STATUS_INACTIVE')."<span class=\"required\">*</span>", //NOT for active/inactive.
                     // there is special config in Checkout module to handle/store
                     // active/inactive flags.
                     "PreferencesAZViewClassName" => "flat_shipping_rates_input_az",
                     "APIClassName" => __CLASS__
                    );
    }

    /**
     * Installs the specified module in the system.
     *
     * The install() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Flat_Shipping_Rates::getTables() instead of $this->getTables().
     */
    function install()
    {
        global $application;
        $obj = &$application->getInstance('MessageResources',"shipping-module-flat-shipping-rates-messages", "AdminZone");

        $tableNames = Shipping_Module_Flat_Shipping_Rates::getTableNames();
        $tables = Shipping_Module_Flat_Shipping_Rates::getTables();
        $query = new DB_Table_Create($tables);

        $table = $tableNames['table_units'];            #the name of the filled table
        $columns = $tables[$table]['columns'];  #the array of field names of the table

        for ($i=1; $i<=3; $i++)
        {
            $query = new DB_Insert($table);
            $query->addInsertValue($i, $columns['id']);
            $query->addInsertValue('SM_TBL_RTS_RU_00'.$i, $columns['name']);
            $query->addInsertValue('SM_TBL_RTS_RU_TYPE_00'.$i, $columns['type']);
            $query->addInsertValue('SM_TBL_RTS_RU_DESCR_00'.$i, $columns['descr']);
            $application->db->getDB_Result($query);
        }

        $table = $tableNames['table_settings'];            #  the name of the filled table
        $columns = $tables[$table]['columns'];  #  the array of field names of the table

        $query = new DB_Insert($table);
        $query->addInsertValue(1, $columns['id']);
        $query->addInsertValue("MODULE_NAME", $columns['key']);
        $query->addInsertValue('s:'._ml_strlen($obj->getMessage('MODULE_NAME')).':"'.$obj->getMessage('MODULE_NAME').'";', $columns['value']);
        $application->db->getDB_Result($query);
        $query = new DB_Insert($table);
        $query->addInsertValue(3, $columns['id']);
        $query->addInsertValue("MODULE_RATE_UNIT_ID", $columns['key']);
        $query->addInsertValue('s:1:"1";', $columns['value']);
        $application->db->getDB_Result($query);

        //                                RemovePersonInfoType
        //                   ,          -     CheckoutEditor
        //             PersonInfoType,         , BillingInfo, ShippingInfo,
        //  CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
        //             ), ShippingMethodInfo (              ).
        //       ShippingModule'                                                 ,
        //                                     .
        //                    ,                 PersonInfoType          .
        //
        //  PersonInfoType.
        modApiFunc('EventsManager',
               'addEventHandler',
               'RemovePersonInfoTypeEvent',
               'Shipping_Module_Flat_Shipping_Rates',
               'OnRemovePersonInfoType');
    }

    /**
     *                    RemovePersonInfoType.
     *                  ,          -     CheckoutEditor
     *            PersonInfoType,         , BillingInfo, ShippingInfo,
     * CustomerInfo, CreditCardInfo, BankAccountInfo, PaymentMethodInfo (
     *            ), ShippingMethodInfo (              ).
     *      ShippingModule'                                                 ,
     *                                    .
     *                   ,                 PersonInfoType          .
     *
     * PersonInfoType.
     *
     *        Standard Shipping Rates                         PersonInfoType:
     * shippingInfo
     *
     * @param string $person_info_type_tag - tag      person info type' ,
     *                      (turn off)   CheckoutFormEditor' .
     *
     * @return mixed - NULL,                       - "          ",       -
     *                                     ,            ,
     *        (                                   ).
     */
    function OnRemovePersonInfoType($person_info_type_tag)
    {
        global $application;

        if($this->isActive() === false)
        {
            //                        -                                .
            $value =  NULL;
        }
        else
        {
            $this->MessageResources = &$application->getInstance('MessageResources',"shipping-module-flat-shipping-rates-messages", "AdminZone");
            $msg = $this->MessageResources->getMessage('MODULE_SHIPPING_FLAT_SHIPPING_RATES_API_MSG_REMOVE_PERSON_INFO_TYPE');

            $value = NULL;
            switch($person_info_type_tag)
            {
                case "shippingInfo":
                {
                    $value = $msg;
                    break;
                }
                default:
                {
                    break;
                }
            }
        }
        return $value;
    }


    /**
     * This method is invoked by Checkout module in CZ (Customer Zone). It is
     * also invoked in AZ (Admin Zone).
     * returns - Boolean - Show this module during the process of Checkout in
     * Customer Zone or not?
     */
    function isActive()
    {
        global $application;
        $active_modules = modApiFunc("Checkout","getActiveModules", "shipping");
        return array_key_exists($this->getUid(), $active_modules);
    }

    /**
     * This method is invoked by Checkout. It returns the cost of the selected
     * shipping method. Some shipping modules can have several shipping methods
     * (e.g. by airplane, by train etc.), the other have only one.
     * 'All Inactive' has one method. The result is always the same
     * "the cost is not defined" ("N/A").
     */
    function getShippingCost($method_id="")
    {
        //$ShippingInfo = modApiFunc("Checkout", "getPrerequisiteValidationResults", "shippingInfo");
        ////: remove stuff after finishing taxes.
        //return PRICE_N_A;

        $ShippingInfo = modApiFunc("Shipping_Cost_Calculator","getShippingInfo");
        $orderCost = modApiFunc("Shipping_Cost_Calculator","getCartSubtotal");

        if($ShippingInfo["isMet"] == false)
        {
            return PRICE_N_A;
        }

        $this->getSettings();

        global $application;
        $tables = $this->getTables();
        $tableNames = $this->getTableNames();

        //$orderCost = modApiFunc("Checkout", "getOrderPrice", "Subtotal");
        switch ($this->Settings["MODULE_RATE_UNIT_ID"])
        {
            case 2: /*$orderRateUnit = modApiFunc("Checkout", "getOrderWeight", "brutto");*/
                    $orderRateUnit = modApiFunc("Shipping_Cost_Calculator","getPackWeight");
                    break;
            case 3: /*$orderRateUnit = modApiFunc("Checkout", "getOrderProductsNumber");*/
                    $orderRateUnit=modApiFunc("Shipping_Cost_Calculator","getItemsCount");
                    break;
            case 1:
            default: $orderRateUnit = $orderCost; break;
        }

        $orderRateUnit = floatval($orderRateUnit);

        $countryId = $ShippingInfo["validatedData"]["Country"]["value"];
//        $stateId = modApiFunc("Checkout", "getPrAttr", "shippingInfo", "Statemenu");
//        $stateId = $ShippingInfo["validatedData"]["Statemenu"]["value"];
        $stateId = (isset($ShippingInfo["validatedData"]["Statemenu"]["value"]))
            ? $ShippingInfo["validatedData"]["Statemenu"]["value"]
            : "-1";

        $result = execQuery('SELECT_SM_FLAT_SR_RATES',array
        (
            'countryId'           => $countryId
           ,'stateId'             => $stateId
           ,'orderRateUnit'       => $orderRateUnit
           ,'MODULE_RATE_UNIT_ID' => $this->Settings["MODULE_RATE_UNIT_ID"]
           ,'table_rates'         => $tableNames['table_rates']
           ,'tables'              => $tables
        ));

        if (sizeof($result)==1)
        {
            $cost = $result[0]["cost"];
        }
        else
        {
            //Try "ALL STATES" cost for chosen country.
            $result = execQuery('SELECT_SM_FLAT_SR_RATES_ALL_STATES',array
            (
                'countryId'           => $countryId
               ,'stateId'             => $stateId
               ,'orderRateUnit'       => $orderRateUnit
               ,'MODULE_RATE_UNIT_ID' => $this->Settings["MODULE_RATE_UNIT_ID"]
               ,'table_rates'         => $tableNames['table_rates']
               ,'tables'              => $tables
            ));

            if(sizeof($result)==1)
            {
                $cost = $result[0]["cost"];
            }
            else
            {
                //Try "ALL COUNTRIES" cost.
                $result = execQuery('SELECT_SM_FLAT_SR_RATES_ALL_COUNTRIES',array
                (
                    'countryId'           => $countryId
                   ,'stateId'             => $stateId
                   ,'orderRateUnit'       => $orderRateUnit
                   ,'MODULE_RATE_UNIT_ID' => $this->Settings["MODULE_RATE_UNIT_ID"]
                   ,'table_rates'         => $tableNames['table_rates']
                   ,'tables'              => $tables
                ));

                if(sizeof($result)==1)
                {
                    $cost = $result[0]["cost"];
                }
                else
                {
                    $cost = PRICE_N_A;
                }
            }
        }

        return $cost;
    }

    function getShippingMethodInfo($method_id, $and_calc=false)
    {
        if(!isset($this->Settings))
            $this->Settings=$this->getSettings();
        if($method_id == $this->single_available_method_id)
        {
            return array(
                        'id' => $this->single_available_method_id,
                        //@
                        'method_name' => $this->Settings["MODULE_NAME"],
                        'method_code' => '',
                        'destination' => 'UNDEFINED',
                        'available' => $this->IsActive() ? 'Y' : 'N',
                        'days' => 0,
                        'cost' => ( $and_calc ? $this->getShippingCost() : PRICE_N_A )
                        );
        }
        else
        {
            return array();
        }
    }

    /**
     *
     */
    function getShippingMethods($type="ALL", $and_calc = false)
    {
        global $application;

       /* The $type="AVAILABLE" condition in this module equals the whole
           module, which is isActive.
        */
        if($type == "AVAILABLE" &&
           $this->isActive() === false)
        {
            return array();
        }

        if($this->is_debug==true)
            $this->_debug_info[]=array("Calculation type","Offline");

        $info = $this->getShippingMethodInfo($this->single_available_method_id, $and_calc);

       /* If the parameter $and_calc == true, the shipping cost should be
           determined.
        */
        if($and_calc === true &&
           $info["cost"] == PRICE_N_A)
        {
            if($this->is_debug==true)
                $this->_debug_info[]=array("Result","Delivery is not available");
            return array();
        }

        if($this->is_debug==true)
            $this->_debug_info[]=array("Result",modApiFunc('Localization','currency_format',$info["cost"]));

        return array($info);
    }

    /**
     * Uninstalls the module.
     * It deletes all module tables.
     *
     * The uninstall() method is called statically.
     * To call other methods of this class from this method,
     * the static call is used, for example,
     * Payment_Module_Flat_Shipping_Rates::getTables() instead of $this->getTables().
     */
    function uninstall()
    {
        $query = new DB_Table_Delete(Shipping_Module_Flat_Shipping_Rates::getTables());
        global $application;
        $application->db->getDB_Result($query);
    }

    /**
     * Returns true if in this shipping module the shipping method with the
     * specified id exists, false otherwise.
     */
    function isValidShippingMethodId($method_id)
    {
        if($method_id == 1)
        {
            return true;
        }
        else
        {
            return false;
        }
    }

    /**
     * Gets the array of meta description of module tables.
     *
     * The array structure of meta description of the table:
     * <code>
     *      $tables = array ();
     *      $table_name = 'table_name';
     *      $tables[$table_name] = array();
     *      $tables[$table_name]['columns'] = array
     *      (
     *          'fn1'               => 'table_name.field_name_1'
     *         ,'fn2'               => 'table_name.field_name_2'
     *         ,'fn3'               => 'table_name.field_name_3'
     *         ,'fn4'               => 'table_name.field_name_4'
     *      );
     *      $tables[$table_name]['types'] = array
     *      (
     *          'fn1'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
     *         ,'fn2'               => DBQUERY_FIELD_TYPE_INT .' NOT NULL'
     *         ,'fn3'               => DBQUERY_FIELD_TYPE_CHAR255
     *         ,'fn4'               => DBQUERY_FIELD_TYPE_TEXT
     *      );
     *      $tables[$table_name]['primary'] = array
     *      (
     *          'fn1'       # several key fields may be used, e.g. - 'fn1', 'fn2'
     *      );
     *      $tables[$table_name]['indexes'] = array
     *      (
     *          'index_name1' => 'fn2'      # several fields can be used in one index, e.g. - 'fn2, fn3'
     *         ,'index_name2' => 'fn3'
     *      );
     * </code>
     *
     * @return array -  the meta description of module tables
     */
    function getTables()
    {
        static $tables;

        if (is_array($tables))
        {
            return $tables;
        }

        $tables = array ();

        $tableNames = Shipping_Module_Flat_Shipping_Rates::getTableNames();
        $rate_units = $tableNames['table_units'];
        $tables[$rate_units] = array();
        $tables[$rate_units]['columns'] = array
            (
                'id'                => $rate_units.'.sm_flat_shipping_rates_rate_unit_id'
               ,'name'              => $rate_units.'.sm_flat_shipping_rates_rate_unit_name'
               ,'type'              => $rate_units.'.sm_flat_shipping_rates_rate_unit_type'
               ,'descr'             => $rate_units.'.sm_flat_shipping_rates_rate_unit_descr'
            );
        $tables[$rate_units]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'name'              => DBQUERY_FIELD_TYPE_CHAR255
               ,'type'              => DBQUERY_FIELD_TYPE_CHAR255
               ,'descr'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$rate_units]['primary'] = array
            (
                'id'
            );

        $table_rates = $tableNames['table_rates'];
        $tables[$table_rates] = array();
        $tables[$table_rates]['columns'] = array
            (
                'id'                => $table_rates.'.sm_flat_shipping_rates_table_rate_id'
               ,'c_id'              => $table_rates.'.sm_flat_shipping_rates_country_id'
               ,'s_id'              => $table_rates.'.sm_flat_shipping_rates_state_id'
               ,'rv_from'           => $table_rates.'.sm_flat_shipping_rates_rate_value_from'
               ,'rv_to'             => $table_rates.'.sm_flat_shipping_rates_rate_value_to'
               ,'ru_id'             => $table_rates.'.sm_flat_shipping_rates_rate_unit_id'
               ,'cost_type_id'      => $table_rates.'.sm_flat_shipping_rates_rate_cost_type_id'
               ,'cost'              => $table_rates.'.sm_flat_shipping_rates_rate_cost'
            );
        $tables[$table_rates]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'c_id'              => DBQUERY_FIELD_TYPE_INT .' NOT NULL DEFAULT 0'
               ,'s_id'              => DBQUERY_FIELD_TYPE_INT .' NOT NULL DEFAULT 0'
               ,'rv_from'           => DBQUERY_FIELD_TYPE_FLOAT
               ,'rv_to'             => DBQUERY_FIELD_TYPE_FLOAT
               ,'ru_id'             => DBQUERY_FIELD_TYPE_INT .' NOT NULL DEFAULT 0'
               ,'cost_type_id'      => DBQUERY_FIELD_TYPE_INT .' NOT NULL DEFAULT 0'
               ,'cost'              => DBQUERY_FIELD_TYPE_FLOAT
            );
        $tables[$table_rates]['primary'] = array
            (
                'id'
            );
        $tables[$table_rates]['indexes'] = array
            (
                'IDX_c' => 'c_id'
               ,'IDX_s' => 's_id'
               ,'IDX_rv_from' => 'rv_from'
               ,'IDX_rv_to' => 'rv_to'
            );

        $settings = $tableNames['table_settings'];
        $tables[$settings] = array();
        $tables[$settings]['columns'] = array
            (
                'id'                => $settings.'.sm_flat_shipping_rates_setting_id'
               ,'key'               => $settings.'.sm_flat_shipping_rates_setting_key'
               ,'value'             => $settings.'.sm_flat_shipping_rates_setting_value'
            );
        $tables[$settings]['types'] = array
            (
                'id'                => DBQUERY_FIELD_TYPE_INT .' NOT NULL auto_increment'
               ,'key'               => DBQUERY_FIELD_TYPE_CHAR50
               ,'value'             => DBQUERY_FIELD_TYPE_CHAR255
            );
        $tables[$settings]['primary'] = array
            (
                'id'
            );

        global $application;
        return $application->addTablePrefix($tables);
    }

    function getTableNames()
    {
        return array(
             'table_settings' => 'sm_flat_shipping_rates_settings'
            ,'table_rates'    => 'sm_flat_shipping_rates_rates_table'
            ,'table_units'    => 'sm_flat_shipping_rates_rate_units'
        );
    }

    /**
     * Clears the Settings table.
     */
    function clearSettingsInDB()
    {
        global $application;
        $tableNames = Shipping_Module_Flat_Shipping_Rates::getTableNames();
        $cols = $this -> getTables();
        $cols = $cols[$tableNames['table_settings']]['columns'];
        $query = new DB_Delete($tableNames['table_settings']);
        $query -> deleteMultiLangField($cols['value'], $cols['id'],
                                       'Shipping_Module_Flat_Shipping_Rates');
        $application->db->getDB_Result($query);
    }

    /**
     * Gets current module settings from Settings.
     *
     * @return array - module settings array
     */
    function getSettings()
    {
        $tableNames = Shipping_Module_Flat_Shipping_Rates::getTableNames();
        $result = execQuery('SELECT_PM_SM_SETTINGS',array('ApiClassName' => __CLASS__, 'settings_table_name' => $tableNames['table_settings']));
        $this->Settings = array();
        for ($i=0; $i<sizeof($result); $i++)
        {
            $this->Settings[$result[$i]['set_key']] = unserialize($result[$i]['set_value']);
        }
        return $this->Settings;
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings - module settins array.
     */
    function setSettings($Settings)
    {
        global $application;
        $this->clearSettingsInDB();
        $tables = $this->getTables();
        $columns = $tables[$this->table_settings]['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Insert($this->table_settings);
            $query->addInsertValue($key, $columns['key']);
            $query -> addMultiLangInsertValue(serialize($value),
                                              $columns['value'],
                                              $columns['id'],
                                              'Shipping_Module_Flat_Shipping_Rates');
            $application->db->getDB_Result($query);

            $inserted_id = $application->db->DB_Insert_Id();
        }
    }

    /**
     * Sets up module attributes and logs it to the database.
     *
     * @param array $Settings -  module settings array. The undefined parameter values
     * remain unchanged.
     */
    function updateSettings($Settings)
    {
        global $application;
        $tables = $this->getTables();
        $columns = $tables[$this->table_settings]['columns'];

        foreach($Settings as $key => $value)
        {
            $query = new DB_Update($this->table_settings);
            $query -> addMultiLangUpdateValue($columns['value'],
                                              serialize($value),
                                              $columns['id'], '',
                                              'Shipping_Module_Flat_Shipping_Rates');
            $query->WhereValue($columns['key'], DB_EQ, $key);
            $application->db->getDB_Result($query);
        }
    }

    /**
     * Gets rate units.
     *
     * @return array - the result array
     */
    function getRateUnits()
    {
        $tables = $this->getTables();
        $tableNames = $this->getTableNames();
        $tableNames['tables'] = $tables;
        $result = execQuery('SELECT_SM_FLAT_SR_RATE_UNITS', $tableNames);
        if (is_array($result))
            foreach($result as $k => $v)
            {
                $result[$k]['name'] = getMsg('FSR1', $v['name']);
                $result[$k]['type'] = getMsg('FSR1', $v['type']);
                $result[$k]['descr'] = getMsg('FSR1', $v['descr']);
            }
        return $result;
    }

    /**
     * Gets a unit of rate units from the Localization module.
     *
     * @param integer $ru_type - unit type
     *
     * @return array - the array of results
     */
    function getRateUnitUnitsValue($ru_type)
    {
        return modApiFunc("Localization", "getUnitTypeValue", $ru_type);
    }

    /**
     * Gets strings from the table of the shipping cost values.
     *
     * @param integer $regionId - address id
     * @param array $rate_unit_values_array - the array of rate units interval
     *        values
     * @return array - the array of rates, ordered by c_id, s_id, rv_from.
     */
    function getFlatShippingRates($ru_id = NULL, $cost_type_id = NULL/*$countryId, $stateId, $rate_unit_values_array*/)
    {
        global $application;
        $tables = $this->getTables();
        $tableNames = $this->getTableNames();
        $tr = $tables[$tableNames['table_rates']]['columns'];

        $result_array = array();
////        foreach ($rate_unit_values_array as $rate_unit_value)
////        {

            $result_rows = execQuery('SELECT_SM_FLAT_SR_RATES_ALL_RATES',array
            (
                'ru_id'           => $ru_id
               ,'cost_type_id'    => $cost_type_id
               ,'table_rates'     => $tableNames['table_rates']
               ,'tables'          => $tables
            ));

//            if (sizeof($result)>0)
            foreach($result_rows as $row)
            {
                $result_array[$row["ru_id"]][$row["cost_type_id"]][$row["c_id"]][$row["s_id"]][] = $row;
            }
////        }
        return $result_array;
    }

    /**
     * Deletes the strings from the table.
     *
     * @param array $address_id_array - the array of address ids
     * @param $rate_unit_id - id of rate unit
     */
    function deleteRowsFromFlatShippingRates($rate_id_array)
    {
        global $application;
        $tables = $this->getTables();
        $tr = $tables[$this->table_rates]['columns'];

        $query = new DB_Delete($this->table_rates);
        $query->WhereField( $tr['id'], DB_IN, "(".implode(", ", $rate_id_array).") ");
        $application->db->getDB_Result($query);
    }

    /**
     * Checks if two intervals are intersected. The boundaries are real numbers.
     * If they are intersected (even at a single point), returns true, false otherwise.
     */
    function doTwoIntervalsIntersect($from1, $to1, $from2, $to2)
    {
        return !(($to1 < $from2) || ($to2 < $from1));
    }

    /**
     * Checks if two intervals are intersected at exactly one point.
     *
     * @param $EPS the accuracy of comparison of two real numbers.
     * @return false if two intervals are intersected at more than two points,
     * or are not injtersected at all, returns a real number - the coordinate
     * of a singular intersection point, otherwise.
     */
    function doTwoIntervalsIntersectInSinglePoint($EPS, $from1, $to1, $from2, $to2)
    {
        $ret_struct = array("ret_val" => false,
                            "intersection_coord" => NULL);
        if(!$this->doTwoIntervalsIntersect($from1, $to1, $from2, $to2))
        {
        }
        else
        {
            if(($from1 < $from2) &&
               (abs($to1 - $from2) < 0.5 * $EPS))
            {
                $ret_struct["ret_val"] = true;
                $ret_struct["intersection_coord"] = $to1;
            }
            else
            if(($from2 < $from1) &&
               (abs($to2 - $from1) < 0.5 * $EPS))
            {
                $ret_struct["ret_val"] = true;
                $ret_struct["intersection_coord"] = $to2;
            }
            else
            {
            }
        }
        return $ret_struct;
    }

    /**
     * Checks if a newly added interval intersects with any of already added ones.
     * If it intersects with even one interval, returns true, false otherwise.
     */
    function doesAddingShippingRateCreateRateUnitIntervalsIntersection($EPS,
                                                                       $c_id,
                                                                       $s_id,
                                                                       $rate_value_from,
                                                                       $rate_value_to,
                                                                       $rate_unit_id,
                                                                       $cost_type_id,
                                                                       $rate_cost)
    {
        $ret_struct = array("ret_val" => false,
                            "rate_id" => NULL,
                            "intersection_coord" => NULL);
        //Fetch all rates with same $rate_unit_id and $cost_type_id
        $rates = $this->getFlatShippingRates($rate_unit_id, $cost_type_id);
        if(isset($rates[$rate_unit_id][$cost_type_id][$c_id][$s_id]))
        {
            foreach($rates[$rate_unit_id][$cost_type_id][$c_id][$s_id] as $rate)
            {
                if($this->doTwoIntervalsIntersect($rate["rv_from"], $rate["rv_to"], $rate_value_from, $rate_value_to))
                {
                    $ret_struct["ret_val"] = true;
                    $ret_struct["id"] = $rate["id"];
                    $_ret_struct = $this->doTwoIntervalsIntersectInSinglePoint($EPS, $rate["rv_from"], $rate["rv_to"], $rate_value_from, $rate_value_to);
                    if($_ret_struct["ret_val"] === true)
                    {
                        $ret_struct["intersection_coord"] = $_ret_struct["intersection_coord"];
                    }
                }
            }
        }
        return $ret_struct;
    }

    /**
     * Checks if intervals of cost/weight/...
     * (shipping rate units) make a contiguous one.
     *
     * @param $eps the comparison accuracy. If $eps = 0.1,
     * then intervals [0.0; 0.9] and [1.0; 2.0] amount to the contiguous
     * interval [0.0; 2.0].If $eps = 0.0.1, then there will be an empty
     * interval [0.91; 0.99] between these two intervals.
     * @return true, if intervals make a contiguous one. Otherwise, the array
     * consists of empty intervals.
     * WARNING: the array should be classified by $rv_from!
     */
    function areShippingRatesIntervalsContiguous($EPS, $rates_for_c_id_s_id)//$rate_unit_id, $cost_type_id)
    {
//        $rates = $this->getFlatShippingRates($rate_unit_id, $cost_type_id);

        if(empty($rates_for_c_id_s_id))
        {
            return true;
        }

//        if (!function_exists('rate_cmp'))
//        {
//            function rate_cmp($rate1, $rate2)
//            {
//                if($rate1["rv_from"] == $rate2["rv_from"])
//                {
//                    return 0;
//                }
//                return ($rate1["rv_from"] < $rate2["rv_from"]) ? -1 : 1;
//            }
//        }
//        usort($rates, "rate_cmp");

        $x = $rates_for_c_id_s_id[0]["rv_from"] - $EPS;
        $not_defined_intervals = array();
        foreach($rates_for_c_id_s_id as $rate)
        {
            //:change the accuracy of $rate["rv_from"] and $rate["rv_to"] to $EPS!
            //  The excessive accuracy may lead to fals results.
            if(abs($x - $rate["rv_from"]) <= 1.5 * $EPS)
            {
                //The current interval follows the previous one at distance of $EPS.
                //Go on.
            }
            else
            {
                $not_defined_interval = $rate;
                $not_defined_interval['id'] = NULL;
                $not_defined_interval['cost'] = NULL;
                $not_defined_interval['rv_from'] = $x + $EPS;
                $not_defined_interval['rv_to'] = $rate["rv_from"] - $EPS;
                $not_defined_intervals[] = $not_defined_interval;
            }
            $x = $rate["rv_to"];
        }
        if(empty($not_defined_intervals))
        {
            return true;
        }
        else
        {
            return $not_defined_intervals;
        }
    }

    /**
     * Changes the cost values in the rate list.
     *
     * @param array $address_id_array - address id array
     * @param array $rate_unit_value_id_array - the array of interval id values
     *        of the rate unit
     * @param array $cost_array - the cost array
     */
    function insertFlatShippingRates($countryId, $stateId, $rate_value_from, $rate_value_to, $rate_unit_id, $rate_cost_type_id, $rate_cost)
    {
        global $application;
        $tables = $this->getTables();
        $tr = $tables[$this->table_rates]['columns'];

        $query = new DB_Insert($this->table_rates);
        $query->addInsertValue($countryId, $tr['c_id']);
        $query->addInsertValue($stateId, $tr['s_id']);
        $query->addInsertValue($rate_value_from, $tr['rv_from']);
        $query->addInsertValue($rate_value_to, $tr['rv_to']);
        $query->addInsertValue($rate_unit_id, $tr['ru_id']);
        $query->addInsertValue($rate_cost_type_id, $tr['cost_type_id']);
        $query->addInsertValue($rate_cost, $tr['cost']);

        $result = $application->db->getDB_Result($query);
    }

    function setDebugFlag($flag=true)
    {
        if(is_bool($flag))
            $this->is_debug=$flag;
    }

    function getDebugInfo()
    {
        return $this->_debug_info;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $table_units    = 'sm_flat_shipping_rates_rate_units';
    var $table_settings = 'sm_flat_shipping_rates_settings';
    var $table_rates    = 'sm_flat_shipping_rates_rates_table';

    //The ID of the single available method in this module.
    var $single_available_method_id = 1;

    /**
     * A flag, which is stored in the database. It indicates, if the specified
     * module is mapped in CZ Checkout.
     */
    var $bActive;

    var $is_debug;
    var $_debug_info;


    /**#@-*/
}
?>