<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * freight101_input_az view
 *
 * @package ShippingModuleFreight101
 * @author Egor V. Derevyankin
 */
class freight101_input_az extends pm_sm_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Modules_Manager constructor.
     */
    function freight101_input_az()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"shipping-module-freight101-messages", "AdminZone");
        $this->Hints = &$application->getInstance('Hint');
        $this->shipping_methods=modApiFunc("Shipping_Module_Freight101","getShippingMethods");

        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }

        $requirments=modApiFunc("Shipping_Module_Freight101","checkRequirments");
        $reqsErrors=array("OCNTR"=>"ERROR_006","CURRENCY"=>"ERROR_007","SOAP"=>"ERROR_008");
        for($i=0;$i<count($requirments);$i++)
            $this->ErrorsArray[]=$reqsErrors[$requirments[$i]];

        if(count($this->ErrorsArray)>0 and $this->POST["status"]==true)
        {
            $this->POST["status"]=false;
            $this->ViewState["hasCloseScript"]="false";
            modApiFunc("Checkout", "setModuleActive", (modApiFunc("Shipping_Module_Freight101", "getUid")), false);
        };
    }

    /**
     * Copies data from the global POST to the local POST array.
     */
   function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST =
            array(
                 "status"       => ($SessionPost["status"]=="active")? true:false
                ,"ORG_ZIP"      => $SessionPost["ORG_ZIP"]
                ,"DEFINED_OZIP" => $SessionPost["DEFINED_OZIP"]
                ,"ORG_LGN"      => $SessionPost["ORG_LGN"]
                ,"ORG_TS"       => $SessionPost["ORG_TS"]
                ,"ORG_IP"       => $SessionPost["ORG_IP"]
                ,"ORG_AN"       => $SessionPost["ORG_AN"]
                ,"ORG_LT"       => $SessionPost["ORG_LT"]
                ,"DST_LGN"      => $SessionPost["DST_LGN"]
                ,"DST_TS"       => $SessionPost["DST_TS"]
                ,"DST_IP"       => $SessionPost["DST_IP"]
                ,"DST_AN"       => $SessionPost["DST_AN"]
                ,"DST_LT"       => $SessionPost["DST_LT"]
                ,"PCLASS"       => $SessionPost["PCLASS"]
                ,"PCK_HAZ"      => $SessionPost["PCK_HAZ"]
                ,"AUTH_KEY"     => $SessionPost["AUTH_KEY"]
            );
    }

    /**
     * Fills the local POST array by data from the DB.
     */
    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Shipping_Module_Freight101", "getSettings");
        foreach ($settings as $key => $value)
        {
            switch($key)
            {
                case "ORG_ZIP":         $this->POST["ORG_ZIP"]=$value; break;
                case "DEFINED_OZIP":    $this->POST["DEFINED_OZIP"]=$value;break;
                case "ORG_LGN":         $this->POST["ORG_LGN"]=$value;break;
                case "ORG_TS":          $this->POST["ORG_TS"]=$value;break;
                case "ORG_IP":          $this->POST["ORG_IP"]=$value;break;
                case "ORG_AN":          $this->POST["ORG_AN"]=$value;break;
                case "ORG_LT":          $this->POST["ORG_LT"]=$value;break;
                case "DST_LGN":         $this->POST["DST_LGN"]=$value;break;
                case "DST_TS":          $this->POST["DST_TS"]=$value;break;
                case "DST_IP":          $this->POST["DST_IP"]=$value;break;
                case "DST_AN":          $this->POST["DST_AN"]=$value;break;
                case "DST_LT":          $this->POST["DST_LT"]=$value;break;
                case "PCLASS":          $this->POST["PCLASS"]=$value;break;
                case "PCK_HAZ":         $this->POST["PCK_HAZ"]=$value;break;
                case "AUTH_KEY":        $this->POST["AUTH_KEY"]=$value;break;
            }
        }
        $this->POST["status"] = modApiFunc("Shipping_Module_Freight101", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );
    }


    /**
     * @return String Return html code for hidden form fields representing
     * @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * @return HTML code for the errors
     */
    function outputErrors()
    {
        global $application;

        $return_html_code="";

        foreach($this->ErrorsArray as $index => $value)
        {
            $this->_Template_Contents = array(
                                            "ErrorIndex"    => $index+1,
                                            "Error"         => $this->MessageResources->getMessage($value)
                                        );
            $application->registerAttributes($this->_Template_Contents);
            $return_html_code.=$this->mTmplFiller->fill("shipping_module_freight101/", "error.tpl.html", array());
        };

        return $return_html_code;
    }

    function outputTopErrors()
    {
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }

        global $application;

        $return_html_code="";

        $this->_Template_Contents = array(
                                            "Errors"    => $this->outputErrors()
                                        );
        $application->registerAttributes($this->_Template_Contents);
        $return_html_code.=$this->mTmplFiller->fill("shipping_module_freight101/", "errors.tpl.html", array());

        return $return_html_code;
    }

    /**
     * @return HTML code for the module status
     */
    function outputStatus()
    {

        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked":""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "":"checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("shipping_module_freight101/", "status.tpl.html", array());
        return $retval;
    }

    function outputOZipSelect()
    {
        global $application;
        $retval = "";
        $default_ozip=modApiFunc("Configuration","getTagValue","StoreOwnerPostcode");
        $this->_Template_Contents = array(
                                          "OZip_default_Active" => ($this->POST["ORG_ZIP"]=="default")? "checked":""
                                         ,"DefaultOZip"   => $default_ozip
                                         ,"OZip_defined_Active" => ($this->POST["ORG_ZIP"]=="defined")? "checked":""
                                         ,"DefinedOZip" => HtmlForm::genInputTextField(5,"DEFINED_OZIP",6,$this->POST["DEFINED_OZIP"])
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("shipping_module_freight101/", "ozip.tpl.html", array());
        return $retval;
    }

    /**
     * @return HTML code for this view
     */
    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        // `Lift Gate Needed` select box
        $org_lgn_types = array (
            "select_name" => "ORG_LGN",
            "selected_value" => $this->POST["ORG_LGN"],
            "values" => array()
        );
        foreach(array("YES","NO") as $lgnv)
            $org_lgn_types["values"][]=array (
                                        "value" => $lgnv,
                                        "contents" => $this->MessageResources->getMessage("CHOICE_$lgnv")
                                      );

        // `Trade Show` select box
        $org_ts_types = array (
            "select_name" => "ORG_TS",
            "selected_value" => $this->POST["ORG_TS"],
            "values" => array()
        );
        foreach(array("YES","NO") as $tsv)
            $org_ts_types["values"][]=array (
                                        "value" => $tsv,
                                        "contents" => $this->MessageResources->getMessage("CHOICE_$tsv")
                                      );

        // `Inside Pickup` select box
        $org_ip_types = array (
            "select_name" => "ORG_IP",
            "selected_value" => $this->POST["ORG_IP"],
            "values" => array()
        );
        foreach(array("YES","NO") as $ipv)
            $org_ip_types["values"][]=array (
                                        "value" => $ipv,
                                        "contents" => $this->MessageResources->getMessage("CHOICE_$ipv")
                                      );

        // `Appointment Needed` select box
        $org_an_types = array (
            "select_name" => "ORG_AN",
            "selected_value" => $this->POST["ORG_AN"],
            "values" => array()
        );
        foreach(array("YES","NO") as $anv)
            $org_an_types["values"][]=array (
                                        "value" => $anv,
                                        "contents" => $this->MessageResources->getMessage("CHOICE_$anv")
                                      );

        // `Location Type` select box
        $org_lt_types = array (
            "select_name" => "ORG_LT",
            "selected_value" => $this->POST["ORG_LT"],
            "values" => array()
        );
        foreach(array("C","R") as $ltv)
            $org_lt_types["values"][]=array (
                                        "value" => $ltv,
                                        "contents" => $this->MessageResources->getMessage("LT_$ltv")
                                      );

        // `Lift Gate Needed` select box
        $dst_lgn_types = array (
            "select_name" => "DST_LGN",
            "selected_value" => $this->POST["DST_LGN"],
            "values" => $org_lgn_types["values"]
        );
        // `Trade Show` select box
        $dst_ts_types = array (
            "select_name" => "DST_TS",
            "selected_value" => $this->POST["DST_TS"],
            "values" => $org_ts_types["values"]
        );
        // `Inside Pickup` select box
        $dst_ip_types = array (
            "select_name" => "DST_IP",
            "selected_value" => $this->POST["DST_IP"],
            "values" => $org_ip_types["values"]
        );
        // `Appointment Needed` select box
        $dst_an_types = array (
            "select_name" => "DST_AN",
            "selected_value" => $this->POST["DST_AN"],
            "values" => $org_an_types["values"]
        );
        // `Location Type` select box
        $dst_lt_types = array (
            "select_name" => "DST_LT",
            "selected_value" => $this->POST["DST_LT"],
            "values" => $org_lt_types["values"]
        );

        // `Package Class` select box
        $pck_classes = array (
            "select_name" => "PCLASS",
            "selected_value" => $this->POST["PCLASS"],
            "values" => array()
        );
        $pclasses_values = array_map("trim",file(dirname(__FILE__)."/../includes/pclasses.csv"));
        foreach($pclasses_values as $pclass)
            $pck_classes["values"][]=array(
                                    "value" => $pclass,
                                    "contents" => $pclass
                    );
        // `Hazmat` select box
        $hazmat_types = array (
            "select_name" => "PCK_HAZ",
            "selected_value" => $this->POST["PCK_HAZ"],
            "values" => $org_ts_types["values"]
        );

        $request = new Request();
        $request->setView('CheckoutShippingModuleSettings');
        $request->setAction("update_freight101_settings");
        $form_action = $request->getURL();
        $settings = modApiFunc("Shipping_Module_Freight101", "getSettings");
        $template_contents = array(
                                    "EditSMForm"    => $HtmlForm1->genForm($form_action, "POST", "EditSMForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"ModuleType"            => $this->MessageResources->getMessage('MODULE_TYPE')
                                   ,"ModuleName"            => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"Subtitle"              => $this->MessageResources->getMessage('FORM_SUBTITLE')
                                   ,"TopErrors"             => $this->outputTopErrors()
                                   ,"ModuleStatusFieldName" => $this->MessageResources->getMessage('MODULE_STATUS_FIELD_NAME')
                                   ,"ModuleStatusField"     => $this->outputStatus()
                                   ,"ModuleNameFieldName"   => $this->MessageResources->getMessage('MODULE_NAME_FIELD_NAME')
                                   ,"ModuleNameField"       => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"ModuleDescrFieldName"  => $this->MessageResources->getMessage('MODULE_DESCR_FIELD_NAME')
                                   ,"ModuleDescrFieldValue" => $this->MessageResources->getMessage('MODULE_DESCR')
                                   ,"AuthSettingsHeader"    => $this->MessageResources->getMessage('LBL_AUTHENTICATION')." ".$this->MessageResources->getMessage('LBL_SETTINGS')
                                   ,"AuthKeyFieldName"      => $this->MessageResources->getMessage('LBL_AUTHENTICATION')." ".$this->MessageResources->getMessage('LBL_KEY')
                                   ,"AuthKeyFieldValue"     => HtmlForm::genInputTextField(125,"AUTH_KEY",75,$this->POST["AUTH_KEY"])
                                   ,"OrgSettingsHeader"     => $this->MessageResources->getMessage('LBL_ORINGINATION')." ".$this->MessageResources->getMessage('LBL_SETTINGS')
                                   ,"OZipFieldName"         => $this->MessageResources->getMessage('LBL_ZIP_CODE')
                                   ,"OZipFieldValue"        => $this->outputOZipSelect()
                                   ,"OrgLiftGateNeededFieldName" => $this->MessageResources->getMessage('LBL_LIFT_GATE_NEEDED')
                                   ,"OrgLiftGateNeededFieldValue" => HtmlForm::genDropdownSingleChoice($org_lgn_types)
                                   ,"OrgTradeShowFieldName" => $this->MessageResources->getMessage('LBL_TRADE_SHOW')
                                   ,"OrgTradeShowFieldValue" => HtmlForm::genDropdownSingleChoice($org_ts_types)
                                   ,"OrgInsidePickupFieldName" => $this->MessageResources->getMessage('LBL_INSIDE_PICKUP')
                                   ,"OrgInsidePickupFieldValue" => HtmlForm::genDropdownSingleChoice($org_ip_types)
                                   ,"OrgAppointmentNeededFieldName" => $this->MessageResources->getMessage('LBL_APPOINTMENT_NEEDED')
                                   ,"OrgAppointmentNeededFieldValue" => HtmlForm::genDropdownSingleChoice($org_an_types)
                                   ,"OrgLocationTypeFieldName" => $this->MessageResources->getMessage('LBL_LOCATION_TYPE')
                                   ,"OrgLocationTypeFieldValue" => HtmlForm::genDropdownSingleChoice($org_lt_types)
                                   ,"DstSettingsHeader" => $this->MessageResources->getMessage('LBL_DESTINATION')." ".$this->MessageResources->getMessage('LBL_SETTINGS')
                                   ,"DstLiftGateNeededFieldName" => $this->MessageResources->getMessage('LBL_LIFT_GATE_NEEDED')
                                   ,"DstLiftGateNeededFieldValue" => HtmlForm::genDropdownSingleChoice($dst_lgn_types)
                                   ,"DstTradeShowFieldName" => $this->MessageResources->getMessage('LBL_TRADE_SHOW')
                                   ,"DstTradeShowFieldValue" => HtmlForm::genDropdownSingleChoice($dst_ts_types)
                                   ,"DstInsidePickupFieldName" => $this->MessageResources->getMessage('LBL_INSIDE_PICKUP')
                                   ,"DstInsidePickupFieldValue" => HtmlForm::genDropdownSingleChoice($dst_ip_types)
                                   ,"DstAppointmentNeededFieldName" => $this->MessageResources->getMessage('LBL_APPOINTMENT_NEEDED')
                                   ,"DstAppointmentNeededFieldValue" => HtmlForm::genDropdownSingleChoice($dst_an_types)
                                   ,"DstLocationTypeFieldName" => $this->MessageResources->getMessage('LBL_LOCATION_TYPE')
                                   ,"DstLocationTypeFieldValue" => HtmlForm::genDropdownSingleChoice($dst_lt_types)
                                   ,"PckgSettingsHeader" => $this->MessageResources->getMessage('LBL_PACKAGE')." ".$this->MessageResources->getMessage('LBL_SETTINGS')
                                   ,"PackageClassFieldName" => $this->MessageResources->getMessage('LBL_PACKAGE_CLASS')
                                   ,"PackageClassFieldValue" => HtmlForm::genDropdownSingleChoice($pck_classes)
                                   ,"PckClassCalculatorLink" => $this->MessageResources->getMessage('LBL_PACKAGE_CLASS_CALCULATOR_LINK')
                                   ,"HazmatFieldName"       => $this->MessageResources->getMessage('LBL_HAZMAT')
                                   ,"HazmatFieldValue"      => HtmlForm::genDropdownSingleChoice($hazmat_types)
                                   ,"Alert_002"             => $this->MessageResources->getMessage('ALERT_002')
                                   ,"Alert_003"             => $this->MessageResources->getMessage('ALERT_003')
                                   ,"HintLink_AKEY"         => $this->Hints->getHintLink(array('LBL_AUTHENTICATION_KEY','shipping-module-freight101-messages'))
                                   ,"HintLink_OZIP"         => $this->Hints->getHintLink(array('LBL_ZIP_CODE','shipping-module-freight101-messages'))
                                   ,"HintLink_LGN"          => $this->Hints->getHintLink(array('LBL_LIFT_GATE_NEEDED','shipping-module-freight101-messages'))
                                   ,"HintLink_PCLASS"       => $this->Hints->getHintLink(array('LBL_PACKAGE_CLASS','shipping-module-freight101-messages'))
                                   ,"HintLink_HAZMAT"       => $this->Hints->getHintLink(array('LBL_HAZMAT','shipping-module-freight101-messages'))
                                  );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("shipping_module_freight101/", "list.tpl.html",array());

    }

    /**
     * @param $tag name of the requested tag
     * @return value of the tag
     */
    function getTag($tag)
    {
        global $application;
        $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
        return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;
    var $ViewState;

    /**
     * List of error ids. Comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;

    var $shipping_methods;

    /**#@-*/
}
?>