<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * intershipper_input_az view
 *
 * @package ShippingModuleInterShipper
 * @author Egor V. Derevyankin
 */
class intershipper_input_az extends pm_sm_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * A constructor.
     */
    function intershipper_input_az()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"shipping-module-intershipper-messages", "AdminZone");
        $this->Hints = &$application->getInstance('Hint');
        $this->shipping_methods=modApiFunc("Shipping_Module_InterShipper","getShippingMethods");

        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }

        $requirments=modApiFunc("Shipping_Module_InterShipper","checkRequirments");
        $reqsErrors=array("OCNTR"=>"ERROR_006","CURRENCY"=>"ERROR_007","SSL"=>"ERROR_010");
        for($i=0;$i<count($requirments);$i++)
            $this->ErrorsArray[]=$reqsErrors[$requirments[$i]];

        if(count($this->ErrorsArray)>0 and $this->POST["status"]==true)
        {
            $this->POST["status"]=false;
            $this->ViewState["hasCloseScript"]="false";
        };
    }

    /**
     * Copies data from the global POST to the local POST array.
     */
    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST =
            array(
                "ModuleName" => $SessionPost["ModuleName"]
               ,"status"     => ($SessionPost["status"]=="active")? true:false
               ,"Username"   => $SessionPost["Username"]
               ,"Password"   => $SessionPost["Password"]
               ,"DeliveryType" => $SessionPost["DeliveryType"]
               ,"PickupType" => $SessionPost["PickupType"]
               ,"PK_HEIGHT"  => $SessionPost["pk_height"]
               ,"PK_WIDTH"   => $SessionPost["pk_width"]
               ,"PK_LENGTH"  => $SessionPost["pk_length"]
               ,"SMethodsAvailable" => array()
            );

        if(is_array($this->shipping_methods) and !empty($this->shipping_methods))
            foreach($this->shipping_methods as $key => $method)
                $this->POST["SMethodsAvailable"][$method['id']] =
                    (isset($SessionPost["SMethodsAvailable"][$method['id']])?"Y":"N");

    }

    /**
     * Fills the local POST array with data from the DB.
     */
    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Shipping_Module_InterShipper", "getSettings");
        foreach ($settings as $key => $value)
        {
            switch($key)
            {
                case "MODULE_NAME":     $this->POST["ModuleName"] = $value; break;
                case "USERNAME":        $this->POST["Username"] = $value;   break;
                case "PASSWORD":        $this->POST["Password"] = $value;   break;
                case "DELIVERY_TYPE":   $this->POST["DeliveryType"] = $value;   break;
                case "PICKUP_TYPE":     $this->POST["PickupType"] = $value; break;
                case "PK_HEIGHT":       $this->POST["PK_HEIGHT"] = $value;  break;
                case "PK_WIDTH":        $this->POST["PK_WIDTH"] = $value;   break;
                case "PK_LENGTH":       $this->POST["PK_LENGTH"] = $value;  break;
            }
        }
        $this->POST["status"] = modApiFunc("Shipping_Module_InterShipper", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );

        $this->POST["SMethodsAvailable"]=array();
        if(is_array($this->shipping_methods) and !empty($this->shipping_methods))
            foreach($this->shipping_methods as $key => $method)
                $this->POST["SMethodsAvailable"][$method["id"]]=$method["available"];

    }


    /**
     * @return String Return html code for hidden form fields representing
     * @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * @return HTML code for the errors
     */
    function outputErrors()
    {
        global $application;

        $return_html_code="";

        foreach($this->ErrorsArray as $index => $value)
        {
            $this->_Template_Contents = array(
                                            "ErrorIndex"    => $index+1,
                                            "Error"         => $this->MessageResources->getMessage($value)
                                        );
            $application->registerAttributes($this->_Template_Contents);
            $return_html_code.=$this->mTmplFiller->fill("shipping_module_fedex/", "error.tpl.html", array());
        };

        return $return_html_code;
    }

    function outputTopErrors()
    {
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }

        global $application;

        $return_html_code="";

        $this->_Template_Contents = array(
                                            "Errors"    => $this->outputErrors()
                                        );
        $application->registerAttributes($this->_Template_Contents);
        $return_html_code.=$this->mTmplFiller->fill("shipping_module_fedex/", "errors.tpl.html", array());

        return $return_html_code;
    }

    /**
     * @return HTML code for the module status
     */
    function outputStatus()
    {

        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked":""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "":"checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("shipping_module_intershipper/", "status.tpl.html", array());
        return $retval;

    }

    /**
     * @return HTML code for the 'available' checkbox for the shipping method
     */
     function outputAvailableCheckBox($checkbox_id,$available)
    {
        $is_checked=($available=="Y"?"checked":"");
        $return_html_code = "<input type=\"checkbox\" id=\"MA-$checkbox_id\" name=\"SMethodsAvailable[$checkbox_id]\" $is_checked>";
        return $return_html_code;
    }

    /**
     * @return HTML code for the list of the shipping methods
     */
    function outputShippingMethods()
    {
        global $application;

        if(empty($this->shipping_methods) or !is_array($this->shipping_methods))
            return $this->MessageResources->getMessage('LABEL_NO_SHIPPING_METHODS');

        $return_html_code="";

        foreach($this->shipping_methods as $method_key => $method_info)
        {
            $dest=$method_info['destination']=="L"?$this->MessageResources->getMessage("LABEL_SM_DESTINATION_NATIONAL"):
                $this->MessageResources->getMessage("LABEL_SM_DESTINATION_INTERNATIONAL");

            $this->_Template_Contents=array (
                "CycleColor"                   => ( $method_key % 2 ? "EEEEEE":"FFFFFF"),
                "SMethodName"                  => $method_info['method_name'],
                "SMethodDestination"           => $dest,
                "SMethodAvailableCheckBox"     => $this->outputAvailableCheckBox($method_info['id'],$this->POST["SMethodsAvailable"][$method_info['id']]),
                "CarriersSplitter"             => ( $method_key > 0 and $this->shipping_methods[$method_key-1]['carrier_code']!=$method_info['carrier_code'])?"<tr><td colspan=\"3\"><hr size=\"1\" noshade></td></tr>":""
            );
            $application->registerAttributes($this->_Template_Contents);
            $return_html_code.=$this->mTmplFiller->fill("shipping_module_intershipper/","methods_list_item.tpl.html",array());
        }

        return $return_html_code;
    }

    /**
     * @return HTML code for this view
     */
    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        # Delivery types
        $delivery_types = array (
            "select_name" => "DeliveryType",
            "selected_value" => $this->POST["DeliveryType"],
            "values" => array()
        );
        foreach(array("COM","RES") as $dtv)
            $delivery_types["values"][]=array (
                                        "value" => $dtv,
                                        "contents" => $this->MessageResources->getMessage("DT_$dtv")
                                      );

        # Pickup types
        $pickup_types = array (
            "select_name" => "PickupType",
            "selected_value" => $this->POST["PickupType"],
            "values" => array()
        );
        foreach(array("DRP","PCK","SCD") as $ptv)
            $pickup_types["values"][]=array (
                                        "value" => $ptv,
                                        "contents" => $this->MessageResources->getMessage("PT_$ptv")
                                      );

        $request = new Request();
        $request->setView('CheckoutShippingModuleSettings');
        $request->setAction("update_intershipper_settings");
        $form_action = $request->getURL();
        $settings = modApiFunc("Shipping_Module_InterShipper", "getSettings");
        $template_contents = array(
                                    "EditSMForm"    => $HtmlForm1->genForm($form_action, "POST", "EditSMForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"ModuleType"            => $this->MessageResources->getMessage('MODULE_TYPE')
                                   ,"ModuleName"            => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"Subtitle"              => $this->MessageResources->getMessage('FORM_SUBTITLE')
                                   ,"TopErrors"             => $this->outputTopErrors()
                                   ,"ModuleStatusFieldName" => $this->MessageResources->getMessage('MODULE_STATUS_FIELD_NAME')
                                   ,"ModuleStatusField"     => $this->outputStatus()
                                   ,"ModuleNameFieldName"   => $this->MessageResources->getMessage('MODULE_NAME_FIELD_NAME')
                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "ModuleName", "75", prepareHTMLDisplay($this->POST["ModuleName"]))
                                   ,"ModuleDescrFieldName"  => $this->MessageResources->getMessage('MODULE_DESCR_FIELD_NAME')
                                   ,"ModuleDescrFieldValue" => $this->MessageResources->getMessage('MODULE_DESCR')
                                   ,"CalculationHeader"     => $this->MessageResources->getMessage('LABEL_CALCULATION_HEADER')
                                   ,"Username_Name"         => $this->MessageResources->getMessage('LABEL_USERNAME')
                                   ,"Username_Field"        => $HtmlForm1->genInputTextField("128","Username","75",$this->POST["Username"])
                                   ,"Password_Name"         => $this->MessageResources->getMessage('LABEL_PASSWORD')
                                   ,"Password_Field"        => $HtmlForm1->genInputTextField("128","Password","75",$this->POST["Password"])
                                   ,"DelType_Name"          => $this->MessageResources->getMessage('LABEL_DELIVERY_TYPE')
                                   ,"DelType_Field"         => $HtmlForm1->genDropdownSingleChoice($delivery_types)
                                   ,"PickupType_Name"       => $this->MessageResources->getMessage('LABEL_PICKUP_TYPE')
                                   ,"PickupType_Field"      => $HtmlForm1->genDropdownSingleChoice($pickup_types)
                                   ,"PackageSizesHeader"    => $this->MessageResources->getMessage('PK_SIZES_HEADER')
                                   ,"PKH_Name"              => $this->MessageResources->getMessage('PK_HEIGHT')
                                   ,"PKH_Field"             => $HtmlForm1->genInputTextField("128","pk_height","75",$this->POST["PK_HEIGHT"])
                                   ,"PKW_Name"              => $this->MessageResources->getMessage('PK_WIDTH')
                                   ,"PKW_Field"             => $HtmlForm1->genInputTextField("128","pk_width","75",$this->POST["PK_WIDTH"])
                                   ,"PKL_Name"              => $this->MessageResources->getMessage('PK_LENGTH')
                                   ,"PKL_Field"             => $HtmlForm1->genInputTextField("128","pk_length","75",$this->POST["PK_LENGTH"])
                                   ,"MethodsHeader"         => $this->MessageResources->getMessage('METHODS_HEADER')
                                   ,"MethodsList"           => $this->outputShippingMethods()
                                   ,"LabelSMName"           => $this->MessageResources->getMessage('LABEL_SHIPPING_METHOD_NAME')
                                   ,"LabelSMDestination"    => $this->MessageResources->getMessage('LABEL_SHIPPING_METHOD_DESTINATION')
                                   ,"LabelSMAvailable"      => $this->MessageResources->getMessage('LABEL_SHIPPING_METHOD_AVAILABLE')
                                   ,"MethodsCount"          => count($this->shipping_methods)
                                   ,"Alert_001"             => $this->MessageResources->getMessage('ALERT_001')
                                   ,"Alert_002"             => $this->MessageResources->getMessage('ALERT_002')
                                   ,"Alert_003"             => $this->MessageResources->getMessage('ALERT_003')
                                   ,"Alert_004"             => $this->MessageResources->getMessage('ALERT_004')
                                   ,"Alert_005"             => $this->MessageResources->getMessage('ALERT_005')
                                   ,"Alert_006"             => $this->MessageResources->getMessage('ALERT_006')
                                   ,"Alert_007"             => $this->MessageResources->getMessage('ALERT_007')
                                   ,"HintLink_UN"           => $this->Hints->getHintLink(array('LABEL_USERNAME','shipping-module-intershipper-messages'))
                                   ,"HintLink_PSWD"         => $this->Hints->getHintLink(array('LABEL_PASSWORD','shipping-module-intershipper-messages'))
                                   ,"HintLink_PUT"          => $this->Hints->getHintLink(array('LABEL_PICKUP_TYPE','shipping-module-intershipper-messages'))
                                   ,"HintLink_DT"           => $this->Hints->getHintLink(array('LABEL_DELIVERY_TYPE','shipping-module-intershipper-messages'))
                                   ,"HintLink_PKH"          => $this->Hints->getHintLink(array('PK_HEIGHT','shipping-module-intershipper-messages'))
                                   ,"HintLink_PKW"          => $this->Hints->getHintLink(array('PK_WIDTH','shipping-module-intershipper-messages'))
                                   ,"HintLink_PKL"          => $this->Hints->getHintLink(array('PK_LENGTH','shipping-module-intershipper-messages'))
                                  );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("shipping_module_intershipper/", "list.tpl.html",array());

    }

    /**
     * @param $tag name of the requested tag
     * @return value of the tag
     */
    function getTag($tag)
    {
        global $application;
        $value = getKeyIgnoreCase($tag, $this->_Template_Contents);
        return $value;
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;
    var $ViewState;

    /**
     * List of error ids. It comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;

    var $shipping_methods;

    /**#@-*/
}
?>