<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * @package ShippingModuleUSPS
 * @access  public
 * @author Egor V. Derevyankin
 */
class update_usps_settings extends update_pm_sm
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Action constructor.
     */
    function update_usps_settings()
    {
    }

    /**
     * @param $SessionPost array of the posted params
     */
    function saveDataToDB($SessionPost)
    {
        modApiFunc("Checkout", "setModuleActive", (modApiFunc("Shipping_Module_USPS", "getUid")), ($SessionPost["status"]=="active")? true:false);

        $Settings = array(
                          "MODULE_NAME"     => $SessionPost["ModuleName"]
                         ,"RT_SERVER_NAME"  => $SessionPost["RTServerName"]
                         ,"RT_USER_NAME"  => $SessionPost["RTUserName"]
                         ,"RT_INT_MAILTYPE" => $SessionPost["USPS_Int_Mailtype"]
                         ,"RT_DOM_PACKSIZE" => $SessionPost["USPS_Dom_Packsize"]
                         ,"RT_DOM_MACHINABLE" => $SessionPost["USPS_Dom_Machinable"]
                         );
        modApiFunc("Shipping_Module_USPS", "updateSettings", $Settings);

        $Methods = array();

        if(isset($SessionPost["SMethodsAvailable"]) and is_array($SessionPost["SMethodsAvailable"]))
            $Methods=$SessionPost["SMethodsAvailable"];

        modApiFunc("Shipping_Module_USPS", "updateShippingMethods", $Methods);

    }

    /**
     * Action processor.
     */
    function onAction()
    {
        loadCoreFile('URI.class.php');

        global $application;
        $request = $application->getInstance('Request');

        if(modApiFunc('Session', 'is_Set', 'SessionPost'))
        {
            _fatal(array( "CODE" => "CORE_050"), __CLASS__, __FUNCTION__);
        }

        $SessionPost = $_POST;

        $SessionPost["ViewState"]["ErrorsArray"] = array();

        if($SessionPost["status"] == "active")
        {
            //         ,       CheckoutFormEditor'
            //         PersonInfo     : ShippingInfo.
            if(modApiFunc("Checkout", "arePersonInfoTypesActive", array("shippingInfo")) === true)
            {
            }
            else
            {
                $SessionPost["status"]= "inactive";
                $SessionPost["ViewState"]["ErrorsArray"][] = "MODULE_ERROR_NO_PERSON_INFO_TYPES";
            }
        }

        if($SessionPost["ModuleName"]=="")
            $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_001";

        $rtsu = new URI($SessionPost["RTServerName"]);
        $SessionPost["RTServerName"]=$rtsu->getPart("host");

        if($SessionPost["status"]=="active")
        {
            if(!isset($SessionPost["SMethodsAvailable"]) or empty($SessionPost["SMethodsAvailable"]))
            $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_002";

            if($SessionPost["RTServerName"]=="")
            $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_003";

            if($SessionPost["RTUserName"]=="")
            $SessionPost["ViewState"]["ErrorsArray"][]="ERROR_004";

        }


        if($SessionPost["ViewState"]["FormSubmitValue"]=="Save")
        {
            if(count($SessionPost["ViewState"]["ErrorsArray"])==0
                and count(modApiFunc("Shipping_Module_USPS","checkRequirments"))==0)
            {
                unset($SessionPost["ViewState"]["ErrorsArray"]);
                $this->saveDataToDB($SessionPost);
                $SessionPost["ViewState"]["hasCloseScript"] = "true";
            };
        };

        modApiFunc('Session', 'set', 'SessionPost', $SessionPost);
        // get view name by action name.
        $request = new Request();
        $request->setView(CURRENT_REQUEST_URL);
        $application->redirect($request);
    }
    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    /**
     * Corresponding View file.
     */
    var $ViewFilename;

    /**#@-*/
}
?>