<?php
/***********************************************************************
| Avactis (TM) Shopping Cart software developed by Pentasoft Corp.
| http://www.avactis.com
| -----------------------------------------------------------------------
| All source codes & content (c) Copyright 2004-2010, Pentasoft Corp.
| unless specifically noted otherwise.
| =============================================
| This source code is released under the Avactis License Agreement.
| The latest version of this license can be found here:
| http://www.avactis.com/license.php
|
| By using this software, you acknowledge having read this license agreement
| and agree to be bound thereby.
|
 ***********************************************************************/
?><?php

/**
 * usps_input_az view
 *
 * @package ShippingModuleUSPS
 * @author Egor V. Derevyankin
 */
class usps_input_az extends pm_sm_input_az
{
//------------------------------------------------
//               PUBLIC DECLARATION
//------------------------------------------------

    /**#@+
     * @access public
     */

    /**
     * Modules_Manager constructor.
     */
    function usps_input_az()
    {
        global $application;
        $this->MessageResources = &$application->getInstance('MessageResources',"shipping-module-usps-messages", "AdminZone");
        $this->Hints = &$application->getInstance('Hint');
        $this->shipping_methods=modApiFunc("Shipping_Module_USPS","getShippingMethods");

        $this->mTmplFiller = &$application->getInstance('TmplFiller');

        if(modApiFunc("Session", "is_Set", "SessionPost"))
        {
            $this->copyFormData();
            modApiFunc('Session', 'un_Set', 'SessionPost');
        }
        else
        {
            $this->initFormData();
        }

        $requirments=modApiFunc("Shipping_Module_USPS","checkRequirments");
        $reqsErrors=array("OCNTR"=>"ERROR_005","CURRENCY"=>"ERROR_006");
        for($i=0;$i<count($requirments);$i++)
            $this->ErrorsArray[]=$reqsErrors[$requirments[$i]];

        if(count($this->ErrorsArray)>0 and $this->POST["status"]==true)
        {
            $this->POST["status"]=false;
            $this->ViewState["hasCloseScript"]="false";
        };
    }

    /**
     * Copies data from the global POST to the local POST array.
     */
    function copyFormData()
    {
        // eliminate copying on construction
        $SessionPost = modApiFunc("Session", "get", "SessionPost");
        $this->ViewState = $SessionPost["ViewState"];
        //Remove some data, that should not be resent to action, from ViewState.
        if(isset($this->ViewState["ErrorsArray"]) &&
           count($this->ViewState["ErrorsArray"]) > 0)
        {
            $this->ErrorsArray = $this->ViewState["ErrorsArray"];
            unset($this->ViewState["ErrorsArray"]);
        }

        $this->POST =
            array(
                "ModuleName" => $SessionPost["ModuleName"]
               ,"status" => ($SessionPost["status"]=="active")? true:false
               ,"RTServerName" => $SessionPost["RTServerName"]
               ,"RTUserName" => $SessionPost["RTUserName"]
               ,"RTIntMailtype" => $SessionPost["USPS_Int_Mailtype"]
               ,"RTDomPacksize" => $SessionPost["USPS_Dom_Packsize"]
               ,"RTDomMachinable" => $SessionPost["USPS_Dom_Machinable"]
               ,"SMethodsAvailable" => array()
            );

        if(is_array($this->shipping_methods) and !empty($this->shipping_methods))
            foreach($this->shipping_methods as $key => $method)
                $this->POST["SMethodsAvailable"][$method['id']] =
                    (isset($SessionPost["SMethodsAvailable"][$method['id']])?"Y":"N");

    }

    /**
     * Fills the local POST array by data from the DB.
     */
    function initFormData()
    {
        $this->POST = array();
        $settings = modApiFunc("Shipping_Module_USPS", "getSettings");
        foreach ($settings as $key => $value)
        {
            switch($key)
            {
                case "MODULE_NAME":       $this->POST["ModuleName"]      = $value; break;
                case "RT_SERVER_NAME":    $this->POST["RTServerName"]    = $value; break;
                case "RT_USER_NAME":      $this->POST["RTUserName"]      = $value; break;
                case "RT_INT_MAILTYPE":   $this->POST["RTIntMailtype"]   = $value; break;
                case "RT_DOM_PACKSIZE":   $this->POST["RTDomPacksize"]   = $value; break;
                case "RT_DOM_MACHINABLE": $this->POST["RTDomMachinable"] = $value; break;
            }
        }
        $this->POST["status"] = modApiFunc("Shipping_Module_USPS", "isActive");
        $this->ViewState =
            array(
                "hasCloseScript"  => "false"
               ,"FormSubmitValue" => "save"
                 );

        $this->POST["SMethodsAvailable"]=array();
        if(is_array($this->shipping_methods) and !empty($this->shipping_methods))
            foreach($this->shipping_methods as $key => $method)
                $this->POST["SMethodsAvailable"][$method["id"]]=$method["available"];

    }


    /**
     * @return String Return html code for hidden form fields representing
     * @var $this->ViewState array.
     */
    function outputViewState()
    {
        $retval = "";
        foreach ($this->ViewState as $key => $value)
        {
            $retval .= "<input type=\"hidden\" name=\"ViewState[" .$key . "]\" value=\"" . $value . "\">";
        }
        return $retval;
    }

    /**
     * @return HTML code for the errors
     */
    function outputErrors()
    {
        global $application;

        $return_html_code="";

        foreach($this->ErrorsArray as $index => $value)
        {
            $this->_Template_Contents = array(
                                            "ErrorIndex"    => $index+1,
                                            "Error"         => $this->MessageResources->getMessage($value)
                                        );
            $application->registerAttributes($this->_Template_Contents);
            $return_html_code.=$this->mTmplFiller->fill("shipping_module_fedex/", "error.tpl.html", array());
        };

        return $return_html_code;
    }

    function outputTopErrors()
    {
        if (!is_array($this->ErrorsArray) || sizeof($this->ErrorsArray) == 0)
        {
            return;
        }

        global $application;

        $return_html_code="";

        $this->_Template_Contents = array(
                                            "Errors"    => $this->outputErrors()
                                        );
        $application->registerAttributes($this->_Template_Contents);
        $return_html_code.=$this->mTmplFiller->fill("shipping_module_fedex/", "errors.tpl.html", array());

        return $return_html_code;
    }

    /**
     * @return HTML code for the module status
     */
    function outputStatus()
    {

        global $application;
        $retval = "";
        $status = $this->POST["status"];
        $this->_Template_Contents = array(
                                          "Active"          => ($status)? "checked":""
                                         ,"ActiveMessage"   => $this->MessageResources->getMessage('MODULE_STATUS_ACTIVE')
                                         ,"Inactive"        => ($status)? "":"checked"
                                         ,"InactiveMessage" => $this->MessageResources->getMessage('MODULE_STATUS_INACTIVE')
                                         );
        $application->registerAttributes($this->_Template_Contents);
        $retval.= $this->mTmplFiller->fill("shipping_module_usps/", "status.tpl.html", array());
        return $retval;

    }

    /**
     * @return HTML code for the 'available' checkbox for the shipping method
     */
     function outputAvailableCheckBox($checkbox_id,$available)
    {
        $is_checked=($available=="Y"?"checked":"");
        $return_html_code = "<input type=\"checkbox\" id=\"MA-$checkbox_id\" name=\"SMethodsAvailable[$checkbox_id]\" $is_checked>";
        return $return_html_code;
    }

    /**
     * @return HTML code for the list of the shipping methods
     */
    function outputShippingMethods()
    {
        global $application;

        if(empty($this->shipping_methods) or !is_array($this->shipping_methods))
            return $this->MessageResources->getMessage('LABEL_NO_SHIPPING_METHODS');

        $return_html_code="";

        foreach($this->shipping_methods as $method_key => $method_info)
        {
            $dest=$method_info['destination']=="L"?$this->MessageResources->getMessage("LABEL_SM_DESTINATION_NATIONAL"):
                $this->MessageResources->getMessage("LABEL_SM_DESTINATION_INTERNATIONAL");

            $this->_Template_Contents=array (
                "CycleColor"                   => ( $method_key % 2 ? "EEEEEE":"FFFFFF"),
                "SMethodName"                  => $method_info['method_name'],
                "SMethodDestination"           => $dest,
                "SMethodAvailableCheckBox"     => $this->outputAvailableCheckBox($method_info['id'],$this->POST["SMethodsAvailable"][$method_info['id']])
            );
            $application->registerAttributes($this->_Template_Contents);
            $return_html_code.=$this->mTmplFiller->fill("shipping_module_usps/","methods_list_item.tpl.html",array());
        }

        return $return_html_code;
    }

    /**
     * @return HTML code for this view
     */
    function output()
    {
        global $application;
        loadCoreFile('html_form.php');
        $HtmlForm1 = new HtmlForm();
        if($this->ViewState["hasCloseScript"] == "true")
        {
            modApiFunc("application", "closeChild_UpdateParent");
            return;
        }

        # Options data

        # Mail type
        $rt_int_mailtypes = array(
                "select_name" => "USPS_Int_Mailtype",
                "selected_value" => $this->POST["RTIntMailtype"],
                "values" => array(
                        array(
                            "value" => "Package",
                            "contents" => $this->MessageResources->getMessage('RT_INT_MAILTYPE_PCK'),
                        ),
                        array(
                            "value" => "Postcards or Aerogrammes",
                            "contents" => $this->MessageResources->getMessage('RT_INT_MAILTYPE_POA'),
                        ),
                        array(
                            "value" => "Matter for the Blind",
                            "contents" => $this->MessageResources->getMessage('RT_INT_MAILTYPE_MFB'),
                        ),
                        array(
                            "value" => "Envelope",
                            "contents" => $this->MessageResources->getMessage('RT_INT_MAILTYPE_ENV'),
                        ),
                    ),
            );

        # Packsize
        $rt_dom_packsizes = array(
                "select_name" => "USPS_Dom_Packsize",
                "selected_value" => $this->POST["RTDomPacksize"],
                "values" => array(
                        array(
                            "value" => "Regular",
                            "contents" => $this->MessageResources->getMessage('RT_DOM_PACKSIZE_RG'),
                        ),
                        array(
                            "value" => "Large",
                            "contents" => $this->MessageResources->getMessage('RT_DOM_PACKSIZE_LR'),
                        ),
                        array(
                            "value" => "Oversize",
                            "contents" => $this->MessageResources->getMessage('RT_DOM_PACKSIZE_OS'),
                        ),
                    ),
            );

        # Machinable
        $rt_dom_machinables = array(
                "select_name" => "USPS_Dom_Machinable",
                "selected_value" => $this->POST["RTDomMachinable"],
                "values" => array(
                        array(
                            "value" => "true",
                            "contents" => $this->MessageResources->getMessage('RT_DOM_MACHINABLE_YES'),
                        ),
                        array(
                            "value" => "false",
                            "contents" => $this->MessageResources->getMessage('RT_DOM_MACHINABLE_NO'),
                        ),
                    ),
        );

        $request = new Request();
        $request->setView('CheckoutShippingModuleSettings');
        $request->setAction("update_usps_settings");
        $form_action = $request->getURL();
        $settings = modApiFunc("Shipping_Module_USPS", "getSettings");
        $template_contents = array(
                                    "EditSMForm"    => $HtmlForm1->genForm($form_action, "POST", "EditSMForm")
                                   ,"HiddenArrayViewState"  => $this->outputViewState()
                                   ,"ModuleType"            => $this->MessageResources->getMessage('MODULE_TYPE')
                                   ,"ModuleName"            => $this->MessageResources->getMessage('MODULE_NAME')
                                   ,"Subtitle"              => $this->MessageResources->getMessage('FORM_SUBTITLE')
                                   ,"TopErrors"             => $this->outputTopErrors()
                                   ,"ModuleStatusFieldName" => $this->MessageResources->getMessage('MODULE_STATUS_FIELD_NAME')
                                   ,"ModuleStatusField"     => $this->outputStatus()
                                   ,"ModuleNameFieldName"   => $this->MessageResources->getMessage('MODULE_NAME_FIELD_NAME')
                                   ,"ModuleNameField"       => $HtmlForm1->genInputTextField("128", "ModuleName", "75", prepareHTMLDisplay($this->POST["ModuleName"]))
                                   ,"ModuleDescrFieldName"  => $this->MessageResources->getMessage('MODULE_DESCR_FIELD_NAME')
                                   ,"ModuleDescrFieldValue" => $this->MessageResources->getMessage('MODULE_DESCR')
                                   ,"RTConfigHeader"        => $this->MessageResources->getMessage('RT_CONFIG_HEADER')
                                   ,"RTServerNameFieldName" => $this->MessageResources->getMessage('RT_SERVER_NAME_FIELD_NAME')
                                   ,"RTServerNameField"     => $HtmlForm1->genInputTextField("128","RTServerName","75", prepareHTMLDisplay($this->POST["RTServerName"]))
                                   ,"RTUserNameFieldName"   => $this->MessageResources->getMessage('RT_USER_NAME_FIELD_NAME')
                                   ,"RTUserNameField"       => $HtmlForm1->genInputTextField("128","RTUserName","75", prepareHTMLDisplay($this->POST["RTUserName"]))
                                   ,"RTIntHeader"           => $this->MessageResources->getMessage('RT_INTERNATIONAL_HEADER')
                                   ,"RTIntMailTypeFieldName" => $this->MessageResources->getMessage('RT_INT_MAILTYPE_FIELD_NAME')
                                   ,"RTIntMailTypeFieldValue" => $HtmlForm1->genDropdownSingleChoice($rt_int_mailtypes)
                                   ,"RTDomHeader"           => $this->MessageResources->getMessage('RT_DOMESTIC_HEADER')
                                   ,"RTDomPacksizeFieldName" => $this->MessageResources->getMessage('RT_DOM_PACKSIZE_FIELD_NAME')
                                   ,"RTDomPacksizeFieldValue" => $HtmlForm1->genDropdownSingleChoice($rt_dom_packsizes)
                                   ,"RTDomMachinableFieldName" => $this->MessageResources->getMessage('RT_DOM_MACHINABLE_FIELD_NAME')
                                   ,"RTDomMachinableFieldValue" => $HtmlForm1->genDropdownSingleChoice($rt_dom_machinables)
                                   ,"MethodsHeader"         => $this->MessageResources->getMessage('METHODS_HEADER')
                                   ,"MethodsList"           => $this->outputShippingMethods()
                                   ,"LabelSMName"           => $this->MessageResources->getMessage('LABEL_SHIPPING_METHOD_NAME')
                                   ,"LabelSMDestination"    => $this->MessageResources->getMessage('LABEL_SHIPPING_METHOD_DESTINATION')
                                   ,"LabelSMAvailable"      => $this->MessageResources->getMessage('LABEL_SHIPPING_METHOD_AVAILABLE')
                                   ,"MethodsCount"          => count($this->shipping_methods)
                                   ,"Alert_001"             => $this->MessageResources->getMessage('ALERT_001')
                                   ,"Alert_002"             => $this->MessageResources->getMessage('ALERT_002')
                                   ,"Alert_003"             => $this->MessageResources->getMessage('ALERT_003')
                                   ,"Alert_004"             => $this->MessageResources->getMessage('ALERT_004')
                                   ,"HintLink_RTSN"         => $this->Hints->getHintLink(array('RT_SERVER_NAME_FIELD_NAME','shipping-module-usps-messages'))
                                   ,"HintLink_RTUN"         => $this->Hints->getHintLink(array('RT_USER_NAME_FIELD_NAME','shipping-module-usps-messages'))
                                   ,"HintLink_RTMT"         => $this->Hints->getHintLink(array('RT_INT_MAILTYPE_FIELD_NAME','shipping-module-usps-messages'))
                                   ,"HintLink_RTPS"         => $this->Hints->getHintLink(array('RT_DOM_PACKSIZE_FIELD_NAME','shipping-module-usps-messages'))
                                   ,"HintLink_RTMA"         => $this->Hints->getHintLink(array('RT_DOM_MACHINABLE_FIELD_NAME','shipping-module-usps-messages'))
                                  );

        $this->_Template_Contents = $template_contents;
        $application->registerAttributes($this->_Template_Contents);
        return $this->mTmplFiller->fill("shipping_module_usps/", "list.tpl.html",array());

    }

    /**
     * @param $tag name of the requested tag
     * @return value of the tag
     */
    function getTag($tag)
    {
        return getKeyIgnoreCase($tag, $this->_Template_Contents);
    }

    /**#@-*/

//------------------------------------------------
//              PRIVATE DECLARATION
//------------------------------------------------

    /**#@+
     * @access private
     */

    var $POST;

    /**
     * View state structure. It comes from action.
     * $SessionPost["ViewState"] structure example:
     * <br>array
     * <br>(
     * <br>    "hasCloseScript"  = "false"           //true/false
     * <br>    "ErrorsArray"     =  array()          //true/false
     * <br>)
     */
    var $ViewState;

    /**
     * List of error ids. It comes from action.
     */
    var $ErrorsArray;
    var $ErrorMessages;

    var $_Template_Contents;

    var $MessageResources;
    var $_error_index;
    var $_error;

    var $shipping_methods;

    /**#@-*/
}
?>